/**
 * Objeto de busqueda
 */
var busqueda = function(){
	zIndex = 1000;
	/**
	 * Realiza una busqueda en el servidor a travs de ajax
	 */
	buscar= function(jq,cadena,idFiltroBase,idCategoria,idTipoFiltro,idFiltro,nivel,idProductoSel,idOfertaSel,funcionDespues){
		nbf.ejecutar(
			"\\appv1\\app::ajaxResultadosBusqueda1",
			[cadena,idFiltroBase,idCategoria,idTipoFiltro,idFiltro,nivel,idProductoSel],
			function (respuesta){
				if(respuesta.status=='ok'){
					ui.almacenarSesion(st.obtenerLocalVar("idUsuario"),respuesta.firma,respuesta.sessId);
					var busquedaActual ='<div class="">Busqueda actual :><div class="busquedaActual">'+cadena+'</div></div>';
					var breadCrumbsTexto = "<div class='irA'><a class='inicio'  href='#'>"+cadena+"</a></div>";
					$(".contenidoPagina").html(respuesta.html);
					var jqProductoSel=null;
					if(idOfertaSel>0){
						var jqOfertaSel = $(".contenidoPagina ."+nbf.codificarDatoClass(idOfertaSel));
						jqProductoSel =jqOfertaSel.closest(".producto");
					}
					if(idProductoSel>0){
						jqProductoSel = $(".contenidoPagina ."+nbf.codificarDatoClass(idProductoSel));
					}
					if(jqProductoSel){
						if(jqProductoSel.size()>0){
							var url = jqProductoSel.find(".urlFicha").text();
							jqProductoSel.addClass("on");
							jqProductoSel.find(".urlFicha").html(jqProductoSel.find(".imgProd").attr("src"));
							jqProductoSel.find(".imgProd").attr("src",url);
						}
					}
					$(".contenidoPagina").removeClass("cargando");
					ui.catalogo.cargarBuscarEventos(jq);
					breadCrumbs.pintarBreadCrumb("breadCrumbPrincipal");
					if(typeof(funcionDespues)=="function")
						funcionDespues();
				}
				else
					alert(respuesta.mensajes);
			}
		);
	}
	
	/**
	 * Funcion que carga la pagina correspondiente de mostrar todos los productos con la palabra codificada en el class
	 */
	cargarMostrarTodos = function(palabra){
		$("#content").attr("class","contentPrincipal "+nbf.codificarDatoClass(palabra)+" todos");
		contenido.cargarPanelCentral(
			function(){
				var comienzo = new Date().getTime();
				ui.popup.iniciarPopupEspera(comienzo);
			},
			function(){
				ui.popup.cerrarPopupEspera();
			}
		);
	}
	
return {"buscar":buscar};
}();

ui = ui || {};
ui.catalogo = ui.catalogo || {};

/**
 * Funcion que muestra todos los productos y devuelve el html correspondiente para pintar
 */
ui.catalogo.cargarMostrarTodosListado = function(jq,palabra,funcionDespues){
	nbf.ejecutar(
		"\\appv1\\app::ajaxObtenerResultados",
		[palabra,null,null,null,null,1,true],
		function(respuesta){
			if(respuesta.status=="ok"){
				jq.html(respuesta.html);
//				//$(".productos li").css("display","none");
//				if(jq.find(".productos").hasClass("paginacion")==false){
//					jq.find(".productos").addClass("paginacion");
//					jq.find(".productos").addClass("pagina-1");
//				}
//				var pagina=2;
//				var elementosPagina=5;
//				
//				if(pagina>0){
//					if(pagina!=1)
//						$('<div style="margin-top:5px;margin-bottom:5px;text-align:center;height:40px;width:100%;background:#ccc;" class="pagina'+pagina+' paginaMenos">Cargar resultados anteriores...(ir a pagina '+(pagina-1)+')</div>').insertBefore(".productos");
//					
//					jq.find(".productos li:gt("+pagina*elementosPagina+")").css("display","none");
//					$('<div style="margin-top:5px;margin-bottom:5px;text-align:center;height:40px;width:100%;background:#ccc;" class="pagina'+pagina+' paginaMenos">Cargar siguientes resultados...</div>').insertAfter(".productos");
//				}
				ui.catalogo.cargarBuscarEventos(jq);
				if(typeof(funcionDespues)=="function")
					funcionDespues();
			}else
				ui.popup.crearAlertaError(respuesta.mensajes,null,"Error");
		}
	);
}

ui.catalogo.cargarBuscando =function(jq,busquedaValor,filtro1,categoria,valor1,valor2,nivel,funcionDespues){
	contenido.cambiarClass($(".contentPrincipal"),"buscar");
	if(funcionDespues)
		funcionDespues();
	nbf.initContenido();

}

ui.catalogo.cargarBuscar =function(jq,busquedaValor,filtro1,categoria,valor1,valor2,nivel,idProductoSel,idOfertaSel,funcionDespues){
	ui.catalogo.cargarContenidoBuscar(jq,busquedaValor,filtro1,categoria,valor1,valor2,nivel,idProductoSel,idOfertaSel,funcionDespues);
	ui.catalogo.cargarBuscarEventos(jq);
}

ui.catalogo.cargarContenidoBuscar = function(jq,busquedaValor,filtro1,categoria,valor1,valor2,nivel,idProductoSel,idOfertaSel,funcionDespues){
	buscar(jq,busquedaValor,filtro1,categoria,valor1,valor2,nivel,idProductoSel,idOfertaSel,funcionDespues);
}

ui.catalogo.cargarBuscarEventos =function(jq){
	//click en una subcategoria o categoria
	jq.find(".resCat ul li a").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			var classPrincipal = $(".contentPrincipal").attr("class").split(" ");
			var nivel =nbf.decodificarDatoClass(classPrincipal[1]);
			var palabraBuscar = nbf.decodificarDatoClass(classPrincipal[2]);
			if($(this).closest("li").hasClass("todos")){
				//mostrar todos los productos de la categoria
				cargarMostrarTodos(palabraBuscar);
			}
			else{
			
				if($(this).closest("li").hasClass("sel")==false){
					if(nivel=="0")
						nivel=1;
					else
						nivel=parseInt(nivel)+1;
				}
				var idCat= nbf.decodificarDatoClass(classPrincipal[3]);
				var nuevaCat = nbf.extraerDatos($(this));
				classContent="contentPrincipal";
				classContent +=" "+nbf.codificarDatoClass(nivel);
				classContent +=" "+classPrincipal[2];
				classContent +=" "+nbf.codificarDatoClass(nuevaCat);
				if(classPrincipal[4]!="buscar")
					classContent +=" "+classPrincipal[4];
				if(classPrincipal[4]!="buscar")
					classContent +=" "+classPrincipal[5];
				classContent +=" buscar";
				$("#content").attr("class",classContent);
				var textCat =$(this).html();
				textCat = textCat.split("<span>");
				var elemJSON = [nivel,palabraBuscar,nuevaCat,textCat[0],classPrincipal[4],classPrincipal[5]];
				breadCrumbs.anadirElemento("breadCrumbPrincipal","buscar",nbf.toJSON(elemJSON));
				contenido.cargarPanelCentral(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}
				);
			}
		}
	);
	jq.find(".btnSiguienteLinea").click(
		function(ev){
			ev.preventDefault();
			var cont = $(this).closest(".btnEliminarLinea").html();
			var resultado = cont.match(/(["]).*\1/)[0];
			var elemento = resultado.substr(1,resultado.length-2);
		}
	);
	
	//Boton de volver al supermercado
	jq.find(".btnVolver").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			contenido.cambiarClass($(".contentPrincipal"),"categoriasListaCargando");
			contenido.cargarPanelCentral();
		}
	);
	
	jq.find(".filtroListado a").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			var idFiltro = nbf.extraerDatos($(this));
			var tipoFiltro = nbf.extraerDatos($(this).closest("ul"));
			var classPrincipal = $(".contentPrincipal").attr("class").split(" ");
			var nivel=2;
			if($(".contentPrincipal").hasClass("todos")==false)
				nivel =nbf.decodificarDatoClass(classPrincipal[1]);
			
			if($(this).closest("li").hasClass("sel")==false){
				if(nivel=="0")
					nivel=1;
				else
					nivel=parseInt(nivel)+1;
			}
			var palabraBuscar = "";
			var idCat="";
			if($(".contentPrincipal").hasClass("todos")==false){
				palabraBuscar = nbf.decodificarDatoClass(classPrincipal[2]);
				idCat = nbf.decodificarDatoClass(classPrincipal[3]);
			}
			else{
				palabraBuscar = nbf.decodificarDatoClass(classPrincipal[1]);
			}
			
			classContent="contentPrincipal";
			classContent +=" "+nbf.codificarDatoClass(nivel);
			classContent +=" "+nbf.codificarDatoClass(palabraBuscar);
			classContent +=" "+nbf.codificarDatoClass(idCat);
			classContent +=" "+nbf.codificarDatoClass(idFiltro);
			classContent +=" "+nbf.codificarDatoClass(tipoFiltro);
			classContent +=" buscar";
			$("#content").attr("class",classContent);
			
			var filtroTexto = $(this).find("span").html();
			filtroTexto = filtroTexto.split("<em>");
			var elemJSON = [nivel,palabraBuscar,idCat,filtroTexto[0],idFiltro,tipoFiltro];
			breadCrumbs.anadirElemento("breadCrumbPrincipal","buscar",nbf.toJSON(elemJSON));
			contenido.cargarPanelCentral(
				function(){
					var comienzo = new Date().getTime();
					ui.popup.iniciarPopupEspera(comienzo);
				},
				function(){
					ui.popup.cerrarPopupEspera();
				}
			);
		}
	);
	jq.find(".btnSecundario").click(
		function(ev){
			ev.preventDefault();
			var valorBuscar = $(this).find("p").text()
			$(".cuadroBuscar input[name=inputBusqueda]").val(valorBuscar);
			cabecera.lanzarBusqueda($(".headerFixed"));
		}
	);
	jq.find(".resSRAlt ul li a").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				var valorBuscar = $(this).find(".alt").text()
				$(".cuadroBuscar input[name=inputBusqueda]").val(valorBuscar);
				cabecera.lanzarBusqueda($(".headerFixed"));
			}
		);

	/**
	 * Boton para ir a la seccion de Mis superofertas reservadas
	 */
//	jq.find(".btnVerOfertasFlash").click(
//		function(ev){
//			ev.preventDefault();
//			ui.vibracionCorta();
//			contenido.cambiarClass($(".bloqueDerecho"),"cargarMisSuperOfertas");
//			contenido.cargarBloqueDerecho();
//			nbf.initPrivada();
//			swiper.moverSwiper(2);
//		}
//	);
	
	/**
	 * Boton para aadir productos a la cesta
	 */
	jq.find(".producto .btnMas").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var sinUnidades=false;
			if($(this).closest(".visible").hasClass("sinUnidades")){
				contenido.cambiarClass($(this).closest(".datosCarro").find(".sinUnidades"),"sinUnicades noActivo","visible");
				$(this).closest(".datosCarro").find(".sinUnidades").removeClass("visible");
				$(this).closest(".datosCarro").find(".sinUnidades").addClass("noActivo");
				$(this).closest(".datosCarro").find(".conUnidades").addClass("visible");
				$(this).closest(".datosCarro").find(".conUnidades").removeClass("noActivo");			
				$(this).closest(".producto").addClass("itemEnCarro");
				
				sinUnidades=true;
			}
			var item = $(this).closest(".producto");
			if(sinUnidades==false)
				carro.anadirUnidadCarro(item,null);
			else
				carro.anadirUnidadCarro(item,
				function(){
					if(jq.find(".producto").size()<=20){
						contenido.cargarPanelCentral();
					}
				},
				true
			);
		}
	);
	
	/**
	 * Boton quitar una unidad de articulos de la cesta
	 */
	jq.find(".producto .btnMenos").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var item = $(this).closest(".producto");
			carro.quitarUnidadCarro(
				item,
				false,
				function(){
					if($(".productos").size()<=20)
						contenido.cargarPanelCentral();
				}
			);
		}
	);
	
	/**
	 * Boton de eliminar el producto de la cesta
	 */
	jq.find(".producto .btnEliminar").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var item = $(this).closest(".producto");
			if(item.hasClass("itemOfertaFlash")) {
				ui.popup.crearConfirmar(
					"Ests seguro que quieres eliminar el producto del carro?",
					function(){
						carro.eliminarProductoCarro(item,false);
						contenido.cargarPanelCentral();
//						contenido.cargarBloqueIzquierdo();
					},
					null,
					false,
					"Eliminar del carro"
				);
			}
			else {
				carro.eliminarProductoCarro(item,false);
//				contenido.cargarPanelCentral();
//				contenido.cargarBloqueIzquierdo();
			}
		}
	);
	
	/**
	 * Boton para reservar las super-ofertas
	 */
	jq.find(".producto .btnReservar").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var jqOfer = $(this).closest(".itemOfertaFlash");
			if(jqOfer.hasClass("agotada")==false){
				so.reservarOfertaFlash(nbf.extraerDatos(jqOfer),$(this),jqOfer,null,null,null,
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}	
				);
				ui.actualizarCarro();
			}
		}
	);
	
	/**
	 * Boton para reservar una unidad mas de super-ofertas
	 */
	jq.find(".producto .btnReservarMas").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var jqOfer = $(this).closest(".itemOfertaFlash");
			if(jqOfer.hasClass("agotada")==false){
				so.reservarOfertaFlash(nbf.extraerDatos(jqOfer),$(this),jqOfer,null,1,null,
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}	
				);
				ui.actualizarCarro();
			}
		}
	);
	/**
	 * Boton para reservar las super-ofertas
	 */
	jq.find(".producto .btnReservarMenos").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var jqOfer = $(this).closest(".itemOfertaFlash");
			if(jqOfer.hasClass("agotada")==false){
				so.reservarOfertaFlash(nbf.extraerDatos(jqOfer),$(this),jqOfer,null,-1,null,
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}	
				);
				ui.actualizarCarro();
			}
		}
	);
	
	jq.find(".producto .btnSi").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var idOferta= nbf.extraerDatos($(this).closest(".producto").find(".idOfer"));
			if(idOferta){
				nbf.ejecutar(
					"\\appv1\\app::ajaxReservarOfertaFlashSiguientePedido",
					[idOferta],
					function(respuesta){
						if(respuesta.status=="ok"){
							ui.popup.crearAlerta("Oferta reservada para el prximo pedido",null,"popup2",false,"Oferta reservada");
						}else
							ui.popup.crearAlertaError(respuesta.mensajes,null,"Error");
					}
				);
			}
		}
	);
	jq.find(".producto .btnNo").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				$(this).closest(".reservaSiguiente").addClass("noActivo");
			}
		);
	
	jq.find(".producto a.des").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var noMarcar=false;
			var producto =$(this).closest(".producto");
			if(producto.hasClass("on")){
				producto.removeClass("on");
				noMarcar=true;
			}
			
			var productos = jq.find(".producto");
			if(noMarcar==false){
				productos.each(
					function(){
						if($(this).hasClass("on")){
							var url = $(this).find(".urlFicha").text();
							$(this).find(".urlFicha").html($(this).find(".imgProd").attr("src"));
							$(this).find(".imgProd").attr("src",url);
						}
						$(this).removeClass("on");
					}
				);
			}

			if(producto.size()>0 && noMarcar==false){
				producto.addClass("on");
			}
			
			var url = producto.find(".urlFicha").text();
			producto.find(".urlFicha").html(producto.find(".imgProd").attr("src"));
			producto.find(".imgProd").attr("src",url);
		}
	
	);
	
}