/**
 * cargar la informacion del blque derecho de mi cuenta
 */
cargarBloqueIzquierdo = function(jq,funcionDespues){
	if(st.obtenerLocalVar("modoTrabajo")=="online"){
		nbf.ejecutar(
			"\\appv1\\app::ajaxCargarCarroCompra",
			[],
			function (respuesta){
				if(respuesta.status=='ok'){
					//repinta la cesta del panel izquierdo con el html que devuelve la llamada ajax
				   carro.pintarCesta(respuesta);
				   if(funcionDespues)
					   funcionDespues();
				}
			}
		);
	}
	else{
		$("bloqueIzquierdo").attr("class","bloqueIzquierdo");
		$(".bloqueIzquierdo").html("<div class='sinConexion'>Necesita conexin de internet para poder ver esta seccin!</div>");
	}
}

/**
 * Eventos de la cesta de la compra
 */
cargarCestaEventos = function (jq){
	//Si aumentamos las unidades de la cesta y ese producto lo estamos viendo en la busqueda de productos automaticamente se
	//actualiza la cantidad en el panel central
	jq.find(".btnMas").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				var item = $(this).closest(".producto");
				carro.anadirUnidadCarro(
					item,
					function(){
						var classProducto =nbf.codificarDatoClass(nbf.extraerDatos(item));
						if($(".contentPrincipal ."+classProducto).size()>0)
							contenido.cargarPanelCentral();
					}
				);
			}
		}
	);
	jq.find(".btnMenos").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				var item = $(this).closest(".producto");
				
				carro.quitarUnidadCarro(
					item,
					true,
					function(){
						var classProducto =nbf.codificarDatoClass(nbf.extraerDatos(item));
						if($(".contentPrincipal ."+classProducto).size()>0)
							contenido.cargarPanelCentral();
					}
				);
			}
		}
	);
	jq.find(".btnReservarMas").click(
		function(ev){
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				var item = $(this).closest(".producto");
				so.reservarOfertaFlash(nbf.extraerDatos(item.find(".itemOfertaFlash")),$(this),item,null,1,true);
				ui.actualizarCarro();
			}
		}
	);
	jq.find(".btnReservarMenos").click(
		function(ev){
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				var item = $(this).closest(".producto");
				so.reservarOfertaFlash(nbf.extraerDatos(item.find(".itemOfertaFlash")),$(this),item,null,-1,true);
				ui.actualizarCarro();
			}
		}
	);
	
	jq.find(".btnEliminar").click(
		function(ev){
			ev.preventDefault();
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				var item = $(this).closest(".producto");
				if(item.hasClass("itemOfertaFlash")){
					ui.popup.crearConfirmar(
						"Ests seguro que quieres eliminar el producto del carro?",
						function(){
							carro.eliminarProductoCarro(item,true);
						},
						null,
						false,
						"Quitar del carro"
					);
					
				}else{
					carro.eliminarProductoCarro(item,true);
				}
			}
		}
	);
	
	jq.find(".uds").click(
		function(ev){
			ev.preventDefault();
			var producto =$(this).closest(".producto");
			toggleProducto(producto);
		}
	);
	//lo dejamos con el click porque el comportamiento con las demas opciones no vale
	jq.find(".productos .des").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			var producto =$(this).closest(".producto");
			toggleProducto(producto);
		}
	);
//	
	jq.find(".completarLista").click(
		function(ev){
			ev.preventDefault();
			contenido.cambiarClass($(".bloqueDerecho"),"miListaCompra");
			contenido.cargarBloqueDerecho();
			swiper.moverSwiper(2);
		}
	);
}

/**
 * funcion para visualizar los controles de mas y menos y quitar del carro
 */
toggleProducto = function(producto){
	var productos =$(this).closest(".listaProductosCesta");
	productos.each(
		function(){
			$(this).find(".cantidadI").removeClass("on");
		}
	);
	if(producto.find(".cantidadI").hasClass("on"))
		producto.find(".cantidadI").removeClass("on");
	else
		producto.find(".cantidadI").addClass("on");
}

