/**
 * Carga de contenidos HTML
 */

cargandoSuperOfertas=function(jq){
	var html ="Buscando Superofertas...";
	jq.html(html);
	jq.addClass("cargando");
	contenido.cambiarClass($(".contentPrincipal"),"superOfertas");
	contenido.cargarPanelCentral();
}

cargarSuperOfertas = function(jq,panel,ofertaSeleccionada,funcionDespues){
	if(panel==null)
		panel=1;
	nbf.ejecutar(
		"\\appv1\\app::ajaxObtenerSuperOfertas",
		[panel],
		function (respuesta){
			if(respuesta.status=="ok"){
				$(".contenidoPagina").html(respuesta.html);
				$(".contenidoPagina").removeClass("cargando");
				if(ofertaSeleccionada!="null"){
					var productoOfer=$(".contenidoPagina").find(".idOfer."+nbf.codificarDatoClass(ofertaSeleccionada));
					if(productoOfer){
						var jqProd =productoOfer.closest(".producto");
						jqProd.addClass("on");
						var url = jqProd.find(".urlFicha").text();
						jqProd.find(".urlFicha").html(jqProd.find(".imgProd").attr("src"));
						jqProd.find(".imgProd").attr("src",url);
					}
				}
				cargarEventosSuperOfertas(jq);
				
				
				if(typeof(funcionDespues)=="function")
					funcionDespues();
			}
		}
	);
}

cargarOfertas = function(jq,funcionDespues){
	var html='<div class="botonesMenuOfertas">';
	html +=ui.botonHtml("secOfDia","Ofertas del da",null,true);
	html +=ui.botonHtml("secSO","Super-ofertas",null,true);
	html +=ui.botonHtml("secOFres","Ofertas en frescos",null,true);
	html +='</div>';
	jq.html(html);
	$(".contenidoPagina").removeClass("cargando");
	breadCrumbs.initBreadCrumb("breadCrumbPrincipal");
	breadCrumbs.anadirElemento("breadCrumbPrincipal","ofertas","Ofertas","Ofertas disponibles");
	breadCrumbs.pintarBreadCrumb("breadCrumbPrincipal");
	cargarOfertasEventos(jq);
	if(typeof(funcionDespues)=="function")
		funcionDespues();
}

cargarOfertasEventos = function(jq){
	jq.find(".secOfDia").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			var valorBuscar= "ofertas del dia";
			$(".cuadroBuscar input[name=inputBusqueda]").val(valorBuscar);
			cabecera.lanzarBusqueda($(".headerFixed"));
		}	
		
	);
	jq.find(".secSO").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			contenido.cambiarClass($(".contentPrincipal"),"superOfertas");
			breadCrumbs.anadirElemento("breadCrumbPrincipal","superOfertas","Super Ofertas","Super Ofertas disponibles");
			breadCrumbs.pintarBreadCrumb("breadCrumbPrincipal");
			contenido.cargarPanelCentral(
				function(){
					var comienzo = new Date().getTime();
					ui.popup.iniciarPopupEspera(comienzo);
				},
				function(){
					ui.popup.cerrarPopupEspera();
				}
			);
			
		}	
		
	);
	jq.find(".secOFres").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			var valorBuscar= "oferta frescos";
			$(".cuadroBuscar input[name=inputBusqueda]").val(valorBuscar);
			cabecera.lanzarBusqueda($(".headerFixed"));
		}	
	);
}

cargarEventosSuperOfertas=function(jq){
	
	jq.find(".producto a.des").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var noMarcar=false;
			var producto =$(this).closest(".producto");
			if(producto.hasClass("on")){
				producto.removeClass("on");
				noMarcar=true;
			}
			var productos = jq.find(".producto");
			if(noMarcar==false){
				productos.each(
					function(){
						if($(this).hasClass("on")){
							var url = $(this).find(".urlFicha").text();
							$(this).find(".urlFicha").html($(this).find(".imgProd").attr("src"));
							$(this).find(".imgProd").attr("src",url);
						}
						$(this).removeClass("on");
					}
				);
			}

			if(producto.size()>0 && noMarcar==false){
				producto.addClass("on");
			}
			
			var url = producto.find(".urlFicha").text();
			producto.find(".urlFicha").html(producto.find(".imgProd").attr("src"));
			producto.find(".imgProd").attr("src",url);
		}
	);
	
	
	jq.find(".itemOferFlaMini .btnReservar").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var jqOfer =$(this).closest(".itemOferFlaMini"); 
			if(jqOfer.hasClass("agotada")==false){
				so.reservarOfertaFlash(nbf.extraerDatos(jqOfer),$(this),jqOfer,null,null,null,
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}
				);
				ui.actualizarCarro();
			}
		}
	);
	jq.find(".itemOferFlaMini .btnReservarMenos").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var jqOfer =$(this).closest(".itemOferFlaMini");
			so.reservarOfertaFlash(nbf.extraerDatos(jqOfer),$(this),jqOfer,null,-1,null,
				function(){
					var comienzo = new Date().getTime();
					ui.popup.iniciarPopupEspera(comienzo);
				},
				function(){
					ui.popup.cerrarPopupEspera();
				}	
			);
			ui.actualizarCarro();
		}
	);
	jq.find(".itemOferFlaMini .btnReservarMas").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var jqOfer =$(this).closest(".itemOferFlaMini"); 
			so.reservarOfertaFlash(nbf.extraerDatos(jqOfer),$(this),jqOfer,null,1,null,
				function(){
					var comienzo = new Date().getTime();
					ui.popup.iniciarPopupEspera(comienzo);
				},
				function(){
					ui.popup.cerrarPopupEspera();
				}	
			);
			ui.actualizarCarro();
		}
	);
	jq.find(".itemOferFlaMini .btnEliminar").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			//eliminamos del carro la superoferta
			var item = $(this).closest(".producto");
			ui.popup.crearConfirmar(
				"Ests seguro que quieres eliminar el producto del carro?",
				function(){
					carro.eliminarProductoCarro(item,false);
					contenido.cargarPanelCentral();
//					ui.actualizarCarro();
				},
				null,
				false,
				"Eliminar del carro"
			);
		}
	);
	jq.find(".lnkT45").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var panel = $(this).closest("li").attr("class");
			$(".contentPrincipal").attr("class","contentPrincipal "+panel+" superOfertas ");
			contenido.cargarPanelCentral();
			breadCrumbs.anadirElemento("breadCrumbPrincipal","lnkPanel"+panel+ " superOfertas","Super Ofertas",$(this).text());
			breadCrumbs.pintarBreadCrumb("breadCrumbPrincipal");
		}
	);
}