
cargarRecetasCategorias = function(jq,funcionDespues){
	nbf.ejecutar(
		"\\appv1\\app::ajaxObtenerRecetasCategorias",
		[],
		function (respuesta){
			if(respuesta.status=="ok"){
				jq.html(respuesta.html);
				breadCrumbs.initBreadCrumb("breadCrumbDerecho");
				breadCrumbs.anadirElemento("breadCrumbDerecho","recetas recetasCategorias","Categoras","Categora de recetas");
				breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
				cargarEventosRecetas(jq);
				if(typeof(funcionDespues)=="function")
					funcionDespues();
				$(".caracteristica").css("margin-top",(0-$(".caracteristica").height()-5));
				$(".busquedaRecetas #ddMenu").show();
				 if($("#ddMenu").css("display")=="block"){
						$("#grippie").addClass("up");
					}
					else{
						$("#grippie").removeClass("up");
					}
			}
		}
	);
}

cargarRecetasLista = function(jq,idCategoria,filtros,textoBuscar,todas,videoReceta,funcionDespues){
	nbf.ejecutar(
		"\\appv1\\app::ajaxObtenerRecetasLista",
		[idCategoria,filtros,textoBuscar,todas,videoReceta],
		function (respuesta){
			if(respuesta.status=="ok"){
				jq.html(respuesta.html);
			
				cargarEventosRecetasLista(jq);
				if(typeof(funcionDespues)=="function")
					funcionDespues();
				$(".caracteristica").css("margin-top",(0-$(".caracteristica").height()-5));
			}
		}
	);
	
}

cargarRecetasFicha = function(jq,idReceta,funcionDespues){
	var numPersonas=4;
	if(st.obtenerLocalVar("numPersonas")!="")
		numPersonas=st.obtenerLocalVar("numPersonas");
	
	nbf.ejecutar(
		"\\appv1\\app::ajaxObtenerRecetasFicha",
		[idReceta,numPersonas],
		function (respuesta){
			if(respuesta.status=="ok"){
				jq.html(respuesta.html);
				$(".receta").addClass(nbf.codificarDatoClass(idReceta));
				$(".numSel").val(numPersonas);
				$(".caracteristica").css("margin-top",(0-$(".caracteristica").height()-5));

				recetaIniciarPasos();
				
				cargarEventosRecetaFicha(jq,idReceta);
				if(typeof(funcionDespues)=="function")
					funcionDespues();
			}
		}
	);
}

cargarEventosRecetaFicha = function(jq,idReceta){
	
	$(".receta .btnVideoReceta a").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var idVideo = $(this).attr("class");
			var url='https://www.youtube.com/watch?v='+idVideo;
			nbf.deviceReady(
				function(){
					if(device.platform=="Android")
						window.plugins.ChildBrowser.showWebPage(url,{showLocationBar:false});
					else
						var ref = window.open(url, 'videoreceta', 'location=no');
				}
			);
		}
		
	);
	
	$(".personas .contenido .numSel").change(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var numPersonas = $(".numSel").val();
			var idReceta = nbf.extraerDatos($(".receta"));
			st.establecerLocalVar("numPersonas",numPersonas);
			nbf.ejecutar(
				"\\appv1\\app::ajaxObtenerRecetasFicha",
				[idReceta,numPersonas,true],
				function (respuesta){
					if(respuesta.status=="ok"){
						$(".receta .ingredientes .datos").html(respuesta.html);
					}
				}
			);
		}
	);
	
	$(".ingredientes .datos li").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var tag=$(this).data("tag");
			$(".cuadroBuscar input[name=inputBusqueda]").val(tag);
			cabecera.lanzarBusqueda($(".headerFixed"));
			swiper.moverSwiper(1);
		}
	);
	$(".valoracion .estrella").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var valoracion = 0;
			//$(this).closest(".estrellas").find(".registrada").size()
		//	if($(this).closest(".estrellas").find(".registrada").hasClass("noActivo")|| $(this).closest(".estrellas").find(".registrada").size()==0)
				valoracion = $(this).text();
			
			$(this).closest(".estrellas").find(".estrella").each(
				function(){
					if($(this).text()<=valoracion)
						$(this).removeClass("off");
					else
						$(this).addClass("off");
				}
			);
		}
	);
	
	$(".votarReceta").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				
				var estrellas = $(this).closest(".estrellas");
				var valoracion=0;
				estrellas.find(".estrella").each(
					function(){
						if($(this).hasClass("off")==false){
							//hay que contar uno
							valoracion+=1;
						}
					}
					
				);
				
				if(valoracion==0)
					ui.popup.crearAlertaError("No has valorado la receta, porfavor, valora la receta a medida que te ha gustado",null,"Valorar receta");
				else{
					//estrellas.find(".registrada").removeClass("noActivo");
					nbf.ejecutar(
						"\\appv1\\app::ajaxValorarReceta",
						[idReceta,valoracion],
						function (respuesta){
							if(respuesta.status=="ok"){
								ui.popup.crearAlerta(
									"Votacion enviada, muchas gracias por valorar la receta",
									function(){
										contenido.cargarBloqueDerecho(
											function(){
												var comienzo = new Date().getTime();
												ui.popup.iniciarPopupEspera(comienzo);
											},
											function(){
												ui.popup.cerrarPopupEspera();
											}							
										);
									}
									,"popup2",
									false,
									"Valoracin de recetas");
							}
						}
					);
					
				}
			}
		);
	
	$(".btnSiguiente").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			recetaPasoSiguiente();
		}
	);
	
	$(".btnAnterior").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			recetaPasoAnterior();
		}
	);
	$(".btnResumen").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			$(".botonesReproduccion .btnPasos").removeClass("noActivo");
			$(this).addClass("noActivo");
			$(".elaboracion .resumenElaboracion").removeClass("noActivo");
			$(".pasosElaboracion").addClass("noActivo");
			$(".elaboracion .botonesSiguenteAnterior").addClass("noActivo");
		}
	);
	$(".btnPasos").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			$(".botonesReproduccion .btnResumen").removeClass("noActivo");
			$(this).addClass("noActivo");
			$(".pasosElaboracion").removeClass("noActivo");
			$(".elaboracion .resumenElaboracion").addClass("noActivo");
			$(".elaboracion .botonesSiguenteAnterior").removeClass("noActivo");
			
		}
	);
	
	$(".btnComprarReceta").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				
				var receta =nbf.extraerDatos($(".recetasFicha"));
				var numPersonas = $("#numSel").val();
				
				$(".bloqueDerecho").attr("class","bloqueDerecho recetas comprarReceta "+nbf.codificarDatoClass(receta)+" num-"+numPersonas);
				contenido.cargarBloqueDerecho(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}
				);
			}
		);
	
	initFiltros();

}

cargarEventosRecetasLista = function(jq){
	jq.find(".liReceta").click(
		function(ev){
//			ev.preventDefault();
			ev.stopPropagation();
			$(".bloqueDerecho").attr("class","bloqueDerecho recetas recetasFicha");
			var receta =nbf.extraerDatos($(this).find(".lnkReceta"));
			$(".bloqueDerecho").addClass(nbf.codificarDatoClass(receta));
			breadCrumbs.anadirElemento("breadCrumbDerecho","recetas recetasFicha "+nbf.codificarDatoClass(receta),$(this).find(".lnkReceta").text());
			breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
			contenido.cargarBloqueDerecho(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}
				);
		}
	);
	
	jq.find("li.todas").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				$(".bloqueDerecho").attr("class","bloqueDerecho recetas recetasLista todas");
				breadCrumbs.anadirElemento("breadCrumbDerecho","recetas recetasLista todas","Todas las recetas");
				breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
				
				contenido.cargarBloqueDerecho(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}
				);
			}
		);
	
	
	initFiltros();
}
cargarEventosRecetas = function(jq){
	jq.find(".lnkCat").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			contenido.cambiarClass($(".bloqueDerecho"),"recetas recetasLista");
			var categoriaSel = nbf.extraerDatos($(this));
			$(".bloqueDerecho").addClass(nbf.codificarDatoClass(categoriaSel));
			
			breadCrumbs.anadirElemento("breadCrumbDerecho","recetas recetasLista "+nbf.codificarDatoClass(categoriaSel),$(this).text());
			breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
			
			contenido.cargarBloqueDerecho(
				function(){
					var comienzo = new Date().getTime();
					ui.popup.iniciarPopupEspera(comienzo);
				},
				function(){
					ui.popup.cerrarPopupEspera();
				}
			);
		}
	);
	jq.find(".lnkTodas").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			
			$(".bloqueDerecho").attr("class","bloqueDerecho recetas recetasLista todas");
			breadCrumbs.anadirElemento("breadCrumbDerecho","recetas recetasLista todas","Todas las recetas");
			breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
			
			contenido.cargarBloqueDerecho(
				function(){
					var comienzo = new Date().getTime();
					ui.popup.iniciarPopupEspera(comienzo);
				},
				function(){
					ui.popup.cerrarPopupEspera();
				}
			);
		}
	);
	
	initFiltros();
}

comprarReceta = function(jq,idReceta,numPersonas,funcionDespues){
	if(idReceta>0 && numPersonas>0){
		nbf.ejecutar(
			"\\appv1\\app::ajaxComprarReceta",
			[idReceta,numPersonas],
			function (respuesta){
				if(respuesta.status=="ok"){
					jq.html(respuesta.html);
					
					$(".lineasPedido a").attr("href","#");
					breadCrumbs.anadirElemento("breadCrumbDerecho","recetas comprarReceta "+nbf.codificarDatoClass(idReceta)+ " num-"+numPersonas,"Comprar Receta","Comprar ingredientes de la receta");
					breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
					
					cargarEventosComprarReceta(jq);
					if(typeof(funcionDespues)=="function")
						funcionDespues();
				}
				else
					ui.popup.crearAlertaError(respuesta.mensajes,null,"Error en el proceso");
			}
		);
	}
	else
		ui.crearAlertaError("Tienes que seleccionar algun ingrediente para aadirlo al carro",null,"Selecciona ingrediente");
}

cargarEventosComprarReceta = function(jq){
	jq.find(".lineasPedido .linea .des a").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			$(this).closest("tr").toggleClass("lineaSel");
		}
	);
	jq.find(".conjuntoControles .cancelar").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			breadCrumbs.retrocederBreadCrumb("breadCrumbDerecho");
		}
	);
	
	jq.find(".cantidad .cantMas").click(
		function(ev) {
			ev.preventDefault();
			ev.stopPropagation();
			$(this).closest("tr").addClass("lineaSel");
			var cantidadActual =parseInt($(this).closest(".cantidad").find(".inputUds").val());
			$(this).closest(".cantidad").find(".inputUds").val(cantidadActual+1);
		}
	);
	jq.find(".cantidad .cantMenos").click(
		function(ev) {
			ev.preventDefault();
			ev.stopPropagation();
			$(this).closest("tr").addClass("lineaSel");
			var cantidadActual =parseInt($(this).closest(".cantidad").find(".inputUds").val());
			if(cantidadActual>0)
				$(this).closest(".cantidad").find(".inputUds").val(cantidadActual-1);
		}
	);
		
	jq.find(".conjuntoControles .guardar").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				var idReceta = nbf.extraerDatos($(".comprarReceta"));
				var datos =[];
				$(".lineasPedido tbody tr").each(
					function(){
						if($(this).hasClass("lineaSel")){
							var idProducto =nbf.extraerDatos($(this));
							var cantidad =$(this).find(".inputUds").val();
							var elem ={};
							elem.idProducto=idProducto;
							elem.cantidad=cantidad;
							datos.push(elem);
						}
					}
				);
				var productos =nbf.toJSON(datos);
				nbf.ejecutar(
					"\\appv1\\app::ajaxIncluirProductos",
					[productos,idReceta],
					function (respuesta){
						if(respuesta.status=="ok"){
							//alert("ya se han aadido los productos al carro correctamente");
							ui.popup.crearAlerta(
								"Hemos aadido los ingredientes de la receta a tu carro de la compra",
								function(){
									ui.actualizarCarro();
									swiper.moverSwiper(0);
									$(".bloqueDerecho").attr("class","bloqueDerecho");
									contenido.cargarBloqueDerecho(
										function(){
											var comienzo = new Date().getTime();
											ui.popup.iniciarPopupEspera(comienzo);
										},
										function(){
											ui.popup.cerrarPopupEspera();
										}
									);
								},
								"popup2",
								false,
								"Ingredientes aadidos"
							);
						}
						else
							ui.popup.crearAlertaError(respuesta.mensajes,null,"Selecciona ingrediente");
					}
				);
			}
		);
}

function recetaIniciarPasos(){
	var paso = nbf.extraerDatos($(".elaboracion .pasosElaboracion"));
	var numPasos= $(".elaboracion .pasoElaboracion").size();
	if(paso==null){
		paso=1;
		//estamos en el paso 1
		$(".elaboracion .pasosElaboracion").addClass(nbf.codificarDatoClass(1));
		//pintamos el paso 1
		$(".pasoElaboracion").removeClass("on");
		$(".pasoElaboracion."+nbf.codificarDatoClass(1)).addClass("on");
		pintarBotones(paso,numPasos);
		$(".elaboracion .resumenElaboracion").addClass("noActivo");
		$(".botonesReproduccion .btnPasos").addClass("noActivo");
	}
}
function recetaPasoSiguiente(){
	var paso = nbf.extraerDatos($(".elaboracion .pasosElaboracion"));
	var numPasos= $(".elaboracion .pasoElaboracion").size();
	if(paso<numPasos)
		paso+=1;
	$(".elaboracion .pasosElaboracion").attr("class","elaboracion pasosElaboracion "+nbf.codificarDatoClass(paso));
	$(".elaboracion .pasoElaboracion").removeClass("on");
	$(".elaboracion .pasoElaboracion."+ nbf.codificarDatoClass(paso)).addClass("on");
	pintarBotones(paso,numPasos);
}

function recetaPasoAnterior(){
	var paso = nbf.extraerDatos($(".elaboracion .pasosElaboracion"));
	var numPasos= $(".elaboracion .pasoElaboracion").size();
	if(paso>1)
		paso-=1;
	$(".elaboracion .pasosElaboracion").attr("class","elaboracion pasosElaboracion "+nbf.codificarDatoClass(paso));
	$(".elaboracion .pasoElaboracion").removeClass("on");
	$(".elaboracion .pasoElaboracion."+nbf.codificarDatoClass(paso)).addClass("on");
	pintarBotones(paso,numPasos);
}

function pintarBotones(paso,numPasos){
	if(paso==numPasos && paso==1){
		$(".elaboracion .btnSiguiente").addClass("off");
		$(".elaboracion .btnAnterior").addClass("off");
	}
	else{ 
		$(".elaboracion .btnSiguiente").removeClass("off");
		$(".elaboracion .btnAnterior").removeClass("off");
		if(paso==1)
			$(".elaboracion .btnAnterior").addClass("off");
		if(paso==numPasos)
			$(".elaboracion .btnSiguiente").addClass("off");
	}
}
function initFiltros(){
    $("#ddMenu").hide();
   
    var botonFiltros= $("#grippie");
    botonFiltros.click(
    	function(ev){
    		if($("#ddMenu").css("display")=="block"){
    			$("#grippie").addClass("down");
    			$("#grippie").removeClass("up");
    		}
    		else{
    			$("#grippie").addClass("up");
    			$("#grippie").removeClass("down");
    		}
    			
    		ev.preventDefault();
    		ev.stopPropagation();
    	       $('#ddMenu').slideToggle();
    	}	
    );
    
    $(".btnBusquedaAvanzada").click(
    	function(ev){
    		ev.preventDefault();
    		ev.stopPropagation();
    		$(".filtroAvanzado").toggleClass("noActivo");
    	}
    );
    $(".radios .elem").click(
    	function(ev){
    		ev.preventDefault();
    		ev.stopPropagation();
    		
    		$(this).addClass("sel");
    		
    		if($(this).hasClass("elemReceta")){    		
    			$(".radios .elemVideoreceta").removeClass("sel");
    			$("input[name=esReceta]").val("1");
    		}
    		else{
    			$(".radios .elemReceta").removeClass("sel");
    			$("input[name=esReceta]").val("2");
    		}
    	}
    );
    	
    $(".filtroBotonBuscar").click(
		 function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var formulario = $(this).closest("form");
			var cadenaBusqueda ="";
			formulario.find("select.categoria").each(
				function(){
					if($(this).val()!="catDefecto"){
						var valor =$(this).val();
						if(cadenaBusqueda!="")
							cadenaBusqueda +="-";
						cadenaBusqueda +=valor;
					}
				}
			);
			var busquedaTexto= formulario.find(".filtroBusquedaTexto input");
			var tipoReceta= formulario.find("input[name=esReceta]").val();
			$('#ddMenu').slideToggle(
				null,
				function(){
					var clase="";
//					if(busquedaTexto.val()==""){
//						clase="recetas recetasLista buscarR "+nbf.codificarDatoClass(cadenaBusqueda);
//						if(comboVideorecetas.val()!="catDefecto")
//							clase+= " " + "vr"+comboVideorecetas.val();
//						$(".bloqueDerecho").attr("class","bloqueDerecho "+ clase);
//					}
//					else{
//						
//						clase="recetas recetasLista buscarR "+nbf.codificarDatoClass(cadenaBusqueda) + " " +nbf.codificarDatoClass(busquedaTexto.val());
//						if(comboVideorecetas.val()!="catDefecto")
//							clase+= " " + "vr"+comboVideorecetas.val();
//						$(".bloqueDerecho").attr("class","bloqueDerecho "+ clase);
//					}
					clase="recetas recetasLista buscarR "+nbf.codificarDatoClass(cadenaBusqueda) + " " +nbf.codificarDatoClass(busquedaTexto.val());
					//if(comboVideorecetas.val()!="catDefecto")
					clase+= " " + nbf.codificarDatoClass(tipoReceta);
					$(".bloqueDerecho").attr("class","bloqueDerecho "+ clase);
					
					
					//aadimos el breadcrumb aqui
						breadCrumbs.anadirElemento("breadCrumbDerecho",clase,"bsqueda personalizada");
						breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
					
					contenido.cargarBloqueDerecho(
						function(){
							var comienzo = new Date().getTime();
							ui.popup.iniciarPopupEspera(comienzo);
						},
						function(){
							ui.popup.cerrarPopupEspera();
						}
					);
				}
			);
		 }
   ); 
}
