
nbf.ready(
	function(jq){
		FastClick.attach(document.body);
		
		var emailUsuario= st.obtenerLocalVar("emailUsuario");
		if(emailUsuario!="" && $(".usuarioInput").val()=="")
			$(".usuarioInput").attr("value",emailUsuario);
		
		
		if(jq.find(".APPVersion").size()>0)
			jq.find(".APPVersion").html(st.obtenerLocalVar("APPVersion"));
	
		//si el login es correcto redirige a index.html
		ui.checkLoginUsuario("principal.html",null,null);
		
		//Boton Facebook Logout
		jq.find(".FBLogout").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
			}
		);
		
		//Boton Facebook login
		jq.find(".FBLogin").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				
				ui.formularioCodigoPostalValidar("Introduzca el cdigo postal para loguearse",
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
						//hacemos login en facebook
						facebook.init(
							false,
							function(respuesta){
								loguearUsuario(respuesta);
								$(".FBLogout").show();
		  						$(".FBLogin").hide();
		  						ui.popup.cerrarPopupEspera();
							},
							function(){
								ui.popup.crearAlertaError("Los datos introducidos no son correctos",null,"Error acceso");
								ui.popup.cerrarPopupEspera();
							}
						);
					}
				);
			}
		);
		jq.find(".olvidarContrasena a").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				var email ="";
				if($(".usuarioInput").val())
					email=$(".usuarioInput").val();
				ui.popupOlvidarContrasena(email);
			}
		);
		//Boton login
		jq.find(".buttonLogin").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				var comienzo = new Date().getTime();
				ui.popup.iniciarPopupEspera(comienzo);
				var usr = $(".usuarioInput");
				var pwd = jq.find(".passwordInput");
				if(usr.val()!="" && pwd.val()!=""){
					nbf.ejecutar(
						"\\appv1\\app::ajaxLogin",
						[usr.val(),pwd.val(),st.obtenerLocalVar("SOperativo"),st.obtenerLocalVar("SOVersion"),st.obtenerLocalVar("APPVersion"),st.obtenerLocalVar("uuidUser")],
						function(respuesta){
							if(respuesta.status=="ok"){
								if(respuesta.sessId){
									loguearUsuario(respuesta);
									ui.popup.cerrarPopupEspera();
								} 
							}
							else{
								ui.popup.crearAlertaError("Los datos introducidos no son correctos",null,"Error acceso");
								ui.popup.cerrarPopupEspera();
							}
						}
					);
				}
				else{
					ui.popup.cerrarPopupEspera();
					ui.popup.crearAlertaError("Faltan datos o datos errneos",null,"Error acceso");
				}
				st.establecerLocalVar('emailUsuario', usr.val(),'never');
			}
		);
		
		jq.find(".buttonRegistro").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				window.location="registro.html"; 
			}
		);
	
		jq.find(".usuarioInput").keyup(
			function(e){
				if(e.keyCode==13){
					jq.find(".buttonLogin").trigger("click");
				}
			}
		);
		
		jq.find(".usuarioInput").focus(
			function(ev){
				ev.preventDefault();
				var pos = $(".posUsuario label").offset().top;
				$(window).scrollTop(pos);
			}
		);
		
		jq.find(".passwordInput").keyup(
			function(e){
				if(e.keyCode==13){
					jq.find(".buttonLogin").trigger("click");
				}
			}
		);
		jq.find(".passwordInput").focus(
			function(ev){
				ev.preventDefault();
				//var pos = $(this).offset().top;
				var pos = $(".posPwd label").offset().top;
				$(window).scrollTop(pos);
			}
		);
	}
);

loguearUsuario =function(respuesta){
	try{
		if(sessionStorage.getItem("idUsuario")){
			sessionStorage.removeItem("idUsuario");
			sessionStorage.removeItem("sessId");
			sessionStorage.removeItem("firma");
		}
	}catch(e){
	}
	if(respuesta.versionServer.resultado!="")
		st.establecerLocalVar("versionAPPServidor",respuesta.versionServer.resultado);
	else
		st.establecerLocalVar("versionAPPServidor","");
	
	//si tenemos una version antigua popup
	if(respuesta.versionOK!="" && respuesta.versionOK!==undefined && respuesta.versionOK!=null){
		st.establecerLocalVar("marketActualizar",respuesta.preferencias.market);
		ui.formularioActualizacion(
			respuesta,
			function(){
				ui.loginUsuario(respuesta.idUsuario,respuesta.firma,respuesta.sessId,respuesta.preferencias,"principal.html",respuesta);
			}
		);
	} 
	else{
		ui.loginUsuario(respuesta.idUsuario,respuesta.firma,respuesta.sessId,respuesta.preferencias,"principal.html",respuesta);
	}
}

nbf.deviceReady(
	function(){
		if(st.obtenerLocalVar("loginFBAuto")=="1"){
			alert("tenemos que loguear automaticamente con la cuenta de facebook");
		}
	}
);

