ui = ui || {};
ui.catalogo = ui.catalogo || {};
ui.catalogo.listado = function(){

	function initRegalosSustitutivos(jqItems){
		var bloque = jqItems.closest(".bloqueSupAlternativos");
		var botonSeleccionarRegalo = bloque.find(".regaloUnidad .item");
		var listaElementos = nbf.extraerDatos(jqItems.closest(".bloqueDivProductos").find(".contenidoBloque"));
		jqItems.find("input").attr("disabled","disabled");
		if(listaElementos){
			var idsSeleccionados = listaElementos.toString().split(",");
			var encontrado=false;
			for(var i=0;i<idsSeleccionados.length;i++){
				if(encontrado==false){
					var classId=nbf.codificarDatoClass(idsSeleccionados[i]);
					var objItem = jqItems.find("."+classId);
					if(objItem.size()>0){
						//ha encontrado un elemento seleccionado en la vista
						//por tanto, lo marcamos como seleccionado
						objItem.addClass("sel");
						encontrado=true;
					}
				}
			}
		}
		
		botonSeleccionarRegalo.click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				var items = botonSeleccionarRegalo.closest(".items");
				items.find(".item").removeClass("sel");
				$(this).addClass("sel");
			}
		);
	};
	
	function cambiarCantidadProducto(jqProducto,incremento,funcionOk,repintar,cantidadActual){
		if (cantidadActual== "")
			cantidadActual = 0;
		var idProducto = nbf.extraerDatos(jqProducto);
		var nuevaCantidad =1;
		if(nuevaCantidad==1 && jqProducto.hasClass("itemEnCarro")==false)
			nuevaCantidad= 1;
		else
			nuevaCantidad= parseInt(cantidadActual) +(parseInt(incremento));
		if(jqProducto.closest(".pasoCompra").hasClass("pasoCompraDisponibilidadProducto"))
			jqProducto.find(".uds .unicos input").val(nuevaCantidad);
		else
			jqProducto.find(".uds").html(nuevaCantidad +"<span class='ud'> Uds</span>" );
		
		if(nuevaCantidad!=0)
			jqProducto.addClass("itemEnCarro");
		else
			jqProducto.removeClass("itemEnCarro");
		nbf.lanzar(1000, function(ev) {
			carro.cambiarCantidadProductoAJAX(
				idProducto,
				nuevaCantidad,
				null,
				null,
				null,
				function(respuesta){
					if(funcionOk)
						funcionOk(respuesta);
				},
				null,null,repintar
			);
		});
		
	}
	function initProductosUpselling(jqItems,funcionCambioCantidad){
		
		var bloque = jqItems.closest(".bloque");
		var botonMas = bloque.find(".btnMas");
		var botonMenos=bloque.find(".btnMenos");
		var botonEliminarCarro =bloque.find(".btnEliminar");
		botonMas.click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				var jqProducto = $(this).closest(".producto");
				var cantidadActualjq = (jqProducto.find(".uds"));
				if(cantidadActualjq)
					var cantidadActual = cantidadActualjq.text().split("Uds")[0];
					
				cambiarCantidadProducto(jqProducto,"+1",
					function(respuesta){
						var unid =jqProducto.find(".uds").text();
						var unidades=unid.split("Uds");
						
						if(respuesta.cantidad>="1"){
							jqProducto.find(".conUnidades").removeClass("noActivo");
							jqProducto.find(".btnMenos").removeClass("noActivo");
							jqProducto.find(".uds").html(respuesta.cantidad +"<span class='ud'> Uds</span>");
						}
					},
					true,
					cantidadActual
				);
				
			}
		);
		
		botonMenos.click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				var jqProducto = $(this).closest(".producto");
				var cantidadActualjq = (jqProducto.find(".uds"));
				if(cantidadActualjq)
					var cantidadActual = cantidadActualjq.text().split("Uds")[0];
				if(cantidadActual!="0"){
					cambiarCantidadProducto(
						jqProducto,"-1",
						function(respuesta){
							if(respuesta.cantidad=="0"){
								jqProducto.find(".conUnidades").addClass("noActivo");
								jqProducto.find(".btnMenos").addClass("noActivo");
								jqProducto.find(".btnEliminar").addClass("noActivo");
								jqProducto.find(".btnMas").show();
							}
							jqProducto.find(".uds").html(respuesta.cantidad +"<span class='ud'> Uds</span>");
						},
						true,
						cantidadActual
					);
				}
			}
		);
		botonEliminarCarro.click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				var jqProducto = $(this).closest(".producto");
				jqProducto.find(".conUnidades").addClass("noActivo");
				jqProducto.find(".sinUnidades").removeClass("noActivo");
				jqProducto.find(".btnMenos").addClass("noActivo");
				jqProducto.find(".btnEliminar").addClass("noActivo");
				jqProducto.find(".btnMas").show();
				jqProducto.removeClass("itemEnCarro");
				var idProducto = nbf.extraerDatos(jqProducto);
				nbf.lanzar(1000, function(ev) {
					carro.cambiarCantidadProductoAJAX(
						idProducto,
						0,
						null,
						null,
						null,
						function(respuesta){
							if(funcionOk)
								funcionOk(respuesta);
						},
						null,null,false
					);
				});
			}
		);
		
//		bloque.find(".productos .des").click(
//				function(ev){
//					ev.preventDefault();
//					ev.stopPropagation();
//					
//				}
//			);
	}
	
	//inicializacion de producto individual
	function initProductos(jqItems,funcionCambioCantidad){		
//		//comprar/modificar cantidad
		var bloque = jqItems.closest(".bloqueSupAlternativos");
		//boton Comprar y aadir una unidad
		var botonComprarSustitutivo = bloque.find(".alternativos .btnComprar,.alternativos .cantMas");
		var botonMenosSustitutivo = bloque.find(".alternativos .cantMenos");
		botonComprarSustitutivo.click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				var jqProducto = $(this).closest(".item");
				var cantidadActual=jqProducto.find(".inputUds").val();
				cambiarCantidadProducto(jqProducto,"+1",
				function(respuesta){
					jqProducto.find(".uds .unicos input").val(respuesta.cantidad);
				}		
				,true,cantidadActual);
			}
		);
		//boton menos
		botonMenosSustitutivo.click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				var jqProducto = $(this).closest(".item");
				var cantidadActual=jqProducto.find(".inputUds").val();
				cambiarCantidadProducto(jqProducto,"-1",null,true,cantidadActual);
			}
		);
		
		//reservar super-oferta
		jqItems.find(".btnReservarSo").click(
			function(ev){
				ev.preventDefault();
				ui.fichaOfertaFlash.reservarOfertaFlash(nbf.extraerDatos($(this)),$(this));
			}
		);
	};

	nbf.ready(
		function(jq){
			var modListado = jq.find(".modListadoProductos");
			if(modListado.size()>0){
				modListado.each(
					function(){
						initProductos($(this).find(".items .item"));
					}
				);
				
				//inicializamos los carruseles de productos con el nmero de pginas y pgina actual
				modListado.find(".carruselBox .carrusel").each(
					function(){
						var carrusel = $(this);
						var lista = carrusel.find(".items");
						carrusel.data("pag",0);
						carrusel.data("max",Math.floor((lista.find("li").size()-1)/3));
						carruselActualizarControles(carrusel);			
					}
				);
				
				modListado.find(".carruselBox .btnC").click(
					function(ev){
						ev.preventDefault();
						if(!$(this).hasClass("btnCOff")){
							var carrusel = $(this).closest(".carruselBox").find(".carrusel");
							var signo;
							if($(this).hasClass("btnCAnt")){
								signo = "+";
								if(carrusel.data("pag")==0)
									return;
								carrusel.data("pag",carrusel.data("pag")-1);
							}else{
								signo = "-";
								if(carrusel.data("pag")==carrusel.data("max"))
									return;
								carrusel.data("pag",carrusel.data("pag")+1);
							}
							carruselActualizarControles(carrusel);
							
							carrusel.find(".items").animate(
								{"margin-left":signo+"="+carrusel.width()},
								{"duration":1000}
							);
						}
					}
				);
			}
		}
	);
	
	return {
		"initProductos":initProductos,
		"initProductosUpselling":initProductosUpselling,
		"initRegalosSustitutivos":initRegalosSustitutivos
	};
}();