
ui.pedido = ui.pedido || {};
ui.pedido.proceso = ui.pedido.proceso || {};
ui.pedido.proceso.compra = function(){
	var jqProcesoCompra=null;
	//paso actual del proceso de compra
	var pasoActual = "pasoCompraCarro";
	var reservandoEntrega = false;


	function initProcesoCompra(jq,esReservaEntrega){
		jqProcesoCompra = jq;
		
		jq.find(".btnSiguiente").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				pasoSiguiente(
					function(){
						var comienzo = new Date().getTime();
						//aadimos el tiempo de inicio en el class
						ui.popup.iniciarPopupEspera(comienzo);
					},	
					function(popup){
						ui.popup.cerrarPopupEspera();
					}
				);	
			}
		);
		
		jq.find(".btnAnterior").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				pasoAnterior(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},	
					function(popup){
						ui.popup.cerrarPopupEspera();
					}
				);	
			}
		);
		
		jq.find(".btnPlegar").click(
			function(ev){
				ev.preventDefault();
				$(".bloqueIzquierdo").attr("class","bloqueIzquierdo");
				contenido.cargarBloqueIzquierdo(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}		
				);
			}
		);
		
		//ui.usuario.initCodigoPromocional(jq.find(".codDescuentoContenido"));
		
		reservandoEntrega = esReservaEntrega;
		
		resetPasoActual();

		
		//ponemos el contenido del primer paso
		actualizarPasoActual();
	}
	
	//Cambia al paso anterior de compra
	function pasoAnterior(funcionAntes,funcionDespues){
		if(funcionAntes)
			funcionAntes();
				
		pedido.proceso.compra.pasoAnterior(
			pasoActual,
			reservandoEntrega,
			function(pasoAnterior){
				if(pasoAnterior)
					actualizarPasoActual(pasoAnterior,null,funcionDespues);
			},
			function(){ //si no hay paso anterior, plegamos el carro
				//ui.pedido.proceso.carro.plegar();
				$(".bloqueIzquierdo").css("display","none");
				$(".bloqueIzquierdo").attr("class","bloqueIzquierdo");
				contenido.cargarBloqueIzquierdo();
				$(".bloqueIzquierdo").css("display","block");
				if(funcionDespues)
					funcionDespues();
			}
		);
		
	}
	
	//Cambia al paso siguiente de compra
	//
	function pasoSiguiente(funcionAntes,funcionDespues){
		if(typeof(funcionAntes)=="function")
			funcionAntes();
		
		if(!jqProcesoCompra.hasClass("procesoCompraCargando")){
			jqProcesoCompra.addClass("procesoCompraCargando");
			pedido.proceso.compra.confirmarPaso(
				pasoActual,
				reservandoEntrega,
				eval("ui.pedido.proceso."+pasoActual+".obtenerDatos(jqProcesoCompra)"),
				function(pasoSiguiente,datos){
					if(pasoSiguiente){ //hay paso siguiente
						if(typeof(funcionDespues)=="function"){
							actualizarPasoActual(pasoSiguiente,null,funcionDespues);
					
							}
						else
						actualizarPasoActual(pasoSiguiente);
					}
					else{ //compra confirmada
						//cerramos el posible popup creado
						ui.popup.cerrarCualquierPopupEspera();
						if(datos.usarTpv){
							if(datos.urlTpv){
								procesarPedidoPaypal(datos,jqProcesoCompra);
							}
							else{
								procesarPedidoTarjetaOnline(datos,jqProcesoCompra);
//								var form = $(datos.formTpv);
//								jqProcesoCompra.append(form);
//								form.submit();
							}
						}else{
							procesarPedidoOtrasFormasPago(datos,funcionDespues);
							
						}
					}
				},
				function(mensajes){
					if(funcionDespues){
						funcionDespues();
					}
						
					ui.popup.crearAlertaError(mensajes,null,"Proceso de compra");
					jqProcesoCompra.removeClass("procesoCompraCargando");
				},
				function(pasoCambiar,mensajes){
					var fOk = function(){
						actualizarPasoActual(pasoCambiar);
					};
					if(mensajes)
						ui.popup.crearAlertaError(mensajes,fOk,"");
					else
						fOk();
				}
			);
		}
	}
	/**
	 * Funcion que procesa mediante childbrowser la peticion de pedido a traves de paypal
	 * @param datos datos recibidos (idpedido,url  etc...
	 * @param jqProcesoCompra  jq del link que llama a esta funcion para quitarle el class si se cancela
	 */
	function procesarPedidoPaypal(datos,jqProcesoCompra){
		if(st.obtenerLocalVar("SOVersion")!="pcVersion"){
			window.plugins.ChildBrowser.showWebPage(
				datos.urlTpv,{ showLocationBar: false }
			);
			window.plugins.ChildBrowser.onClose = function(){
				jqProcesoCompra.removeClass("procesoCompraCargando");
			}
			window.plugins.ChildBrowser.onLocationChange = function (url) {
			    //retorno de paypal ok
			    if(getQueryVar(url,"paypalOk")==1){
			       	window.plugins.ChildBrowser.close();
			       	jqProcesoCompra.removeClass("procesoCompraCargando");
			    	//cojemos los Token=sjakjfdkjfldkfj&PlayerID=daflkdjafkd
			    	popupConfirmarPagoPaypal(datos,url);
			    }
			}
		}
		else{
			//alert("sip");
			window.open(datos.urlTpv,"_blank");
		}
	}
	
	/**
	 * Funcion que procesa la peticion de pagar con tarjeta online
	 */
	function procesarPedidoTarjetaOnline(datos,jqProcesoCompra){
		var urlPago=nbf.raizUrl+"/web/pag/tpv/submit-pago.php?idPedido="+datos.idPedido;
		window.plugins.ChildBrowser.showWebPage(urlPago,
                { showLocationBar: false });
		window.plugins.ChildBrowser.onClose =function(){
			jqProcesoCompra.removeClass("procesoCompraCargando");
		}
		window.plugins.ChildBrowser.onLocationChange = function (url) {
			var resultOk = getQueryVar(url,"ok");
			var resultError= getQueryVar(url,"acc");
			if(resultOk!=false || resultError!=false){
				window.plugins.ChildBrowser.close();
				if(resultOk!=false){
					var elems = url.split("/");
					//si el pedido ha salido ok
					if(elems[elems.length-1]=="?ok=1"){
						var numPedido = elems[elems.length-2]; 
						carro.eliminarProductosAJAX();
						swiper.moverSwiper(1);
						$(".bloqueIzquierdo").attr("class","bloqueIzquierdo");
						contenido.cargarBloqueIzquierdo();
						contenido.cargarPanelCentral();
						//window.location = datos.urlOk;
//						nbf.ejecutar(
//							"\\appv1\\app::ajaxEnviarContactoProducto",
//							[mensaje],
//							function (respuesta){
////									if(respuesta.status=="ok"){
////									}
//							}
//						);
						ui.popup.crearAlerta("Pedido "+ numPedido +" realizado correctamente. En la seccin 'Mis Pedidos' tendrs toda la informacin acerca de este pedido",
							irAPedido()
							,"popup2",false,"Pedido finalizado"
						);
					 }
				}
				else{
					window.plugins.ChildBrowser.close();
					ui.popup.crearAlerta("Ha habido un error con el pedido, por favor, elije una nueva forma de pago o vuelve a intentarlo",null,"popup2",false,"Error en el pedido");
					actualizarPasoActual();
				}
			 }
			
		}
	}
	function procesarPedidoOtrasFormasPago(datos,funcionDespues){
		carro.eliminarProductosAJAX();
		swiper.moverSwiper(1);
		$(".bloqueIzquierdo").attr("class","bloqueIzquierdo");
		contenido.cargarBloqueIzquierdo();
		contenido.cargarPanelCentral();
		//window.location = datos.urlOk;
//		var mensaje="test de pedido";
//		nbf.ejecutar(
//			"\\appv1\\app::ajaxEnviarContactoProducto",
//			[mensaje],
//			function (respuesta){
////					if(respuesta.status=="ok"){
////					}
//			}
//		);
		ui.popup.crearAlerta("Pedido realizado correctamente. En la seccin 'Mis Pedidos' tendrs toda la informacin acerca de este pedido",
			function(){
				irAPedido();
			},
			"popup2",false,"Pedido finalizado"
		);
		if(funcionDespues){
			funcionDespues();
		}
	}
	/**
	 * Popup para la confirmacion del pedido de paypal
	 */
	function popupConfirmarPagoPaypal(datos,url){
		var token =getQueryVar(url,"token");
    	var payerId=getQueryVar(url,"PayerID");
    	var idPedido= datos.idPedido;
    	var bloque = $("<div />");
		var botones = ui.popup.crearBotones("btnsAccion");
		bloque.addClass("c");
		bloque.append("Para finalizar el pedido, debe confirmar el pedido que acaba de realizar con Paypal. <br/>Quiere confirmar el pago por paypal?");
		bloque.append(botones);
		var popup = ui.popup.crear(bloque,"popupAlerta popupNoCerrarButton popup2",false,"popupI","popupII","Confirmar Paypal");
		//aadimos botones
		botones.append(
			ui.popup.crearBoton(
				"Confirmar",
				"Ok",
				function(){	
					confirmarPagoPaypal(idPedido,token,payerId,popup,
						function(){
							var comienzo = new Date().getTime();
							ui.popup.iniciarPopupEspera(comienzo);
						},
						function(){
							ui.popup.cerrarPopupEspera();
						}
					);
				}
			)
		);
		botones.append(
			ui.popup.crearBoton(
				"Cambiar la forma de pago",
				"No",
				function(){
					ui.popup.ocultar(popup);
				}
			)
		);
	}
	
	/**
	 * Funcion que confirma el pago de paypal 
	 * @param idPedido 
	 * @param token
	 * @param payerId
	 */
	function confirmarPagoPaypal(idPedido,token,payerId,popup,funcionAntes,funcionDespues){
		if(typeof(funcionAntes)=="function")
			funcionAntes();
		
		nbf.ejecutar(
			"\\appv1\\app::ajaxConfirmarPedidoPagoPaypal",
			[idPedido,token,payerId],
			function (respuesta){
				if(respuesta.status=="ok"){
					ui.popup.ocultar(popup);
					//vaciamos el carrito 
					//movemos a la principal
					carro.eliminarProductosAJAX();
					swiper.moverSwiper(1);
					$(".bloqueIzquierdo").attr("class","bloqueIzquierdo");
					contenido.cargarBloqueIzquierdo();
					ui.popup.crearAlerta("Pedido realizado correctamente. En la seccin 'Mis Pedidos' tendrs toda la informacin acerca de este pedido",
						function(){
							irAPedido();
						},
						"popup2",false,"Pedido finalizado"
					);
				}
			}
		);
	}
	/**
	 * Funcion que se mueve al panel derecho y muestra mis pedidos para ver el estado del ultmo pedido generado
	 */
	function irAPedido(){
		$(".bloqueDerecho").attr("class","bloqueDerecho misPedidos");
		contenido.cargarBloqueDerecho(
			function(){
				var comienzo = new Date().getTime();
				ui.popup.iniciarPopupEspera(comienzo);
			},
			function(){
				ui.popup.cerrarPopupEspera();
			}				
		);
		$(".bloqueDerecho .btnNivel").removeClass("noActivo")
		$(".bloqueDerecho .btnNivel").html(contenido.mensajeMenuZonaPrivada("Mis pedidos"));
		swiper.moverSwiper(2);
	}
	
	function getQueryVar(url,varName){
		//cogemos y escapamos el string url, aadiendo un & al final para hacer mas sencillo el regExp
	    var url= unescape(url) + '&';
	    var regex = new RegExp('.*?[&\\?]' + varName + '=(.*?)&.*');
	    val = url.replace(regex, "$1");
	    //Si la string es la misma no hemos encontrado valor - retornamos false
	    return val == url ? false : val;
	}
	
	//resetea el paso actual al inicial o al pasado
	function resetPasoActual(){
		if(reservandoEntrega)
			//pasoActual = "pasoCompraDireccionSeleccionar";
//			pasoActual = "pasoCompraCompletarDatos";
			pasoActual ="pasoCompraUpselling";
		else{
			//pasoActual = "pasoCompraCarro";
			//pasoActual = "pasoCompraDireccionSeleccionar";
//			pasoActual = "pasoCompraCompletarDatos";
			pasoActual ="pasoCompraUpselling";
			
		}
	}
	
	//Mueve el marker al paso de compra
	function moverMarkerAPaso(paso){
		var desp = {};
		if(reservandoEntrega){
			desp.pasoCompraDireccionCrear = 15;
			desp.pasoCompraDireccionSeleccionar = 15;
			desp.pasoCompraTelefonoCrear = 30;
			desp.pasoCompraTelefonoSeleccionar = 30;
			desp.pasoCompraFechaEntrega = 50;
		}else{
//			desp.pasoCompraCarro = 10;
			desp.pasoCompraUpselling=15;
			desp.pasoCompraCompletarDatos = 20;
			desp.pasoCompraDireccionCrear = 25;
			desp.pasoCompraDireccionSeleccionar = 25;
			desp.pasoCompraTelefonoCrear = 35;
			desp.pasoCompraTelefonoSeleccionar = 35;
			desp.pasoCompraFechaEntrega = 50;
			desp.pasoCompraDisponibilidadProducto = 55;
			desp.pasoCompraCuponesDescuento = 63;
			desp.pasoCompraSeleccionarRegalos = 66;
			desp.pasoCompraCancelarPedidosDuplicados = 68;
			desp.pasoCompraFormaPago = 70;
		}
		
		jqProcesoCompra.find(".pasos .marker").clearQueue().animate(
			{
				"width":desp[paso]+"%"
			}
		);
	}
	//Actualiza el contenido del paso de compra actual
	function actualizarPasoActual(pasoAsignar,mantenerPosScroll,funcionDespues){
		if(pasoAsignar)
			pasoActual = pasoAsignar;
		//eliminamos todos los popups contextuales que haya
		//ui.popup.eliminarContextuales();
		pedido.proceso.compra.obtenerContenidoPaso(
			pasoActual,
			reservandoEntrega,
			function(html){
				var contenido = $(html);
				if(contenido.find("form").html()==""){
					pasoSiguiente();
				}
				jqProcesoCompra.find(".contenido").html(contenido);
				contenido.addClass(pasoActual);
				eval("ui.pedido.proceso."+pasoActual+".init(contenido)");
				if(!mantenerPosScroll)
					$(window).scrollTop(0);
				moverMarkerAPaso(pasoActual);
				jqProcesoCompra.removeClass("procesoCompraCargando");
				if(funcionDespues){
					funcionDespues();
				}
				//ui.pedido.proceso.carro.actualizarResumen();
				//ui.historia.encolar(jqProcesoCompra.find(".pasoCompra"));
				//ui.pedido.proceso.carro.ajustarAltoDespliegue();
				//analytics.trackUrl("/compra/"+pasoActual.toLowerCase()+"/");
			},
			function(pasoCambiar){
				if(pasoCambiar)
					actualizarPasoActual(pasoCambiar);
			}
		);
		
	}
	
	return {
		"initProcesoCompra":initProcesoCompra,
		"pasoSiguiente":pasoSiguiente,
		"pasoAnterior":pasoAnterior,
		"actualizarPasoActual":actualizarPasoActual,
		"resetPasoActual":resetPasoActual,
	};
}();