ui.pedido = ui.pedido || {};
ui.pedido.proceso = ui.pedido.proceso || {};
ui.pedido.proceso.lista = function(){
	var jqListaCompra = null;
	
	//Inicializa los items de lista de compra
	function initItems(jq){
		jq.find("li .item").click(
			function(ev){
				ev.preventDefault();
				seleccionarItem($(this).closest("li").prevAll().size());
			}
		);
		
		jq.find("li .btnEliminar").click(
			function(ev){
				ev.preventDefault();
				eliminarItem($(this).closest("li"),false);
			}
		);
		
		jq.find(".itemMas").click(
			function(ev){
				ev.preventDefault();
				var actual = jqListaCompra.find(".listaCompraItems .actual");
				var item = null;
				if(actual.size()>0){
					if($(this).hasClass("itemMasTop"))
						item = actual.prevAll().eq(Math.min(8,actual.prevAll().size()-1));
					else{
						if(actual.nextAll().size()>=9){
							if(actual.hasClass("pri")){
								var sig = actual.next();
								seleccionarItem(sig.prevAll().size(),true);
								moverAItemLista(sig);
							}else
								item = actual;
						}else
							item = actual.prevAll().eq(8-actual.nextAll().size());
					}
				}else{
					var primeroVisible = jqListaCompra.find(".listaCompraItems .pri");
					if($(this).hasClass("itemMasTop"))
						item = primeroVisible.prevAll().eq(Math.min(4,primeroVisible.prevAll().size()-1));
					else
						item = primeroVisible.nextAll().eq(Math.min(4,primeroVisible.nextAll().size()-1));
				}
				moverAItemLista(item);
			}
		);
		
		jq.find("li .btnVerProductos").click(
			function(ev){
				ev.preventDefault();
				var popup = ui.popup.crearContextualTitulo("popupContextualProductos",$(this));
				var item = $(this).closest("li").find(".item").text();
				
				popup.data(
					"fnActualizar",
					function(){
						pedido.proceso.lista.obtenerProductosItem(
							item,
							function(html){
								var contenido = $(html);
								var items = contenido.find(".item");
								if(items.size()>0){
									ui.popup.asignarContenido(popup,contenido);
									ui.catalogo.listado.initProductos(
										items,
										function(item,cantidad){
											popup.data("fnActualizar")();
										}
									);
								}else //si no hay items cierro el popup
									ui.popup.ocultar(popup);
							}
						);
					}
				);
				popup.data("fnActualizar")();
			}
		);
		
		var textarea = jq.find("textarea");
		if(textarea.size()==0)
			centrarItemSelLista();
		else{
			textarea.focus(
				function(){
					var txt = $(this);
					txt.addClass("edit");
					if(txt.hasClass("ini")){
						txt.data("ini",txt.val());
						txt.val("");
						txt.removeClass("ini");
					}
				}
			).blur(
				function(){
					var txt = $(this);
					txt.removeClass("edit");
					if(txt.val().length==0 && txt.data("ini")){
						txt.val(txt.data("ini"));
						txt.addClass("ini");
					}	
				}
			).keyup(
				function(){
					var txt = $(this);
					nbf.lanzar(
						3000,
						function(){
							pedido.proceso.lista.asignarItems(txt.val());
						}
					);
				}
			);
		}
		
		jq.find(".btnConfirmar").click(
			function(ev){
				ev.preventDefault();
				var textarea = $(this).closest(".listaCompraItems").find("textarea");
				if(textarea.hasClass("ini") || textarea.val().length==0){
					var img = $("<img src='/web/img/decorado/lista-sin-texto-ayuda.png' />");
					img.css(
						{
							"position":"absolute",
							"left":30,
							"top":textarea.offset().top-50,
							"z-index":1
						}
					);
					$("body").append(img);
					img.animate(
						{
							"left":textarea.offset().left+textarea.width()+100
						},
						{
							"complete":function(){
								img.css("z-index","10000");
								img.animate(
									{
										"left":"-=100"
									}
								).delay(3000).fadeOut();
							}
						}
					);
					
					//ui.popup.crearAlertaAdvertencia("Escribe algo en tu lista, por ejemplo: leche, huevos, aceite");
				}else
					asignarItems(textarea.val());
			}
		);
		
		jq.find(".btnVerVideo").click(
			function(ev){
				ev.preventDefault();
				ui.popup.crearModalPlantillaContexto("popupVideo",[{"e":421,"v":{"idRecurso":218}}],$(this));
			}
		);
		
		jq.find(".btnVerCarro,.btnPagar").click(
			function(ev){
				ev.preventDefault();
				var btn = $(this);
				ui.usuario.loginRequerido(
					"Inicia sesin para ver tu carro",
					function(){
						ui.pedido.proceso.carro.desplegar(btn.hasClass("btnPagar"));
					},
					null,
					false,
					null,
					btn
				);				
			}
		);
		
		jq.find(".btnEditar").click(
			function(ev){
				ev.preventDefault();
				actualizarItems(
					true,
					null,
					function(){
						textareaFocus(jqListaCompra.find("textarea"));
					}
				);
			}
		);
		
		var inputNuevoItem = jq.find(".txtNuevoItem");
		
		var fOk = function(texto){
			if(texto.length==0)
				return;
			pedido.proceso.lista.incluirItem(
				texto,
				function(){
					actualizarItems(
						false,
						jq.find(".actual .item").text(),
						function(){
							if(jq.find(".items li").size()<9)
								jqListaCompra.find(".listaCompraItems .txtNuevoItem").focus();
							else{
								actualizarItems(
									true,
									null,
									function(){
										textareaFocus(jqListaCompra.find("textarea"));
									}
								);
							}	
						}
					);
				},
				function(){
					ui.popup.crearAlertaAdvertencia(
						"Ese producto ya lo tienes en tu lista",
						function(){
							if(inputNuevoItem)
								inputNuevoItem.focus();
						}
					);
				}
			);
		};
		
		ui.catalogo.buscador.initInputBuscador(inputNuevoItem,fOk);
		jq.find(".innerC").click(
			function(ev){
				if($(ev.target).hasClass("innerC") && jq.find(".items li").size()<9)
					inputNuevoItem.focus();
			}
		);
		
		actualizarCssItems();
	}
	
	//actualiza todos los CSS de los items
	function actualizarCssItems(){
		if(jqListaCompra.find(".items .actual").size()>0)
			jqListaCompra.find(".listaCompraItems").addClass("listaCompraItemsConSel");
		else
			jqListaCompra.find(".listaCompraItems").removeClass("listaCompraItemsConSel");
		if(jqListaCompra.find(".items .pri").size()==0)
			jqListaCompra.find(".items li:first").addClass("pri");
	}
	
	//inicializa la lista de categoras compradas
	function initCategoriasCompradas(jq){
		jq.find("li a").click(
			function(ev){
				ev.preventDefault();
				var li = $(this).closest("li");
				var texto = li.find("p").text(); 
				ui.pedido.proceso.lista.actualizarResultados(texto);
				li.addClass("sel").siblings().removeClass("sel");
			}
		);
		
		jq.find(".sinCompra a").click(
			function(ev){
				ev.preventDefault();
				ui.popup.crearModalPlantillaContexto("popupVideo",[{"e":421,"v":{"idRecurso":222}}],$(this));
			}
		);
	}
	
	function textareaFocus(textarea){
		if(textarea.size()>0){
			textarea.focus();
			var elemTextarea = textarea.get(0); 
			var pos = textarea.val().length;
			if(pos>0){
				try{
					if(elemTextarea.setSelectionRange){
						elemTextarea.setSelectionRange(pos, pos);
					}else if(elemTextarea.createTextRange){
						var range = elemTextarea.createTextRange();
					    range.collapse(true);
					    range.moveEnd('character',pos);
					    range.moveStart('character',pos);
					    range.select();
					}
				}catch(e){ //toleramos errores
					
				}
			}
		}
	}
	
	//actualiza la lista de compra
	function actualizarListaCompra(){
		//siempre actualizamos la lista plegada
		pedido.proceso.lista.obtenerListaCompra(
			false,
			false,
			function(html){
				var nuevaLista = $(html);
				jqListaCompra.replaceWith(nuevaLista);
				jqListaCompra = nuevaLista;
				init(jqListaCompra);
			}
		);
	}

	//actualiza los resultados del buscador
	function actualizarResultados(cadena){
		var resultados = jqListaCompra.find(".resultados");
		ui.catalogo.buscador.actualizarResultados(
			resultados,
			cambiarItemActual,
			eliminarItemActual,
			seleccionarItemSiguiente,
			function(){
				ajustarAltoMax();				
			},
			cadena
		);
		var cargando = $("<div />").addClass("cargando").height(400);
		resultados.html(cargando);
		
		var fOk = function(){
			jqListaCompra.removeClass("listaCompraMed").addClass("listaCompraMax");
			$(window).scrollTop(0);
			//ocultamos content por rendimiento
			ui.habilitarContent(false);
			//debemos poner el z-index a la altura de los dems popups modales
			jqListaCompra.css("zIndex",ui.zIndex);
		};
		
		if(jqListaCompra.hasClass("listaCompraMin"))
			desplegar(fOk,true);
		else
			fOk();
		ui.historia.encolar(jqListaCompra);
		analytics.trackBusqueda(cadena);
	}
	
	function ajustarAltoMax(sec){
		if(jqListaCompra.hasClass("listaCompraMax")){
			var listaCompraCaja = jqListaCompra.find(".listaCompraCaja");
			var resultados = jqListaCompra.find(".resultados");
			var posLista = listaCompraCaja.offset();
			jqListaCompra.css("height",Math.max($(window).height(),$("body").height(),resultados.offset().top+resultados.outerHeight(),posLista.top+listaCompraCaja.outerHeight()));
		}
		if(!sec)
			nbf.lanzar(2000,function(){ajustarAltoMax(true);});
	}

	//Selecciona el item en la posicin pasada
	function seleccionarItem(pos,noCentrar){
		var elem = jqListaCompra.find(".listaCompraItems li").eq(pos);
		if(!elem.hasClass("actual")){
			elem.closest("ul").find(".actual").removeClass("actual");
			elem.addClass("actual");
		}
		if(!noCentrar)
			centrarItemSelLista();
		actualizarResultados(elem.find(".item").text());
	}

	//Selecciona un item en base al texto
	function seleccionarItemTexto(texto){
		var pos = -1;
		jqListaCompra.find(".listaCompraItems li .item").each(
			function(){
				pos++;
				if($(this).text()==texto)
					return seleccionarItem(pos);
			}
		);
	}

	//Va al siguiente item de la lista
	function seleccionarItemSiguiente(){
		//primero los siguientes
		var siguiente = jqListaCompra.find(".listaCompraItems .actual").nextAll(":not(.sel)").eq(0);
		if(siguiente.size()==0) //si no hay siguientes		
			siguiente = jqListaCompra.find(".listaCompraItems .actual").prevAll(":not(.sel)").last();
		if(siguiente.size()==0)
			siguiente = jqListaCompra.find(".listaCompraItems .actual").nextAll().eq(0);
		if(siguiente.size()==0) //si no hay siguientes		
			siguiente = jqListaCompra.find(".listaCompraItems .actual").prevAll().last();
		seleccionarItem(siguiente.prevAll().size());
	}

	//Elimina el item actual de la lista
	function eliminarItemActual(){
		eliminarItem(jqListaCompra.find(".listaCompraItems .actual"),true);
	}

	//Elimina el item pasado de la lista (jq es el li del item)
	function eliminarItem(jq,seleccionarSiguiente){
		nbf.ejecutar(
			"\\datos\\pedido\\proceso\\lista::ajaxEliminarItem",
			[jq.find(".item").text()],
			function(respuesta){
				if(respuesta.status=="ok"){
					if(seleccionarSiguiente)
						seleccionarItemSiguiente();
					if(jq.siblings().size()==0){
						actualizarItems(true);
					}else{
						if(jq.hasClass("pri"))
							jq.next().addClass("pri");
						jq.remove();
						moverAItemLista(jqListaCompra.find(".listaCompraItems .pri"));
						//actualizarCssItems();
					}
				}
			}
		);
	};

	//Asigna los items pasados a la lista de compra
	function asignarItems(items){
		pedido.proceso.lista.asignarItems(
			items,
			function(){
				actualizarItems(
					false,
					null,
					function(){
						jqListaCompra.find(".listaCompraItems li:not(.sel) .item").eq(0).click();
					}
				);
			},
			function(mensajes){
				ui.popup.crearAlertaError(mensajes,null,"Error");
			}
		);
	}
	
	//Actualiza los items de la lista de compra
	function actualizarItems(editable,itemActual,funcionOk){
		nbf.ejecutar(
			"\\control\\web\\pedido\\proceso\\lista::ajaxObtenerItems",
			[editable,itemActual],
			function(html){
				var contenido = $(html);
				jqListaCompra.find(".listaCompraItems").replaceWith(contenido);
				initItems(contenido);
				//reseteamos lo que suelo comprar por si hay que recalcular
				jqListaCompra.find(".tabCompradoContent").removeClass("cargado");
				//ajustamos la altura por si la lista es muy larga
				ajustarAltoMax();
				if(funcionOk)
					funcionOk();
			}
		);
	}

	//Cambia el item actualmente seleccionado por el texto nuevo
	function cambiarItemActual(textoNuevo){
		if(textoNuevo.length==0)
			return;
		var actual = jqListaCompra.find(".listaCompraItems .actual");
		if(actual.size()>0){
			var texto = actual.find(".item").text();
			if(texto!=textoNuevo){
				pedido.proceso.lista.cambiarItem(
					texto,
					textoNuevo,
					function(enCarro,cambiado){
						var actual = jqListaCompra.find(".listaCompraItems .actual");
						if(cambiado){
							actual.find(".item").html(textoNuevo).click();
							if(enCarro)
								actual.addClass("sel");
							else
								actual.removeClass("sel");
						}else{
							actual.remove();
							seleccionarItemTexto(textoNuevo);
						}
					}
				);
			}
		}else{
			jqListaCompra.find(".resultados input[name=q]").val(textoNuevo);
			actualizarResultados(textoNuevo);
		}
	};

	//Lanza la actualizacin automtica de los items en carro de la lista de compra 
	function lanzarActualizarItemsEnCarro(){
		nbf.lanzar(1000,actualizarItemsEnCarro);
	};

	//Actualiza los checks de los items en carro de la lista
	function actualizarItemsEnCarro(){
		pedido.proceso.lista.obtenerItems(
			function(respuesta){
				var lis = jqListaCompra.find(".listaCompraItems li");
				for(var i=0;i<respuesta.items.length;i++){
					if(respuesta.items[i].sel)
						lis.eq(i).addClass("selN");
				}
				lis.removeClass("sel").filter(".selN").addClass("sel").removeClass("selN");
			}
		);
	};
	
//	//Centra el item seleccionado en la lista
//	function centrarItemSelLista(){
//		var actual = jqListaCompra.find(".listaCompraItems .actual");
//		if(actual.size()==0)
//			actual = jqListaCompra.find(".listaCompraItems .items li:first");
//		if(actual.size()>0){
//			var items = actual.closest(".items");
//			var huecosVentana = 10;
//			var elemsAntes = actual.prevAll().size();
//			var elemsDespues = actual.nextAll().size();
//			var masTop=null,masBottom=null;
//			
//			if(elemsAntes+elemsDespues>=huecosVentana){ //compruebo si me cabe la lista
//				if(elemsAntes>=huecosVentana/2) //delante tengo ms huecos que ventana
//					masTop=true;
//				else
//					masTop=false;
//				if(elemsDespues>=huecosVentana/2) //detrs tengo ms huecos que ventana
//					masBottom=true;
//				else
//					masBottom=false;
//				
//				var itemColocar = null;
//				if(masTop && masBottom)
//					itemColocar = actual.prevAll().eq(4);
//				else{
//					if(masTop)
//						itemColocar = actual.prevAll().eq(8-elemsDespues);
//					else 
//						itemColocar = jqListaCompra.find(".listaCompraItems .items li:first");
//				}
//				moverAItemLista(itemColocar);
//			}else{
//				items.find(".inner").css("marginTop",0);
//				actualizarCssItems();
//			}
//		}
//	};
//	
//	//mueve el item pasado al top de la lista
//	function moverAItemLista(itemColocar){
//		if(itemColocar.size()>0){
//			itemColocar.siblings().removeClass("pri");
//			itemColocar.addClass("pri");
//			var items = itemColocar.closest(".items");
//
//			var ventana = items.closest(".inner");
//			items.animate(
//				{
//					"marginTop":-(itemColocar.offset().top-items.offset().top)
//				},
//				{
//					"complete":function(){
//						if(itemColocar.prevAll().size()>0)
//							ventana.addClass("masTop");
//						else
//							ventana.removeClass("masTop");
//						if(itemColocar.nextAll().size()>9)
//							ventana.addClass("masBottom");
//						else
//							ventana.removeClass("masBottom");
//						actualizarCssItems();
//					}
//				}				
//			);
//		}
//	};

//	//Despliega la lista de la compra actual
//	function desplegar(funcionOk,rapido){
//		if(jqListaCompra.hasClass("listaCompraMin")){
//			var tabComprado = jqListaCompra.find(".tabComprado");
//			tabComprado.hide();
//			var tabLista = jqListaCompra.find(".tabLista");
//			if(!tabLista.data("cssOrig"))
//				tabLista.data("cssOrig",{"width":tabLista.width()});
//			
//			var velocidad = 400;
//			if(rapido)
//				velocidad = 50;
//			
//			tabLista.find(".ini").fadeOut(
//				velocidad,
//				function(){
//					jqListaCompra.removeClass("listaCompraMin");
//					jqListaCompra.addClass("listaCompraMed");
//					tabLista.find(".main").hide();
//					if(!tabLista.data("cssDest"))
//						tabLista.data("cssDest",{"width":tabLista.width()});
//					
//					tabLista.css(tabLista.data("cssOrig")).css({"display":"block"});
//					jqListaCompra.find(".tabContent").hide().slideDown(
//						velocidad,
//						function(){
//							tabLista.animate(
//								tabLista.data("cssDest"),
//								{
//									"complete":function(){
//										tabLista.find(".main").fadeIn();
//										tabComprado.css({"margin-top":"60px"});
//										tabComprado.show();
//										tabComprado.animate({"margin-top":"0px"});
//										
//										var textarea = jqListaCompra.find("textarea");
//										if(!rapido && textarea.size()>0 && textarea.closest(".ePag4").size()==0)
//											textareaFocus(textarea);
//										if(funcionOk)
//											funcionOk();
//									},
//									"duration":velocidad
//								}
//							);
//						}
//					);
//				}
//			);
//		}else{
//			if(funcionOk)
//				funcionOk();
//		}
//	};

//	//Pliega la lista de la compra actual
//	function plegar(){
//		//[[PRODUCTOSVC]] eliminamos productos de venta cruzada
//		$(".productosVC").remove();
//		if(!$("body").hasClass("ePag4")){
//			if(!jqListaCompra.hasClass("listaCompraMin")){
//				var tabLista = jqListaCompra.find(".tabLista");
//				var tabComprado = jqListaCompra.find(".tabComprado");
//				tabLista.find(".main").fadeOut(
//					200,
//					function(){
//						jqListaCompra.find(".tabContent").slideUp(
//							200,
//							function(){
//								if(tabLista.hasClass("unsel"))
//									selTab(tabLista);
//								tabComprado.animate(
//									{
//										"margin-top":"60px"
//									},
//									{
//										"duration":200,
//										"complete":function(){
//											jqListaCompra.removeClass("listaCompraMed listaCompraMax");
//											//volvemos a mostrar content
//											ui.habilitarContent(true);
//											jqListaCompra.css("zIndex","inherit");
//											tabLista.find(".ini").hide();
//											jqListaCompra.addClass("listaCompraMin");
//											
//											tabLista.animate(tabLista.data("cssOrig"),{"duration":200});
//											tabLista.find(".ini").fadeIn(200);
//											jqListaCompra.find(".items .actual").removeClass("actual");
//											actualizarCssItems();
//										}
//									}
//								);
//							}
//						);
//					}
//				);
//			}
//		}else{
//			jqListaCompra.removeClass("listaCompraMax").addClass("listaCompraMed");
//			//volvemos a mostrar content
//			ui.habilitarContent(true);
//			jqListaCompra.css("zIndex","inherit");
//			jqListaCompra.find(".items .actual").removeClass("actual");
//			jqListaCompra.find(".productosComprados .sel").removeClass("sel");
//			actualizarCssItems();
//		}
//	};
	
	function selTab(jqTab){
		if(jqTab.hasClass("unsel")){
			jqTab.removeClass("unsel");
			jqTab.siblings().addClass("unsel");
			
			var jqTabCompradoContent = jqListaCompra.find(".tabCompradoContent");
			var jqTabListaContent = jqListaCompra.find(".tabListaContent");
			
			if(jqTab.hasClass("tabLista")){
				if(!jqTabListaContent.is(":visible"))
					jqTabListaContent.show();
				jqTabCompradoContent.hide();
				jqListaCompra.removeClass("listaCompraSelCompradas");
			}else{
				jqTabListaContent.hide();
				jqTabCompradoContent.show();
				
				if(!jqTabCompradoContent.hasClass("cargado")){ //slo se carga la primera vez
					pedido.proceso.lista.obtenerCategoriasCompradas(
						function(html){
							jqTabCompradoContent.addClass("cargado");
							jqTabCompradoContent.html(html);
							initCategoriasCompradas(jqTabCompradoContent);
						}
					);
				}
				jqListaCompra.addClass("listaCompraSelCompradas");
			}
		}else
			plegar();
	};
	
	//Inicializa la lista de compra completa
	function init(jq){
		jq.click(
			function(ev){
				if($(ev.target).hasClass("listaCompraMax"))
					plegar();
			}
		);
		
		jq.find(".listaCompraPlegar,.logo").click(
			function(ev){
				ev.preventDefault();
				if(jq.hasClass("listaCompraMin"))
					desplegar();
				else
					plegar();
			}
		);
		
		jq.find(".tabLista").click(
			function(ev){
				ev.preventDefault();
				if(jq.hasClass("listaCompraMin"))
					desplegar();
				else
					selTab($(this));
			}
		);
		
		jq.find(".tabComprado").click(
			function(ev){
				ev.preventDefault();
				selTab($(this));
			}
		);	
		
		initItems(jq.find(".listaCompraItems"));
	}

	nbf.ready(
		function(jq){
			if(jq.is("body")){
				jqListaCompra = jq.find(".header .listaCompra");
				if(jqListaCompra.size()>0){
					init(jqListaCompra);
				}
			}
		}
	);
	
	return {
		"lanzarActualizarItemsEnCarro":lanzarActualizarItemsEnCarro,
		"actualizarItemsEnCarro":actualizarItemsEnCarro,
		"seleccionarItemTexto":seleccionarItemTexto,
		"actualizarResultados":actualizarResultados,
		"actualizarListaCompra":actualizarListaCompra,
		"actualizarItems":actualizarItems
	};
}();