ui.pedido = ui.pedido || {};
ui.pedido.proceso = ui.pedido.proceso || {};
ui.pedido.proceso.pasoCompraDisponibilidadProducto = function(){
	//Obtiene los datos del paso de compra
	function obtenerDatos(jq){
		var idProducto = nbf.extraerDatos(jq.find(".bloqueSupCambio .bloqueProducto .item"));
		var alternativoSel = nbf.extraerDatos(jq.find(".bloqueSupAlternativos .item.sel"));
		var selCantidad = jq.find(".bloqueSeleccion .selCantidad");
		
		var esSuperOferta=0;
		if(jq.find(".bloqueSubCambio .bloqueProducto .tbSO"))
			esSuperOferta=1;
		var selCantidad = jq.find(".bloqueSeleccion .selCantidad");
		var cantidad = 0;
		if(selCantidad.size()>0)
			cantidad = selCantidad.val();
		
		var datos = {"cantidad":cantidad,"idProducto":idProducto,"alternativoSel":alternativoSel};
		
		return datos;		
	}
	
	//Inicializa el paso
	function init(jq){
		jq.find(".bloqueSupCambio .bloqueProducto a").unbind().click(
			function(ev){
				ev.preventDefault();
			}
		);
		ui.catalogo.listado.initRegalosSustitutivos(jq.find(".bloqueSupAlternativos .items"));
		ui.catalogo.listado.initProductos(jq.find(".bloqueSupAlternativos .items"));
	}
	
	return {
		"obtenerDatos":obtenerDatos,
		"init":init
	};
}();