//Asigna contenido al popup pasado
ui.popup.asignarContenido = function(jqPopup,contenido){
	jqPopup.find(".inner").eq(0).html(contenido);
//	jqPopup.find(".conjuntoControles .cancelar").click(
//		function(ev){
//			ev.preventDefault();
//			ui.popup.ocultar(jqPopup);
//			$(".seccionPrincipal").css("display","block");
//			$("body").css("overflow","hidden");
//				//mostramos de nuevo el contenido
//		}
//	);
};

ui.popup.iniciarPopupEspera = function (comienzo){
	ui.popup.crearEsperaBoton1("bolas","Cargando...","popup2 popupBotonEspera ti"+comienzo,"popupI","popupII");
	setTimeout(
		function(){
			var popup = $(".popupBotonEspera.ti"+comienzo);
			if (popup.size()>0){
				ui.popup.ocultar(popup);
			}
		},
		15000
	);
}

//Comprueba si tiene definida una variable de tiempo
//si la tiene lo cierra si transcurre menos del tiempo establecido espera hasta ese tiempo
//si es superior lo que tarde en cerrarse.
ui.popup.cerrarPopupEspera =function(){
	var maxTiempo =500;
	
	var popup = $(".popupBotonEspera");
	
	var estilos = popup.attr("class");
	var comienzo = estilos.match(/\d+$/);
	var fin = new Date().getTime();
	
	var tiempo = fin - comienzo[0];
		setTimeout(
			function(){
				ui.popup.ocultar(popup);	
			},
			(tiempo<maxTiempo)?maxTiempo-tiempo:tiempo
		);
}

ui.popup.cerrarCualquierPopupEspera = function(){
	var popup =$(".popupBotonEspera");
	ui.popup.ocultar(popup);
}

var fCrearAlerta = ui.popup.crearAlerta;
ui.popup.crearAlerta = function(htmlMensaje,funcionOk,claseCss,ocultarBody,param1,param2,titulo){
	var popup = fCrearAlerta(htmlMensaje,funcionOk,claseCss,ocultarBody,param1,param2,titulo);
	popup.css("zIndex",8000+ui.zIndex);
	popup.find(".btnOk").focus();
//	ui.links.init(popup);
	return popup;
};

var fCrearConfirmar = ui.popup.crearConfirmar;
ui.popup.crearConfirmar = function(htmlMensaje,funcionSi,funcionNo,ocultarBody,titulo){
	var popup = fCrearConfirmar(htmlMensaje,funcionSi,funcionNo,ocultarBody,titulo);
	popup.css("zIndex",8000+ui.zIndex);
	return popup;
};

//Crea un popup base
ui.popup.crearBase = function(claseCss,jqAncla,ocultarBody,param1,param2,titulo){
	var popup = ui.popup.crear($("<div />").addClass("inner"),claseCss,ocultarBody,param1,param2,titulo);
	if($(".despliegueFondo:visible").size()>0)
		popup.css("zIndex",8000+ui.zIndex);
	return popup;
};

//Crea un popup contextual
ui.popup.crearContextual = function(claseCss,jqAncla,ocultarBody,param1,param2){
	//Eliminamos cualquier otro popup contextual que haya (que no sea del ancla)
	$(".popupContextual").not(jqAncla.closest(".popupContextual")).remove();
	var popup = ui.popup.crearBase("popupContextual "+claseCss,jqAncla,ocultarBody,param1,param2);
	
	var css = {};
	//var anchoBody = $("body").width();
	//var posAncla = jqAncla.offset();
//	if(posAncla.left+jqAncla.width()+popup.width()+20>anchoBody){ //abrir con ancla derecha
//		css.left = Math.max(0,posAncla.left-popup.width());
//		popup.addClass("popupContextualR");
//	}else{ //abrir con ancla izquierda
//		css.left = posAncla.left+jqAncla.width();
//		popup.addClass("popupContextualL");
//	}
	//css.top = Math.max(posAncla.top+jqAncla.height()/2,132);
	popup.css(css);
	//aadimos el class para distinguir este link
	jqAncla.addClass("contextualAbierto");
	return popup;
};

//Crea un popup contextual de acciones
ui.popup.crearContextualAcciones = function(claseCss,jqAncla){
	return ui.popup.crearContextual("popupContextualAcciones "+claseCss,jqAncla);
};

//Crea un popup contextual de titulo
ui.popup.crearContextualTitulo = function(claseCss,jqAncla){
	return ui.popup.crearContextual("popupContextualTitulo "+claseCss,jqAncla);
};

//Crea un popup contextual de mensaje
ui.popup.crearContextualMensaje = function(jqAncla,claseCss){
	return ui.popup.crearContextualTitulo("popupContextualMensajeGenerico"+(claseCss?" "+claseCss:""),jqAncla);
}


//Elimina los popup contextuales que haya en pantalla
ui.popup.eliminarContextuales = function(){
	$(".popupContextual").remove();
	$(".sugerencias").remove();
};

//Crea un popup modal (funcionOk se pasa cuando queramos animar el popup y jqAncla cuando queramos abrir el popup desde un ancla)
ui.popup.crearModal = function(claseCss,funcionOk,jqAncla,ocultarBody,param1,param2,titulo){
	
	//eliminamos cualquier popup contextual que haya
	ui.popup.eliminarContextuales();
	//creamos el popup modal
	var popup = ui.popup.crearBase("popupModal "+claseCss,jqAncla,ocultarBody,param1,param2,titulo);
	popup.find(".btnCerrar").html("Volver");
//	popup.click(
//		function(ev){
//			var target = $(ev.target); 
//			if(target.hasClass("popupModal"))
//				ui.popup.ocultar(target);
//		}
//	);
	if(funcionOk){
		var popupCt = popup.find(".popupContent");
		//CSS de destino
		var css = {
//			"width":popupCt.width(),
//			"height":popupCt.height(),
//			"top":$(window).scrollTop()+popupCt.position().top,
//			"left":popupCt.offset().left
		};
		
		//popup.css("height",css.top+$("body").height());

		//hasta que termine la animacin aado esta clase al popup
		popup.addClass("popupModalAbriendo");
		
		if(jqAncla && jqAncla.is(":visible")){ //hay ancla, partimos de ella
			popupCt.css(
				{
//					"width":jqAncla.outerWidth(),
//					"height":jqAncla.outerHeight(),
//					"top":jqAncla.offset().top-popup.offset().top,
//					"left":jqAncla.offset().left,
//					"margin-left":0
				}
			);
		}else{ //no hay ancla, partimos del centro
			popupCt.css(
				{
//					"width":30,
//					"height":30,
//					"top":$(window).scrollTop()+$(window).height()/2,
//					"left":$("body").width()/2-15,
//					"margin-left":0
				}
			);
		}
		//popup.hide().fadeIn("fast");
		popupCt.animate(
			css,
			{
				"duration":500,
				"complete":function(){
					$(this).css("height","auto");
					//quito la clase de la animacin
//					if(ocultarBody){
//						//mostramos de nuevo el contenido
//						$(".seccionPrincipal").css("display","block");
//						$("body").css("overflow","hidden");
//					}
					popup.removeClass("popupModalAbriendo");
					funcionOk(popup);
					//recomputamos altura del popup en diferentes momentos por si no se ha cargado el contenido
					var fRecAltura = function(){
						ui.popup.actualizarAltura(popup);
					};
					setTimeout(fRecAltura,1000);
					setTimeout(fRecAltura,5000);
				}
			}
		);
	}
	//ui.historia.encolar(popup);
	return popup;
};

//Actualiza la altura del popup pasado (para fondos velados
ui.popup.actualizarAltura = function(jqPopup){
	if(jqPopup.closest("body").size()>0){
		//buscamos altura mxima de los popups abiertos
		//var jqPopupCt = jqPopup.find(".popupContent");
		//jqPopup.css("height",ui.alturaMaximaPagina());
		jqPopup.css("height",parseInt($(".popupInner").height())*2);
	}
};

//Crea un popup modal de NBML
ui.popup.crearModalNbml = function(claseCss,funcionOk,jqAncla){
	return ui.popup.crearModal("popupModalNbml nbml "+claseCss,funcionOk,jqAncla);
};

//Creacin de un modal de plantilla base
ui.popup.crearModalPlantillaBase = function(metodo,parametros,claseCss,jqAncla,funcionOk,mantenerAnteriores){
	if(!mantenerAnteriores)
		$(".popupModalPlantilla").remove();
	return ui.popup.crearModal(
		"popupModalPlantilla "+claseCss,
		function(popup){
			nbf.ejecutar(
				metodo,
				parametros,
				function(html){
					//movemos el scroll y el popup arriba para no perdernos si se abren ms niveles
					$(window).scrollTop(0);
					//popup.find(".popupContent").css("top","110px");
					ui.popup.asignarContenido(popup,html);
					nbf.init(popup);
					if(funcionOk)
						funcionOk(popup);
				}
			);
		},
		jqAncla,
		true,
		"popupI",
		"popupII"
	);
};

//Crea un popup modal de una plantilla (con contexto opcional)
ui.popup.crearModalPlantilla = function(claseCss,idPlantilla,jqAncla,funcionOk,contexto){
	//analytics.trackUrl("/plantilla"+idPlantilla);
	//\\control\\web\\pagina::ajaxPlantilla
	return ui.popup.crearModalPlantillaBase("\\appv1\\app::ajaxPlantilla",[idPlantilla,contexto],claseCss,jqAncla,funcionOk);
	
};

//Crea un popup modal de la plantilla que aplica a la URL pasada
ui.popup.crearModalPlantillaUrl = function(claseCss,url,jqAncla,funcionOk){
	//analytics.trackUrl(url);
	return ui.popup.crearModalPlantillaBase("\\control\\web\\pagina::ajaxPlantillaUrl",[url],claseCss,jqAncla,funcionOk);
};

//Crea un popup modal de la plantilla que aplica al contexto pasado
ui.popup.crearModalPlantillaContexto = function(claseCss,contexto,jqAncla,funcionOk){
	return ui.popup.crearModalPlantillaBase("\\control\\web\\pagina::ajaxPlantillaContexto",[contexto],claseCss,jqAncla,funcionOk);
};

//Crea un popup modal de formulario
ui.popup.crearModalFormulario = function(claseCss,funcionOk,jqAncla,ocultarBody,titulo){
	
	return ui.popup.crearModal("popupModalFormulario popup1 "+claseCss,funcionOk,jqAncla,ocultarBody,"popupI","popupII",titulo);
};
 
nbf.ready(
	function(jq){
		if(jq.is("body")){
			jq.click(
				function(ev){
					var target = $(ev.target);
					if(!target.hasClass("contextualAbierto")){
						//if(target.closest(".popupContextual").size()==0)
						//	ui.popup.eliminarContextuales();
					}else
						target.removeClass("contextualAbierto");
				}
			);
		}
	}
);
