ui ={};
//libreras para funcionalidad de UI
var ui = function(){
//contador de profundidad
zIndex = 1000;

	//Almacenamos el usuario en sessionStorage o en localStorage (permanente) dependiendo del check del login
	loginUsuario = function(idUsuario,firma,sessId,preferencias,redirectUrl,respuesta){
		
		almacenarSesion(idUsuario,firma,sessId,preferencias);
		if(redirectUrl!==null && redirectUrl!==undefined){
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				window.location=redirectUrl;
			}
			else{
				var reglas=usuario.procesarAccionesReglaGestion(
					respuesta,
					function(){
						window.location=redirectUrl;		
					}
				);	
			}
			
		}
		
	}

	mensajeSinConexion = function(){
		ui.popup.crearAlertaError("No puedes acceder a esta opcin sin conexin a internet",null,"Sin conexin internet");
		contenido.cargarPanelCentral();
	}
	/**
	 * Devuelve true si el usuario est logueado false si no o si la session ha caducado
	 */
	checkLoginUsuario = function (redirectUrl,funcionOk,funcionNoOk){
		//si hay login permanente y esta activo salimos
		//comprobamos si esta accediendo con la session pass almacenada sino tenemos que hacer el registro
		//permanente para registrar al usuario en el panel (ultimo Acceso usuario)
		try{
			//si hay variables de registro (idUsuario y firma) y no hay conexion lo dejamos pasar a principal.html
			
			if(st.obtenerLocalVar("idUsuario")!="" &&  st.obtenerLocalVar("firma")!="" 
					&& st.obtenerLocalVar("modoTrabajo")=="offline"){
				loginUsuario(st.obtenerLocalVar("idUsuario"),st.obtenerLocalVar("firma"),st.obtenerLocalVar("sessId"),st.obtenerLocalVar("preferencias"),null,null);
				funcionOk();
				return true;
			}
			else if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				//sacamos mensaje que no hay conexion 
				ui.formularioNoConexion("No puedes loguearte a la aplicacin sin conexin de internet");
			}
			else{
				//si NO tenemos variables de session almacenadas hacemos un login PERSISTENTE
				if((sessionStorage.getItem("idUsuario")===null || sessionStorage.getItem("idUsuario")===undefined
						) && st.obtenerLocalVar("idUsuario")!==undefined){
					nbf.ejecutar(
						"\\appv1\\app::ajaxLoginPersistente",
						[st.obtenerLocalVar("SOperativo"),st.obtenerLocalVar("SOVersion"),st.obtenerLocalVar("APPVersion"),st.obtenerLocalVar("uuidUser")],
						function (respuesta){
							if(respuesta.status=='ok'){
								//almacenamos la version de la aplicacion del servidor (ultima)
								if(respuesta.versionServer.resultado!="")
									st.establecerLocalVar("versionAPPServidor",respuesta.versionServer.resultado);
								else
									st.establecerLocalVar("versionAPPServidor","");
									
								//si tenemos una version antigua popup
								if(respuesta.versionOK!="" && respuesta.versionOK!==undefined && respuesta.versionOK!=null){
									st.establecerLocalVar("marketActualizar",respuesta.preferencias.market);
									formularioActualizacion(
										respuesta,
										function(){
											loginUsuario(respuesta.idUsuario,respuesta.firma,respuesta.sessId,respuesta.preferencias,null,respuesta);
											if(funcionOk){
												funcionOk();
											}
										}
									);
								}
								//si tenemos la version actualizada
								else{
									ui.loginUsuario(respuesta.idUsuario,respuesta.firma,respuesta.sessId,respuesta.preferencias,"principal.html",respuesta);
									if(funcionOk)
										funcionOk();
								}
							}
							//si no hay registro ok
							else{
								if(funcionNoOk)
									funcionNoOk();
							}
						}
					);
				}
				else{
				//Si SI que tenemos las variables de session 	
					if((st.obtenerLocalVar("idUsuario")!=="undefined" && (sessionStorage.getItem("idUsuario")!==null && sessionStorage.getItem("idUsuario")!==undefined)) 
							&& st.obtenerLocalVar("sessId")==sessionStorage.getItem("sessId")){
						return true;
					}
					else {
						return false;
						window.location="login.html";
					}
				}
			}
		}catch(e){
			alert(e.message);
			alert("se ha producido un error ");
			return false;
		}
	}

	/**
	 * Cierra la sesion del usuario para mandarlo al login
	 */
	logout = function(redirectUrl){
		ui.popup.crearConfirmar(
			"Est seguro que quiere salir de la sesion?",
			function(){
				st.eliminarLocalVar("idUsuario");
				st.eliminarLocalVar("sessId");
				st.eliminarLocalVar("firma");
				sessionStorage.removeItem("idUsuario");
				sessionStorage.removeItem("sessId");
				st.eliminarLocalVar("preferencias");
				sessionStorage.clear();
				window.location=redirectUrl;
			},
			null,
			false,
			"Cerrar sesin"
		);
	}
	actualizarCarro = function(){
		nbf.lanzar(
			200,
			function(ev){
				//refrescamos la cesta y si por algn motivo hemos avanzado en el proceso de pago, lo llevamos a la cesta de nuevo
				$(".bloqueIzquierdo").attr("class","bloqueIzquierdo");
				contenido.cargarBloqueIzquierdo();	
			}
		);
	}

	/**
	 * Si hay alguna modificacion de la firma o de la sesion se almacena en localStorage y sesionStorage.
	 */
	almacenarSesion =function(idUsuario,firma,sessId,preferencias){
		if(idUsuario!=st.obtenerLocalVar("idUsuario"))
			st.establecerLocalVar('idUsuario', idUsuario,'never');
		if(firma!=st.obtenerLocalVar("firma"))
			st.establecerLocalVar('firma', firma,'never');
		if(sessId!=st.obtenerLocalVar("sessId"));
			st.establecerLocalVar("sessId",sessId,'never');
		if(preferencias!=null){
			st.establecerLocalVar("preferencias",nbf.toJSON(preferencias),'never');
		}
		try{
			if(idUsuario!=sessionStorage.getItem("idUsuario"))
				sessionStorage.setItem("idUsuario",idUsuario);
			if(idUsuario!=sessionStorage.getItem("firma"))
				sessionStorage.setItem("firma",firma);
			if(idUsuario!=sessionStorage.getItem("sessId"))
				sessionStorage.setItem("sessId",sessId);
		}catch(e){
			sessionStorage.clear();
			if(idUsuario!=sessionStorage.getItem("idUsuario"))
				sessionStorage.setItem("idUsuario",idUsuario);
			if(idUsuario!=sessionStorage.getItem("firma"))
				sessionStorage.setItem("firma",firma);
			if(idUsuario!=sessionStorage.getItem("sessId"))
				sessionStorage.setItem("sessId",sessId);
		}
	}
	
	//crea el formulario de validar el codigo postal indicado
	formularioCodigoPostalValidar = function(mensaje,funcionContinuar){
		//creamos formulario
		var bloque = $("<div />");
		var botones = ui.popup.crearBotones("btnsAccion");
		bloque.addClass("c");
		bloque.append("<br/><span class='mensaje'>"+mensaje+"</div>");
		bloque.append('<input type="number" value="" maxlength="5" placeholder="xxxxx" class="campo codigoPostal" name="codigoPostal"/>');
		bloque.append(botones);
		var popup = ui.popup.crear(bloque,"popupAlerta popupCerrarButton popup2 popupCodigoPostal",false,"popupI","popupII");
		var titulo = popup.find(".btnsNav");
		titulo.append("<span class='titulo'>Validar C. Postal</span>");
		//aadimos botones
		botones.append(
			ui.popup.crearBoton(
				"Validar",
				"Ok",
				function(){		
					nbf.ejecutar(
						"\\appv1\\app::ajaxValidarCodigoPostal",
						[bloque.find("input[name=codigoPostal]").val()],
						function(respuesta){
							if(respuesta.status=="ok"){
								if(funcionContinuar)
									funcionContinuar();
							}
							else
								ui.popup.crearAlertaError(respuesta.mensajes,null,"Error en el cdigo postal");
						}
					);
				}
			)
		);
		
	}
	
	popupOlvidarContrasena = function(email){
		
		//creamos formulario
		var bloque = $("<div />");
		var botones = ui.popup.crearBotones("btnsAccion");
		bloque.addClass("c");
		bloque.append("<br/>" +
			"<div class='botonEnviar'>" +
				"<label>Email</label>" +
				"<input type='email' value='"+(email?email:"")+"' name='emailEnviar' placeholder='Introduce aqu tu email' />" +
			"</div>" +
			"<div class='mensaje'>" +
				"1.-Rellena tu email para poder enviarte instrucciones para recuperar tu contrasea. <br/><br/>" +
				" 2.-Si ya has recibido el email, introduce el cdigo recibido para recuperar la contrasea" +
			"</div><br/>");
		bloque.append(botones);
		
		var popup = ui.popup.crear(bloque,"popupAlerta popupCerrar popup2 popupEnviarContrasena",false,"popupI","popupII");
		var titulo = popup.find(".btnsNav");
		titulo.append("<span class='titulo'>Olvid la contrasea</span>");
		//aadimos botones
		botones.append(
			ui.popup.crearBoton(
				"Restablecer contrasea",
				"Si",
				function(){
					var emailEnviar=popup.find(".botonEnviar input").val();
					var comienzo = new Date().getTime();
					ui.popup.iniciarPopupEspera(comienzo);
					
					st.establecerLocalVar("emailUsuario",emailEnviar);
					if(emailEnviar){
						nbf.ejecutar(
							"\\appv1\\app::ajaxRestablecerPass",
							[emailEnviar],
							function(respuesta){
								if(respuesta.status=='ok'){
									ui.popup.cerrarPopupEspera();
									ui.popup.crearAlerta("Hemos enviado a tu email las instrucciones necesarias para cambiar la contrsea de tu acceso.  Recuerda revisar la carpeta de correo spam.",null,"popup2",false,"Email enviado");
									ui.popup.ocultar(popup);
									
								}
								else
									ui.popup.crearAlerta(respuesta.mensajes,null,"popup2",false,"Recuperar contrasea");
							}
						);
					}
					else
						ui.popup.crearAlerta("Debes escribir un email para poder restablecer la contrasea",null,"popup2",false,"Faltan datos");
				}
			)
		);
		
	}
	
	
	//crea el formulario de actualizacion de ir al market o de continuar en la aplicacion(si no es una actualizacion
	//bloqueante
	formularioActualizacion = function(respuesta,funcionContinuar){
		//creamos formulario
		var bloque = $("<div />");
		var botones = ui.popup.crearBotones("btnsAccion");
		bloque.addClass("c");
		bloque.append("<br/>"+respuesta.versionOK+"<br/>Est seguro que quiere continuar con esta versin?");
		bloque.append(botones);
		var popup = ui.popup.crear(bloque,"popupAlerta popupNoCerrarButton popup2",false,"popupI","popupII");
		var titulo = popup.find(".btnsNav");
		titulo.append("<span class='titulo'>Nueva actualizacin</span>");
		//aadimos botones
		botones.append(
			ui.popup.crearBoton(
				"Ir al Market",
				"Ok",
				function(){		
					window.plugins.ChildBrowser.showWebPage(respuesta.preferencias.market,
                            { showLocationBar: false });
				}
			)
		);
		if(respuesta.versionServer.bloqueante!=true){
			botones.append(
				ui.popup.crearBoton(
					"Continuar usando la aplicacion",
					"No",
					funcionContinuar
				)
			);
		}
	}
	
	//crea el formulario cuando no hay conexion a internet al iniciar la aplicacion y el usuario no se ha 
	//logueado hasta el momento
	formularioNoConexion = function(mensaje){
		//creamos formulario
		var bloque = $("<div />");
		var botones = ui.popup.crearBotones("btnsAccion");
		bloque.addClass("c");
		bloque.append('<div class="mensaje">'+mensaje+'</div>');
		bloque.append(botones);
		var popup = ui.popup.crear(bloque,"popupAlerta popupNoCerrarButton popup2",false,"popupI","popupII");
		var titulo = popup.find(".btnsNav");
		titulo.append("<span class='titulo'>Sin conexin de internet</span>");
		//aadimos botones
		botones.append(
			ui.popup.crearBoton(
				"Salir de la aplicacin",
				"Ok",
				function(){		
					navigator.app.exitApp();
				}
			)
		);
	}
	
	formularioCodigoPostal = function(respuesta,items,jqInput,jqHidden,jqCampo){
		var bloque = $(respuesta.html);
		bloque.addClass("sugerenciasCpl");
		bloque.find(".btnCerrarSug").hide();
		for(var i in items)
			bloque.find("li").eq(i).data({"l":items[i].l,"cp":items[i].cp});
		bloque.find("li").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				var datos = {};
				datos.l = $(this).data("l");
				datos.cp = $(this).data("cp");
				jqHidden.val(nbf.toJSON(datos));
				jqInput.val($(this).find(".tag").text());
				ui.popup.ocultar(popup);
			}
		).hover(
			function(){
				$(this).addClass("hover");
			},
			function(){
				$(this).removeClass("hover");
			}
		);
		
		var popup = ui.popup.crear(bloque,"popupAlerta popup2 popupCP",false,"popupI","popupII");
		popup.find(".btnCerrar").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				jqHidden.val("");
				jqInput.val("");
			}
		);
		var titulo = popup.find(".btnsNav");
		titulo.append("<span class='titulo'>Seleccione cdigo postal</span>");
	}
	
	/**
	 * Funcion que crea un boton estandar en el html
	 */
	botonHtml =function(className,titulo,visualizar,anchoCompleto){
		if(visualizar==null || visualizar==undefined)
			visualizar="";
		var classAncho="";
		if(anchoCompleto)
			classAncho="seccionAnchoCompleto";
		var html ='<a class="seccion '+classAncho+'">'+
					'<div class="seccionBoton '+className+''+ visualizar+'"><div class="divTxt"><em class="txt">'+titulo+'</em></div>'+
						'<div class="seccionIcono"><em class="ico"></em></div></div>'+
					'</a>';
		return html;
	}
	
	botonHuecoHtml = function (){
		var html ='<div style="float:left;width:100%"></div>';
		return html;
	}
	
	vibracionCorta = function(){
//		nbf.lanzar(
//			10,
//			function(){
//				if(st.obtenerLocalVar("SOVersion")!="pcVersion")
//					navigator.notification.vibrate(100);	
//			}
//		);
	}
		
	//da a un campo comportamiento de buscador de cdigo postal / localidad
	codigoPostalLocalidad = function(jqCampo){
		var jqHidden = jqCampo.find(".val");
		var jqInput = jqCampo.find(".txt");

		jqInput.attr("autocomplete","off");
		jqInput.focus(
			function(){
				jqInput.val("");
				jqHidden.val("");
			}	
		);
		
		jqInput.keyup(
			function(ev){
				var arriba = (ev.which==38);
				var abajo = (ev.which==40);
				var intro = (ev.which==13);
				if(arriba || abajo){ //flechas arriba / abajo
					var sel = jqCampo.find(".sugerencias li.hover");
					if(abajo && sel.next().size()>0)
						sel.removeClass("hover").next().addClass("hover");
					else if(arriba && sel.prev().size()>0)
						sel.removeClass("hover").prev().addClass("hover");
					else if(sel.size()==0)
						jqCampo.find(".sugerencias li").eq(0).addClass("hover");
				}else if(intro){
					var sel = jqCampo.find(".sugerencias li.hover");
					if(sel.size()>0){
						sel.click();
						$(this).blur();
					}
				}else{
					nbf.lanzar(
						300,
						function(){
							nbf.ejecutar(
								"\\appv1\\app::ajaxBuscarLocalidadCodigoPostal",
								[jqInput.val()],
								function(respuesta){
									jqCampo.find(".sugerencias").remove();
									var items = respuesta.items;
									if(items && items.length>0){
										formularioCodigoPostal(respuesta,items,jqInput,jqHidden,jqCampo);
									}
								}
							);
						}
					);

				}
			}
			
		);
		
	};
	
return {"checkLoginUsuario":checkLoginUsuario,
		"logout":logout,
		"loginUsuario":loginUsuario,
		"almacenarSesion":almacenarSesion,
		"actualizarCarro":actualizarCarro,
		"formularioActualizacion":formularioActualizacion,
		"formularioNoConexion":formularioNoConexion,
		'formularioCodigoPostalValidar':formularioCodigoPostalValidar,
		"codigoPostalLocalidad":codigoPostalLocalidad,
		"mensajeSinConexion":mensajeSinConexion,
		"vibracionCorta":vibracionCorta,
		"botonHtml":botonHtml,
		"botonHuecoHtml":botonHuecoHtml,
		"popupOlvidarContrasena":popupOlvidarContrasena};
}();

