ui.usuario= ui.usuario|| {};

ui.usuario.telefono = function(){
	//Edita / crea el telfono pasado
	function editar(idTelefono,funcionOk,jqAncla){
		ui.popup.crearModalFormulario(
			"popupEdicionTelefono",
			function(popup){
				nbf.ejecutar(
					"\\appv1\\app::ajaxFormularioEditarTelefono",
					[idTelefono],
					function(respuesta){
						if(respuesta.status=="ok"){
							ui.popup.asignarContenido(popup,respuesta.html);
							
							var fOk = function(){
								usuario.telefono.guardar(
									idTelefono,
									ui.form.obtenerValores(popup.find("form")),
									function(id){
										ui.popup.ocultar(popup);
										if(funcionOk)
											funcionOk(id);
									},
									function(mensajes){
										ui.popup.crearAlertaError(mensajes,null,"Error en telfono");
									}
								);
							};
							var fCancel =function(){
								ui.popup.ocultar(popup);
								ui.usuario.telefono.actualizar(jqAncla);
							}
							
							//ui.links.init(popup.find(".ayuda"));
							
							popup.find("form").submit(
								function(ev){
									ev.preventDefault();
									fOk();
								}
							);
							
							popup.find(".guardar").click(
								function(ev){
									ev.preventDefault();
									fOk();
								}
							);
							popup.find(".cancelar").click(
									function(ev){
										ev.preventDefault();
										fCancel();
									}
								);
						}else
							ui.popup.crearAlertaAdvertencia(nbf.txt.v("SESION_CADUCADA"));
					}
				);
			},
			jqAncla,
			true,
			"Aadir telfono"
		);
	}

	//actualiza la lista de telefonos
	function actualizar(jq){
		nbf.ejecutar(
			"\\appv1\\app::ajaxTelefonos",
			[],
			function(respuesta){
				if(respuesta.status="ok"){
					$(".seccionPrincipal").css("display","block");
					$("body").css("overflow","hidden");
					//alert(respuesta.html);
					var contenido =$(".pasoCompraContenido");
					contenido.html(respuesta.html);
					//jq.replaceWith(contenido);
					init(contenido);
				}else
					ui.popup.crearAlertaAdvertencia(nbf.txt.v("SESION_CADUCADA"));
			}
		);
	}

	//inicializa bloque de telfonos
	function init(jq){
		jq.find(".btnAdd").click(
			function(ev){
				ev.preventDefault();
				editar(
					null,
					function(){
						ui.usuario.telefono.actualizar(jq);
					},
					$(this)
				);
			}
		);
//		
		jq.find(".btnEdit").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				var idTelefono = nbf.extraerDatos($(this).closest("li"));
				editar(
					idTelefono,
					function(){
						ui.usuario.telefono.actualizar(jq);
					},
					$(this)
				);
			}
		);
		
		jq.find(".btnEliminar").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				var idTelefono = nbf.extraerDatos($(this).closest("li"));
				ui.popup.crearConfirmar(
					"Ests seguro que quieres eliminar el telfono?",
					function(){
						usuario.telefono.eliminar(
							idTelefono,
							function(){
								actualizar(jq);
							},
							function(mensajes){
								ui.popup.crearAlertaError(mensajes,null,"Error en telfono");
							}
						);
					},
					null,
					false,
					"Eliminar telfono"
				);
			}
		);
		
		var procesoCompra = jq.closest(".procesoCompra"); 
		if(procesoCompra.size()>0){
			var lisSel = jq.find("li.sel"); 
			lisSel.click(
				function(ev){
					ev.preventDefault();
					ev.stopPropagation();
					ui.vibracionCorta();
					var li = $(this);
					if(!li.hasClass("selCheck")){
						var idTelefono = nbf.extraerDatos(li);
						pedido.proceso.compra.seleccionarTelefono(
							idTelefono,
							function(){
								li.closest("ul").find("li").removeClass("selCheck");
								li.addClass("selCheck");
							}
						);
					}
				}
			).hover(
				function(){
					$(this).addClass("hover");
				},
				function(){
					$(this).removeClass("hover");
				}
			);
			
			//comprobamos si solo hay una direccin y la seleccionamos
			if(lisSel.size()==1)
				lisSel.click();
		}
	};
	
	return {
		"actualizar":actualizar,
		"init":init,
		"editar":editar
	};
}();

