var app = function(){
	function init(swiper,funcionOk){
		datosDispositivo();
		nbf.deviceReady(
			function(){
				ui.vibracionCorta();

				document.addEventListener(
					"backbutton", 
					function(){
						botonAtras(swiper);
					}, 
					false
				);
				document.addEventListener(
					"offline", 
					function(){
						 st.establecerLocalVar("modoTrabajo","offline");
						 nbf.init();
						 contenido.cargarBloqueIzquierdo();
						 contenido.cargarPanelCentral();
						 contenido.cargarBloqueDerecho();	
					},
					false
				);
				document.addEventListener(
					"online", 
					function(){
						 st.establecerLocalVar("modoTrabajo","online");
						 $(".contentPrincipal").attr("class","contentPrincipal");
						 contenido.cargarBloqueIzquierdo();
						 contenido.cargarPanelCentral();
						 contenido.cargarBloqueDerecho();	

						 //Envia los elementos de milista de la compra cuando recobra la conexion de internet si es que hay definidos
						 enviarListaCompraSinConexion();
					},
					false
				);
				
				//Al iniciar comprobamos si tenemos conexion de internet o no
				 var networkState = navigator.connection.type;
				 if(networkState=="none"){
					 //establece el modo de trabajo Offline
					 st.establecerLocalVar("modoTrabajo","offline");
				 }
				 else{
					 //establece el modo de trabajo Online
				   	st.establecerLocalVar("modoTrabajo","online");
				 }
			}
		);
		if(funcionOk)
			funcionOk();
	}

	function enviarListaCompraSinConexion(){
	 	var elemLista= nbf.parseJSON(st.obtenerLocalVar("miListaCompraElementosSinConexion"));
	   	if(elemLista!=""){
	   		var elementosTxt="";
			for(var i=0;i<elemLista.length;i++){
				elementosTxt += elemLista[i].elem.toString() +"\n";
			}
			nbf.ejecutar(
				"\\appv1\\app::ajaxAsignarItemsListaCompra",
				[elementosTxt],
				function (respuesta){
//					 $(".contentPrincipal").attr("class","contentPrincipal");
//					 $(".bloqueIzquierdo").attr("class","bloqueIzquierdo");
//					 $(".bloqueDerecho").attr("class","bloqueDerecho");
					 st.establecerLocalVar("miListaCompraElementosSinConexion",nbf.toJSON(null));
					 contenido.cargarBloqueIzquierdo();
					 contenido.cargarPanelCentral();
					 contenido.cargarBloqueDerecho();
				}
			);
	   	}
		else{
		   	 $(".contentPrincipal").attr("class","contentPrincipal");
			 $(".bloqueIzquierdo").attr("class","bloqueIzquierdo");
			 $(".bloqueDerecho").attr("class","bloqueDerecho");
			 nbf.init();
			 contenido.cargarBloqueIzquierdo();
			 contenido.cargarPanelCentral();
			 contenido.cargarBloqueDerecho();	
	   	}
	}
	function datosDispositivo(){
		nbf.deviceReady(
			function(){
				$("#dispositivo").html("Sistema operativo del dispositivo: "+device.platform +"<br/>");
				$("#dispositivo").html("Version de "+device.platform +": "+device.version);
				st.establecerLocalVar("SOperativo",device.platform);
				st.establecerLocalVar("SOVersion",device.version);
				st.establecerLocalVar("uuidUser",device.uuid);
			}
		);
		
	}
	return {"init":init,"datosDispositivo":datosDispositivo};
}();


botonAtras = function(swiper){
	if(swiper!==undefined){
		//diferente a principal
		if(swiper.activeIndex!=1){
			//pagina izquierda
			if(swiper.activeIndex==0){
				var clsIzq = $(".bloqueIzquierdo").attr("class").split(" ");
				if(clsIzq.length>1){
					$(".bloqueIzquierdo").attr("class","bloqueIzquierdo");
				}
				else
					swiper.swipeTo(1,500);
				
				contenido.cargarBloqueIzquierdo();
			}
			//pagina derecha
			if(swiper.activeIndex==2){
				var clsDer = $(".bloqueDerecho").attr("class").split(" ");
				if(clsDer.length>1){
					$(".bloqueDerecho").attr("class","bloqueDerecho");
					breadCrumbs.retrocederBreadCrumb("breadCrumbDerecho");
				}
				else
					swiper.swipeTo(1,500);

				contenido.cargarBloqueDerecho();	
			}
		}
		else{
			//si es la principal y estamos en inicio
			if($("#content").attr("class")=="contentPrincipal"){
				if($(".popupSalir").size()==0){
					ui.popup.crearConfirmar(
						"Salir de la aplicacin?",
						function(){
							navigator.app.exitApp();
						},
						null,
						false,
						"Salir"
					);
				}
			}
			//si estamos dentro de alguna categoria
			else{
				//deberamos retroceder con el breadcrumb
				breadCrumbs.retrocederBreadCrumb("breadCrumbPrincipal");
				//$("#content").attr("class","contentPrincipal");
				//contenido.cargarPanelCentral();
			}
		}
	}
	else{
		//alert($(".seccionRegistro").size());
		if($(".seccionRegistro").size()>0){
			window.location="login.html";
		}
		else{
			ui.popup.crearConfirmar(
				"Salir de la aplicacin?",
				function(){
					navigator.app.exitApp();
				},
				null,
				false,
				"Salir"
			);
		}
	}
}
