/**
 * cargar la pagina de inicio en el jq que se le pasa por funcion
 * jqPadre el contenedor padre
 * jqRes es el contenedor donde pintamos el resultado html 
 */
cargarContenidoInicio =function(jq,funcionDespues){
	var padreCentral = $(".contentPrincipal");
	var padreDerecho = $(".bloqueDerecho");
	
	var preferencias = st.obtenerLocalVar("preferencias");
	if(preferencias){
		var preferencias = nbf.parseJSON(preferencias);
	}
	var visualizar = st.obtenerLocalVar("modoTrabajo")=="offline"?" des":"";
	var html ='<div class="botonesMenu">';
		html +=ui.botonHtml("secMiLista","Mi lista de la compra","");
		html +=ui.botonHtml("secSueloC","Lo que suelo comprar",visualizar);
		html +=ui.botonHtml("secO","OFERTAS",visualizar);
		html +=ui.botonHtml("seccionCat","Categoras",visualizar);
		html +=ui.botonHtml("secCodigoB","Escanear cdigo de barras",visualizar);
		html +=ui.botonHtml("seccionRecetas","Recetas",visualizar);
		html +=ui.botonHtml("seccionNutricion","Nutricin",visualizar);
		//html +=ui.botonHuecoHtml();
		html +=ui.botonHtml("secCesta","Cesta de la compra",visualizar);
		html +=ui.botonHtml("secMiZona","Mi zona privada",visualizar);
		html +="</div>";
	
	html +='<div class="posicionATCTel"><a href="tel:900 103 282" class="botonTelefono telefonoATC"><div class="atencionCliente">Atencin al cliente<br/><em>900 103 282</em></div></a></div>';
	if(st.obtenerLocalVar("modoTrabajo")=="offline")
		html +="<center>SIN CONEXIN DE INTERNET</center>";
	jq.html(html);
	if(typeof(funcionDespues)=="function")
		funcionDespues();
	
	/**
	 * Boton de panel Ofertas
	 */
	jq.find(".secO").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				contenido.cambiarClass(padreCentral,"ofertas");
				contenido.cargarPanelCentral(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}
				);
			}
		}
	);
	/**
	 * Boton de Nutricion
	 * 
	 */
	jq.find(".seccionNutricion").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			var url="http://www.tudespensa.com/nutricion/";
			if(device.platform=="Android")
				navigator.app.loadUrl(url, {openExternal : true});
			else{
				var ref = window.open(url, 'nutricion', 'location=no');
			}
		}
	);
	/**
	 * Boton de Recetas
	 */
	jq.find(".seccionRecetas").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
//			contenido.cambiarClass(padreCentral,"recetasCategorias");
//			$(".contentPrincipal").attr("class","contentPrincipal recetas recetasCategorias");
//			contenido.cargarPanelCentral(
//				function(){
//					var comienzo = new Date().getTime();
//					ui.popup.iniciarPopupEspera(comienzo);
//				},
//				function(){
//					ui.popup.cerrarPopupEspera();
//				}
//			);
			
			contenido.cambiarClass(padreDerecho,"recetas recetasCategorias");
			contenido.cargarBloqueDerecho(
				function(){
					var comienzo = new Date().getTime();
					ui.popup.iniciarPopupEspera(comienzo);
				},
				function(){
					ui.popup.cerrarPopupEspera();
				}		
			);
			swiper.moverSwiper(2);
		}
	);
	
	/**
	 * Boton de Mi lista de la compra
	 */
	jq.find(".secMiLista").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			contenido.cambiarClass(padreDerecho,"miListaCompra");
			contenido.cargarBloqueDerecho(
				function(){
					var comienzo = new Date().getTime();
					ui.popup.iniciarPopupEspera(comienzo);
				},
				function(){
					ui.popup.cerrarPopupEspera();
				}		
			);
			swiper.moverSwiper(2);
//			$(".bloqueDerecho .btnNivel").removeClass("noActivo")
//			$(".bloqueDerecho .btnNivel").html(contenido.mensajeMenuZonaPrivada("Mi lista de la compra"));
		}
	);
	
	/**
	 * Boton Lo que suelo comprar
	 */
	jq.find(".secSueloC").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				contenido.cambiarClass(padreDerecho,"sueloComprar");
				contenido.cargarBloqueDerecho(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}		
				);
				nbf.initPrivada();
				swiper.moverSwiper(2);
//				$(".bloqueDerecho .btnNivel").removeClass("noActivo")
//				$(".bloqueDerecho .btnNivel").html(contenido.mensajeMenuZonaPrivada("Lo que suelo comprar"));
			}
		}
	);

	/**
	 * Boton de lector de codigo de barras
	 */
	jq.find(".secCodigoB").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				contenido.cambiarClass(padreCentral,"codigoBarras directo");
				contenido.cargarPanelCentral();
			}
		}
	);
	
	/**
	 * Boton de cesta de la compra
	 */
	jq.find(".secCesta").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				swiper.moverSwiper(0);
			}
		}
	);
	
	/**
	 * Boton de mi zona privada
	 */
	jq.find(".secMiZona").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				$(".bloqueDerecho").attr("class","bloqueDerecho");
				breadCrumbs.initBreadCrumb("breadCrumbDerecho");
				contenido.cargarBloqueDerecho(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}		
				);
				swiper.moverSwiper(2);
			}
		}
	);
	
	/**
	 * Boton mostrar Categorias del supermercado
	 */
	
	$(".seccionCat").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				contenido.cambiarClass(padreCentral,"categoriasLista");
				contenido.cargarPanelCentral(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}
				);
			}
		}
	);
}
