/**
 * Carga de contenidos HTML para MI LISTA DE LA COMPRA
 */
cargarMiListaCompra = function(jq,funcionDespues){
	if(st.obtenerLocalVar("modoTrabajo")=="offline"){
		var html ="";
		html+= "<div class='listaCompra' >";
		html+=		'<ul>';
		html+=			'<li class="add">';
		html+=				'<a href="#" class="anadir">';
		html+=				'<div class="txt"></div>';
		html+=				'</a><div class="bordeInput"><input type="text" class="txtInput" name="nuevoTexto2" placeHolder="Aadir producto ..." data-sel="no" /></div>';
		html+=				'<span class="nuevoElemento">';
		html+=				'<div class="txtNuevo"><input type="text" name="nuevoTexto" /></div>';
		html+=				'</span>';
		html+=			'</li>';
		var elementos = nbf.parseJSON(st.obtenerLocalVar("miListaCompraElementosSinConexion"));
		if(elementos!=""){
			for(var i=0;i<elementos.length;i++){
				if(elementos[i].elem!=undefined){
					html+='<li>';
					html+='<a class="imgCheck" href="#">marcar</a>';
					html+='<a class="del" href="#">eliminar</a>';
					html+='<a class="item" href="#">'+elementos[i].elem+'</a>';
					html+='</li>';
				}
			}
		}
		
		html+=		'</ul>';
		html+='</div>';
		
		var contenidoHtml = html;
		contenidoHtml=anadirBloqueResumen(contenidoHtml);
		contenidoHtml=anadirBloqueTutorialListaCompra(contenidoHtml);
		jq.html(contenidoHtml);
		//jq.removeClass("cargando");
		//$(".btnNivel").remove();
		
		if(funcionDespues){
			funcionDespues();
		}
		cargarMiListaCompraEventos(jq);	
	}
	else{
		cargarLocalTips();
		nbf.ejecutar(
			"\\appv1\\app::ajaxObtenerMiListaCompra",
			[],
			function (respuesta){
				if(respuesta.status=="ok"){
					var contenidoHtml = respuesta.html;
					contenidoHtml=anadirBloqueResumen(contenidoHtml);
					contenidoHtml=anadirBloqueTutorialListaCompra(contenidoHtml);
					jq.html(contenidoHtml);
					jq.removeClass("cargando");
					rellenarListaLocal(jq.find(".listaCompra ul"));
					cargarMiListaCompraEventos(jq);	
				}
			}
		);
		if(funcionDespues)
			funcionDespues();
		//tarea de actualizacion de lista cada 10 segundos si no se esta editando el input
		//en caso de estar editando el input la tarea se pospone 20 segundos
		actualizarLista(10000,20000);
	}
	breadCrumbs.initBreadCrumb("breadCrumbDerecho");
	breadCrumbs.anadirElemento("breadCrumbDerecho","miListaCompra","Mi lista de la compra");
	breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
}

actualizarLista = function(tiempo,tiempoEspera){
	nbf.lanzar(
		tiempo,
		function(ev){
			if(st.obtenerLocalVar("modoTrabajo")=="online" && $(".txtInput").hasClass("focus")==false)
				contenido.cargarBloqueDerecho();
			else
				actualizarLista(tiempoEspera);
		}
	);
}
//Carga los eventos de Mi lista de la compra
cargarMiListaCompraEventos = function(jq){
	jq.find(".txtInput").focus(
		function(ev){
			if($(this).data("sel")=="no")
				$(this).val("");
		}
	);
	
	jq.find(".txtInput").focusin(
		function(){
			$(this).addClass("focus");
		}
	);
	jq.find(".txtInput").focusout(
		function(){
			$(this).removeClass("focus");
		}
	);
	//evento cuando se pulsa intro cuando se escribe un producto en la lista de la compra
	jq.find(".txtInput").keyup(
		function(ev){
			if($(this).data("sel")=="no" && $(this).val().length>0)
				$(this).data("sel","si");
			else{
				if($(this).val()=="")
					$(this).data("sel","no");
			}
			if(ev.keyCode==13 ){
				var nuevoElem = jq.find(".listaCompra .txtInput").val();
				if(nuevoElem!="")
					anadirElementoHTML(nuevoElem,jq.find(".listaCompra ul"));
				$(".txtInput").blur();
				$(".txtInput").focus();
				
			}
		}
	);
	//cuando se pulsa en borrar un elemento de la lista de la compra
	jq.on(
		'click',
		'.del',
		function(){
			var elementoHtml = $(this).closest("li");
			var elementoText =elementoHtml.find(".item").text();
			var elementos = nbf.parseJSON(st.obtenerLocalVar("miListaCompraElementosSinConexion"));
			elementoHtml.remove();
			setTimeout(
				function(){
					eliminarElementoBBDD(elementos,elementoText);
				},
				800
			);
		}
	);
	//Cuando se hace click en un elemento para buscarlo para comprar
	jq.on(
		'click',
		'.item,listaCompra .imgCheck',
		function(ev){
			//'.item:not(.enCarro),listaCompra .imgCheck:not(.checked)',
			ev.preventDefault();
			if((st.obtenerLocalVar("modoTrabajo")=="online")){
				var valorBuscar= $(this).text();
				$(".cuadroBuscar input[name=inputBusqueda]").val(valorBuscar);
				cabecera.lanzarBusqueda($(".headerFixed"));
				swiper.moverSwiper(1);
			}
		}
	);
	
	//Cuando pulsamos aadir elemento en la lista de la compra
	jq.on(
		'click',
		'.listaCompra ul li .anadir',
		function(ev){
			ev.preventDefault();
			if(jq.find(".listaCompra .txtInput").data("sel")=="si" && jq.find(".listaCompra .txtInput").val()!=""){
				var nuevoElem = jq.find(".listaCompra .txtInput").val();
				anadirElementoHTML(nuevoElem,jq.find(".listaCompra ul"));
				jq.find(".nuevoElemento input[name=nuevoTexto]").focus();
			}
		}
	);
	
	//Para borrar todos los elementos de la lista de la compra
	jq.find(".resumen .delTodos").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			//seleccionamos todos menos el primer elelemento que es el input
			ui.popup.crearConfirmar(
				"Quieres eliminar todo lo que has escrito?",
				function(){
					jq.find(".listaCompra ul li:not(:first-child)").remove();
					setTimeout(
						function(){
							eliminarElementosTodos();
						},
						800
					);
				},
				null,
				false,
				"Mi lista de la compra"
			);
		}
	);
	
	
	
	//aadimos el bloque html del nuevo item
	anadirElementoHTML = function(nuevoElem,destino){
		//comprobamos que este elemento no este en la lista y hacemos la cadena de todos
		//los productos de la lista para agregarlos
		var existe =false;
		var totalElementos = {};
		totalElementos =obtenerTotalElementos(destino,nuevoElem); 
		
		//insertar elem en el panel
		var htmlElem = "<li>";
		htmlElem +=			"<a class='imgCheck' href='#'></a>";
		htmlElem +=			"<a class='del' href='#'>eliminar</a>";
		htmlElem +=			"<a class='item' href='#'>";
		htmlElem +=				nuevoElem;
		htmlElem +=			"</a>";
		htmlElem +=		"</li>";
		
		if(totalElementos.existe==false){
			destino.append(htmlElem);
			
			totalElementos.totalElem +=nuevoElem+"\n";
			jq.find(".nuevoElemento").css("display","none");
			jq.find(".nuevoElemento input[name=nuevoTexto]").val("");
			$(".txtInput").val("");
			
			nbf.lanzar(
				1000,
				function(ev){
					//lanzar la adicion del producto en la lista de la compra
					if(st.obtenerLocalVar("modoTrabajo")!="offline")
						anadirElementoBBDD(totalElementos.elems,nuevoElem);
						
					anadirElementoLocal(totalElementos.elems,nuevoElem);
				}
			);
		}
	}
	
	obtenerTotalElementos = function(destino,nuevoElem){
		var existe=false;
		var totalElementos="";
		var result2={};
		var elems=[];
		destino.find("li").each(
			function(ev){
				var objElem ={};
				if($(this).find(".item").text()!=""){
					totalElementos +=$(this).find(".item").text()+"\n";
					objElem.elem=$(this).find(".item").text();
					objElem.checked=($(this).find(".checked").size()>0);
					elems.push(objElem);
				}
				if(nuevoElem){
					if($(this).find(".item").text()==nuevoElem){
						existe=true;
					}
				}
			}
		);
		result2.existe=existe;
		result2.elems=elems;
		return result2;
	}
	//aade el elemento en el array de elementos que en cuanto haya conexion seran subidos al servidor
	anadirElementoLocal =function(elementos,nuevoElem){
		var objElem ={};
		objElem.elem=nuevoElem;
		objElem.checked=false;
		elementos.push(objElem);
		st.establecerLocalVar("miListaCompraElementosSinConexion",nbf.toJSON(elementos));
	}
	//aade el elemento directamente en el servidor
	anadirElementoBBDD = function(elementos,nuevoElem){
		var elementosTxt="";
		var objElem ={};
		objElem.elem=nuevoElem;
		objElem.checked=false;
		elementos.push(objElem);
		for(var i=0;i<elementos.length;i++){
			elementosTxt += elementos[i].elem.toString() +"\n";
		}
		nbf.ejecutar(
			"\\appv1\\app::ajaxAsignarItemsListaCompra",
			[elementosTxt],
			function (respuesta){
			}
		);
	}
	
	eliminarElementoBBDD = function(elementos,elemBorrar){
		var elementos = nbf.parseJSON(st.obtenerLocalVar("miListaCompraElementosSinConexion"));
		for(var i=0;i<elementos.length;i++){
			if(elementos[i].elem==elemBorrar){
				elementos.splice(i,1);
			}
		}
		st.establecerLocalVar("miListaCompraElementosSinConexion",nbf.toJSON(elementos));
		if(st.obtenerLocalVar("modoTrabajo")=="online"){
			nbf.ejecutar(
				"\\appv1\\app::ajaxEliminarItemListaCompra",
				[elemBorrar],
				function (respuesta){
				}
			);
		}
	}
	marcarElemento = function(elemModificar,valor){
		var elementos =nbf.parseJSON(st.obtenerLocalVar("miListaCompraElementosSinConexion"));
		for(var i=0;i<elementos.length;i++){
			if(elementos[i].elem==elemModificar){
				elementos[i].checked=valor;
			}
		}
		st.establecerLocalVar("miListaCompraElementosSinConexion",nbf.toJSON(elementos));
	}
}


//Funcion que elimina todos los elementos de mi lista de la compra
eliminarElementosTodos = function(){
	st.establecerLocalVar("miListaCompraElementosSinConexion",nbf.toJSON(null));
	var elementosTxt = "";
	if(st.obtenerLocalVar("modoTrabajo")=="online"){
		nbf.ejecutar(
			"\\appv1\\app::ajaxAsignarItemsListaCompra",
			[elementosTxt],
			function (respuesta){
			}
		);
	}
}

//Funcion que elimina todos los elementos de mi lista de la compra marcados
eliminarElementosMarcados = function(){
	var elementos =nbf.parseJSON(st.obtenerLocalVar("miListaCompraElementosSinConexion"));
	var elementosTxt = "";
	for(var i=0;i<elementos.length;i++){
		if(elementos[i].checked==false){
			elementosTxt +=elementos[i].elem+"\n";
		}
	}
	nbf.ejecutar(
		"\\appv1\\app::ajaxAsignarItemsListaCompra",
		[elementosTxt],
		function (respuesta){
		}
	);
}

//comprueba si existe un elemento en la lista, devuelve "" si no existe y 1 si es true o 0 si es false el check de 
//marcado
existeElemento = function(elementos,elem){
	
	var encontrado="";
	for(var i=0;i<elementos.length;i++){
		if(elementos[i]){
			if(elementos[i].elem!=""){
				if(elementos[i].elem==elem){
					encontrado=(elementos[i].checked?"1":"0");
				}
			}
		}
	}
	return encontrado;
}


//Rellenamos la variable del local storage con el listado obtenido
rellenarListaLocal = function(destino){
	st.establecerLocalVar("miListaCompraElementosSinConexion",nbf.toJSON(null));
	var result={};
	var elems=[];
	destino.find("li").each(
		function(ev){
			var objElem ={};
			if($(this).find(".item").text()!=""){
					objElem.elem=$(this).find(".item").text();
					objElem.checked=($(this).find(".checked").size()>0);
					elems.push(objElem);
			}
		}
	);
	result.elems = elems;
	result.existe=false;
	st.establecerLocalVar("miListaCompraElementosSinConexion",nbf.toJSON(result.elems));
}
//Compone el objeto que se almacena en localStorage "miListaCompraElementosSinConexion"
//segn lo que se extrae de la vista mas lo que tenga almacenado en el localstorage.
componerObjElementos = function(destino){
	var result={};
	var elems=[];
	var totalElementos ="";
	var elementos =nbf.parseJSON(st.obtenerLocalVar("miListaCompraElementosSinConexion"));
	for (var i=0;i<elementos.length;i++){
		if(elementos[i]){
			if(elementos[i].elem!=null){
				var objElem ={};
				objElem.elem=elementos[i].elem;
				objElem.checked=elementos[i].checked;
				elems.push(objElem);
			}
		}
	}
	destino.find("li").each(
		function(ev){
			var objElem ={};
			if($(this).find(".item").text()!=""){
				var res = existeElemento(elementos,$(this).find(".item").text());
				if(res==""){
					objElem.elem=$(this).find(".item").text();
					objElem.checked=($(this).find(".checked").size()>0);
					elems.push(objElem);
				}
				else{
					if(res=="1"){
						$(this).find(".imgCheck").addClass("checked");
						$(this).find(".item").addClass("enCarro");
					}
					else{
						$(this).find(".imgCheck").removeClass("checked");
						$(this).find(".item").removeClass("enCarro");
					}
						
				}
			}
		}
	);
	result.elems = elems;
	result.existe=false;
	st.establecerLocalVar("miListaCompraElementosSinConexion",nbf.toJSON(result.elems));
}

//funcion que carga los mensajes local tips que se definen en esta ventan
cargarLocalTips=function(){
	var className = $(".bloqueDerecho").attr("class");
	var local =localTips.obtenerLocalTips();
	localTips.cargarLocalTips(
		"bloqueDerecho miListaCompra",
		1,
		"Crea tu lista de la compra y comprtela con otra persona. " +
			"Solamente tienes que comprartir la cuenta de acceso al sistema para estar sincronizados. " +
			"Si una persona aade un elemento a la lista de la compra la otra persona tambin lo ver reflejado en su " +
			"aplicacin.<br/><center><img src='img/listacompra2.jpg' /></center>",
		"Mi lista de la compra"
	);
}
//aade el bloque de resumen de eliminacion de los productos de la lista
anadirBloqueResumen = function(html){
	html+='<div class="resumen">';
	html+=		'<a href="#" class="delTodos">';
	html+=			'<div style="vertical-align:top;display:inline-block;">Borrar todos</div>';
	html+=		'</a>';
	html+='</div>';
	return html;
}

//aade un bloque de como funciona mi lista de la compra
anadirBloqueTutorialListaCompra =function(html){
	if(st.obtenerLocalVar("modoTrabajo")=="offline")
		html+="<div style='padding-top:10px;text-align:center'>MODO SIN CONEXION DE INTERNET (en cuanto recobre la conexion comunicar toda la lista de la compra a su cuenta para que est disponible desde cualquier dispositivo)</div>";
	html +="<div class='miListaBloqueInfo' ></div>";
	return html;
}
/**
 * Carga de contenidos HTML para LO QUE SUELO COMPRAR
 */
cargarSueloComprar = function(jq,funcionDespues){
	nbf.ejecutar(
		"\\appv1\\app::ajaxLoQueSueloComprar",
		[],
		function (respuesta){
			if(respuesta.status=="ok"){
				jq.html(respuesta.html);
				jq.removeClass("cargando");
				if(funcionDespues)
					funcionDespues();
				cargarSueloComprarEventos(jq);
				breadCrumbs.initBreadCrumb("breadCrumbDerecho");
				breadCrumbs.anadirElemento("breadCrumbDerecho","sueloComprar","Suelo comprar","Lo que suelo comprar");
				breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
			}
		}
	);
}
	
cargarSueloComprarEventos =function (jq){
	
	if(jq.find(".productosComprados .sinCompra").size()>0){
		var bloque=$(".bloqueDerecho .contenidoBloque");
		bloque.html("<div class='mensaje'>No ha realizado ningn pedido todava</div>");
	}
	jq.find(".itemCatLink").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var valorBuscar = $(this).closest(".itemCat").find(".tag").html();
			$(".cuadroBuscar input[name=inputBusqueda]").val(valorBuscar);
			cabecera.lanzarBusqueda($(".headerFixed"));
			swiper.moverSwiper(1);
		}
	);
	
}