/**
 * cargar la informacion del blque derecho de mi cuenta
 */
cargarBloqueDerecho = function(jq,funcionDespues){
	var preferencias = st.obtenerLocalVar("preferencias");
	if(preferencias){
		var preferencias = nbf.parseJSON(preferencias);
	}
	var visualizar = st.obtenerLocalVar("modoTrabajo")=="offline"?" des":"";
	var html ='<div class="bloqueInformacion">'+	
	'<div class="breadCrumbs btnNivel">'+
	'</div>'+
	'<div class="contenidoBloque contenidoInformacion">';
	html +='<div class="botonesMenu">';
	html +=ui.botonHtml("seccionMisDatos","Mis datos",visualizar);
	html +=ui.botonHtml("seccionMisRecomendados","Mis recomendados",visualizar);
	html +=ui.botonHtml("seccionMisPedidos","Mis pedidos",visualizar);
	html +=ui.botonHtml("seccionMisDescuentos","Mis descuentos",visualizar);
	html +=ui.botonHtml("seccionMisSO","Mis super-ofertas reservadas",visualizar);
	html +=ui.botonHtml("secMisGastos","Mi bono de gastos de envo",visualizar);
	html +=ui.botonHtml("secMisCuponesP","Mis cupones de Descuento",visualizar);
	
	if(preferencias)
		if(preferencias.botones.volverMostrarAyudas==1)
			html +=ui.botonHtml("secAyudas","Volver a mostrar Ayudas",visualizar);
	
	html +=ui.botonHtml("seccionLogout","Logout",visualizar);
	
	html +='</div>'+
	'	<div class="mobileVersion">'+
	'		<div class="versionAPPTexto">'+
	'			Versin de TuDespensa APP: <span class="versionAPP valor">0.0</span>'+
	'		</div>'+
	'		<div class="dispositivoSO">'+
	'			Sistema Operativo del dispositivo: <span class="dispositivoSOValor valor">Android</span>'+
	'		</div>'+
	'		<div class="dispositivoVersion">'+
	'			Versin: <span class="dispositivoVersionValor valor">Version 4.1</span>'+
	'		</div>'+
	'	</div>'+
	
	'</div>';
	html +='</div>';
	jq.html(html);
	
	breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
	
	if(funcionDespues){
		funcionDespues();
	}
	
	try{
		var preferencias = st.obtenerLocalVar("preferencias");
		if(preferencias){
			var preferencias = nbf.parseJSON(preferencias);
		}
		
		var versionAPP = st.obtenerLocalVar("APPVersion");
		
		var versionAPPServidor = st.obtenerLocalVar("versionAPPServidor");
		
		
		if(!versionAPPServidor)
			$(".bloqueDerecho .mobileVersion .versionAPP").html(versionAPP);
		else{
			var marketHref = st.obtenerLocalVar("marketActualizar");
			$(".bloqueDerecho .mobileVersion .versionAPP").html(st.obtenerLocalVar("APPVersion")+" <a class='actualizarVersion' href='"+st.obtenerLocalVar("marketActualizar")+"'>Actualizar a version "+versionAPPServidor+"</a>");
		}
		
		if(st.estadoLocalVar("SOperativo")==1){
			$(".bloqueDerecho .mobileVersion .dispositivoSOValor").html(st.obtenerLocalVar("SOperativo"));
			$(".bloqueDerecho .mobileVersion .dispositivoVersionValor").html(st.obtenerLocalVar("SOVersion"));
		}
		else{
			$(".bloqueDerecho .mobileVersion .dispositivoSOValor").html("Version de escritorio");
			$(".bloqueDerecho .mobileVersion .dispositivoVersionValor").html("0.0.0");
		}
	}
	catch(e){
		$(".bloqueDerecho .mobileVersion .dispositivoSOValor").html("Version de escritorio");
		$(".bloqueDerecho .mobileVersion .dispositivoVersionValor").html("0.0.0");
	}
	if(st.obtenerLocalVar("modoTrabajo")=="online"){
		nbf.ejecutar(
			"\\appv1\\app::ajaxCargarInfoUsuario",
			[],
			function(respuesta){
				if(respuesta.status=='ok'){
					$(".bienvenidoText").html(respuesta.nombre);
					ui.almacenarSesion(st.obtenerLocalVar("idUsuario"),respuesta.firma,respuesta.sessId);
				}
				else
					ui.popup.crearAlerta("Error al registrarse el usuario",null,"popup2",false,"Error registro");
			}
		);
	}
	
	//eventos de la pantalla derecha
	jq.find(".seccionMisDatos").click(
		function(ev){
			if(ev.handled!==true){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				if(st.obtenerLocalVar("modoTrabajo")=="offline"){
					ui.mensajeSinConexion();
				}
				else{
					contenido.cambiarClass($(".bloqueDerecho"),"misDatos");
					contenido.cargarBloqueDerecho(
						function(){
							var comienzo = new Date().getTime();
							ui.popup.iniciarPopupEspera(comienzo);
						},
						function(){
							ui.popup.cerrarPopupEspera();
						}							
					);
				}
				ev.handled=true;
			}
		}
	);

	jq.find(".seccionMisRecomendados").click(
		function(ev){
			if(ev.handled!==true){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				if(st.obtenerLocalVar("modoTrabajo")=="offline"){
					ui.mensajeSinConexion();
				}
				else{
					contenido.cambiarClass($(".bloqueDerecho"),"misRecomendados");
					contenido.cargarBloqueDerecho(
						function(){
							var comienzo = new Date().getTime();
							ui.popup.iniciarPopupEspera(comienzo);
						},
						function(){
							ui.popup.cerrarPopupEspera();
						}							
					);
				}
				ev.handled=true;
			}	
		}
	);
	jq.find(".seccionMisDescuentos").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				contenido.cambiarClass($(".bloqueDerecho"),"misDescuentos");
				contenido.cargarBloqueDerecho(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}							
				);
			}
		}
	);
	jq.find(".seccionMisPedidos").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				contenido.cambiarClass($(".bloqueDerecho"),"misPedidos");
				contenido.cargarBloqueDerecho(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}				
				);
			}
		}
	)		
	jq.find(".seccionLogout").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else
				ui.logout("login.html");
		}
	);
	
	jq.find(".seccionMisSO").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				contenido.cambiarClass($(".bloqueDerecho"),"misSuperOfertas");
				contenido.cargarBloqueDerecho(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}						
				);
				nbf.initPrivada();
			}
		}
	);
	
	jq.find(".secMisGastos").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				contenido.cambiarClass($(".bloqueDerecho"),"miBonoGastos");
				contenido.cargarBloqueDerecho(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}							
				);
				nbf.initPrivada();
			}
		}
	);
	
	jq.find(".secMisCuponesP").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				contenido.cambiarClass($(".bloqueDerecho"),"misCuponesP");
				contenido.cargarBloqueDerecho(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}							
				);
				nbf.initPrivada();
			}
		}
	);
	
	jq.find(".secAyudas").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			if(st.obtenerLocalVar("modoTrabajo")=="offline"){
				ui.mensajeSinConexion();
			}
			else{
				localTips.eliminarLocalTips();
				initLocalTips();
				ui.popup.crearAlerta(
					"Las ayudas volvern a ser visibles en las pantallas correspondientes",
					null,
					"popup2",
					false,
					"Ayudas activadas"
				);
			}
		}
	);
	
	jq.find(".secLocalTips").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			ui.vibracionCorta();
			var local =localTips.obtenerLocalTips();
			var num= local.length;
			ui.popup.crearAlertaOk("nmero de elementos "+ num + "; "+local,null,"");
		}
	);
}



