//CLASES PARA GENERAR POPUPS EMERGENTES
ui.popup = {};




ui.popup.crearEsperaBoton1 = function(tipo,texto,claseCss,param1,param2){
	
	var bloque = $("<div />");
	var mensaje = $("<div />");
	bloque.addClass("c");
	mensaje.addClass("mensaje");
	//si nos pasan Array lo convertimos a UL
	var mensajeHtml="<br/>";
	if(tipo=="bolas"){
		mensajeHtml +='	<div class="windows8">'+
			'<div class="wBall" id="wBall_1">'+
			'<div class="wInnerBall">'+
			'</div>'+
			'</div>'+
			'<div class="wBall" id="wBall_2">'+
			'<div class="wInnerBall">'+
			'</div>'+
			'</div>'+
			'<div class="wBall" id="wBall_3">'+
			'<div class="wInnerBall">'+
			'</div>'+
			'</div>'+
			'<div class="wBall" id="wBall_4">'+
			'<div class="wInnerBall">'+
			'</div>'+
			'</div>'+
			'<div class="wBall" id="wBall_5">'+
			'<div class="wInnerBall">'+
			'</div>'+
			'</div>'+
			'</div> ';
	}
//	if(imagenUrl)
//		mensajeHtml += "<img src='"+imagenUrl+"' />";
	if(texto)
		mensajeHtml +="<br/>"+ texto;

	mensaje.html(mensajeHtml);
	
	
	bloque.append(mensaje);
	var popup = ui.popup.crear(bloque,"popupBotonEspera popupAlerta"+(claseCss?" "+claseCss:""),null,param1,param2);
	
	return popup;
};

ui.popup.crearEsperaBoton = function(imagenUrl,texto,claseCss,param1,param2){
	
	var bloque = $("<div />");
	var mensaje = $("<div />");
	bloque.addClass("c");
	mensaje.addClass("mensaje");
	//si nos pasan Array lo convertimos a UL
	var mensajeHtml="";
	if(imagenUrl)
		mensajeHtml += "<img src='"+imagenUrl+"' />";
	if(texto)
		mensajeHtml +="<br/>"+ texto;

	mensaje.html(mensajeHtml);
	
	
	bloque.append(mensaje);
	var popup = ui.popup.crear(bloque,"popupBotonEspera popupAlerta"+(claseCss?" "+claseCss:""),null,param1,param2);
	
	return popup;
};

ui.popup.botonPopup =function(className,titulo){
	var html ='<a class="seccionPopup">'+
	'<div class="seccionBotonPopup '+className+''+ visualizar+'"><div class="divTxt"><em class="txt">'+titulo+'</em></div>'+
		'<div class="seccionIcono"><em class="ico"></em></div></div>'+
	'</a>';
	return html;
}



/**
 * Crea un mensaje de alerta con botn de ok
 * @param string htmlMensaje Mensaje a mostrar
 * @param function funcionOk Funcin a ejecutar al pulsar sobre "ok" (opcional)
 * @param string claseCss Clase css adicional para el popup
 * @return jQuery Popup recin creado
 */
ui.popup.crearAlerta = function(htmlMensaje,funcionOk,claseCss,ocultarBody,titulo){
	var param1 = "popupI";
	var param2 = "popupII";
	if(ocultarBody){
		//cambiamos los estilos para ocultar el body
		$(".seccionPrincipal").css("display","none");
		$("body").css("overflow","auto");
		//cambiamos los estilos
	}
	
	var bloque = $("<div />");
	var mensaje = $("<div />");
	bloque.addClass("c");
	mensaje.addClass("mensaje");
	//si nos pasan Array lo convertimos a UL
	if($.isArray(htmlMensaje)){
		if($.isPlainObject(htmlMensaje[0])){
			var msgs = [];
			for(var i in htmlMensaje)
				msgs.push(htmlMensaje[i].mensaje);
			htmlMensaje = msgs; 
		}
		htmlMensaje = "<ul><li>"+htmlMensaje.join("</li><li>")+"</li><ul>";
	}
	mensaje.html(htmlMensaje);
	var botones = ui.popup.crearBotones("btnsAccion");
	bloque.append(mensaje);
	bloque.append(botones);
	var popup = ui.popup.crear(bloque,"popupAlerta"+(claseCss?" "+claseCss:""),null,param1,param2);
	if(titulo){
		var btnsNav = popup.find(".btnsNav");
		var titulo = "<span class='titulo'>"+titulo+"</span>";
		btnsNav.append(titulo);
	}
	botones.append(
		ui.popup.crearBoton(
			"Aceptar",
			"Ok",
			function(){
				ui.popup.ocultar(popup);
				ui.vibracionCorta();
				if(ocultarBody){
					//mostramos de nuevo el contenido
					$(".seccionPrincipal").css("display","block");
					$("body").css("overflow","hidden");
				}
				if(funcionOk)
					funcionOk();
			}
		)
	);
	
	$(".txtPrueba").focus(
		function(ev){
			ev.preventDefault();
			var pos = $(this).offset().top;
			//var pos = $(this).offset().top;
			$(window).scrollTop(pos);
		}
	);
	if(ocultarBody){
		popup.height(parseInt(popup.height())*2);
		alert(popup.height());
	}
	return popup;
};

/**
 * Crea un mensaje de alerta de error con botn de ok
 * @param string htmlMensaje Mensaje a mostrar
 * @param function funcionOk Funcin a ejecutar al pulsar sobre "ok" (opcional)
 * @return jQuery Popup recin creado
 */
ui.popup.crearAlertaError = function(htmlMensaje,funcionOk,titulo){
	return ui.popup.crearAlerta(htmlMensaje,funcionOk,"popupAlertaError popup2",false,titulo);
};

/**
 * Crea un mensaje de alerta de advertencia con botn de ok
 * @param string htmlMensaje Mensaje a mostrar
 * @param function funcionOk Funcin a ejecutar al pulsar sobre "ok" (opcional)
 * @return jQuery Popup recin creado
 */
ui.popup.crearAlertaAdvertencia = function(htmlMensaje,funcionOk){
	return ui.popup.crearAlerta(htmlMensaje,funcionOk,"popupAlertaAdvertencia");
};

/**
 * Crea un mensaje de alerta ok con botn de ok
 * @param string htmlMensaje Mensaje a mostrar
 * @param function funcionOk Funcin a ejecutar al pulsar sobre "ok" (opcional)
 * @return jQuery Popup recin creado
 */
ui.popup.crearAlertaOk = function(htmlMensaje,funcionOk,titulo){
	return ui.popup.crearAlerta(htmlMensaje,funcionOk,"popupAlertaOk popup2",false,titulo);
};

/**
 * Crea un mensaje de confirmacin con opciones si/no
 * @param string htmlMensaje Mensaje a mostrar
 * @param function funcionSi Funcin a ejecutar al pulsar sobre "si"
 * @param function funcionNo Funcin a ejecutar al pulsar sobre "no" (opcional)
 * @return jQuery Popup recin creado
 */
ui.popup.crearConfirmar = function(htmlMensaje,funcionSi,funcionNo,ocultarBody,titulo){
	var param1 = "popupI";
	if(titulo=="Salir")
		param1+=" popupSalir";
	
	var param2 = "popupII";
	var bloque = $("<div />");
	var mensaje = $("<div />");
	mensaje.addClass("mensaje");
	mensaje.html(htmlMensaje);
	
	var botones = ui.popup.crearBotones("btnsAccion");
	bloque.addClass("c");
	bloque.append(mensaje);
	bloque.append(botones);
	var popup = ui.popup.crear(bloque,"popupConfirmar popup2",ocultarBody,param1,param2);
	if(titulo){
		var btnsNav = popup.find(".btnsNav");
		var titulo = "<span class='titulo'>"+titulo+"</span>";
		btnsNav.append(titulo);
	}
	botones.append(
		ui.popup.crearBoton(
			"SI",
			"Si",
			function(){
				ui.popup.ocultar(popup);
				ui.vibracionCorta();
				funcionSi();
				$(".seccionPrincipal").css("display","block");
				$("body").css("overflow","hidden");
			}
		)
	);
	botones.append(
		ui.popup.crearBoton(
			"NO",
			"No",
			function(){
				ui.vibracionCorta();
				if(funcionNo){
					funcionNo();
				$(".seccionPrincipal").css("display","block");
				$("body").css("overflow","hidden");
				}
				else
					ui.popup.ocultar(popup);
					$(".seccionPrincipal").css("display","block");
					$("body").css("overflow","hidden");
			}
		)
	);
	return popup;
};

/**
 * Crea un mensaje de confirmacin con opciones si/no
 * @param string htmlMensaje Mensaje a mostrar
 * @param array opciones Lista de objetos con atributos "texto", "css" y "funcion"
 * @return jQuery Popup recin creado
 */
ui.popup.crearOpciones = function(htmlMensaje,opciones){
	var bloque = $("<div />");
	var mensaje = $("<div />");
	mensaje.addClass("mensaje");
	mensaje.html(htmlMensaje);
	var botones = ui.popup.crearBotones("btnsAccion");
	bloque.append(mensaje);
	bloque.append(botones);
	var popup = ui.popup.crear(bloque,"popupOpciones");
	for(var i=0;i<opciones.length;i++){
		botones.append(
			ui.popup.crearBoton(
				opciones[i].texto,
				opciones[i].css,
				opciones[i].funcion
			)
		);
	}
	return popup;
};

/**
 * Crea un conjunto de botones para popup
 */
ui.popup.crearBotones = function(claseCss){
	var botones = $("<div />");
	botones.addClass("btns");
	if(claseCss)
		botones.addClass(claseCss);
	return botones;
};

/**
 * Crea un boton para popup
 */
ui.popup.crearBoton = function(etiqueta,tipo,funcionClick){
	var className="test";
	var contenido='<div class="seccionBotonPopup '+className+'">'+
						'<div class="divTxt"><em class="txt">'+etiqueta+'</em></div>'+
						'<div class="seccionIcono"><em class="ico"></em></div>'
					'</div>';
	
	var btn = $('<a href="#"></a>');
	btn.addClass("btn btn"+tipo+" seccionPopup" );
	btn.html(contenido);
	btn.click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			funcionClick(ev,$(this));
		}
	);
	return btn;
};

/**
 * Previsualiza la imagen pasada en un popup
 * @param string URL de la imagen
 */
ui.popup.crearImagen = function(urlImagen,claseCss){
	var img = $("<img />");
	img.attr("src",urlImagen);
	img.load(
		function(){
			if($(this).width()>$(window).width())
				$(this).attr("width",$(window).width()-100);
			else if($(this).height()>$(window).height())
				$(this).attr("height",$(window).height()-100);
			var p = $(this).closest(".popupImagen");
			p.css("position","absolute");
			p.css("top",$(window).scrollTop()+20);
			p.css("left","50%");
			p.css("margin","0 0 0 -"+parseInt(p.width()/2)+"px");
			$(this).click(
				function(){
					ui.popup.ocultar(p);
				}
			);
		}
	);
	ui.popup.crear(img,"popupImagen"+(claseCss?" "+claseCss:""));
};

/**
 * Previsualiza una URL en una ventana mediante un iframe. Devuelve el id de la ventana creada
 * @param string url URL a abrir
 * @param string claseCss Clase CSS a aplicar sobre la ventana
 * @return string Id de la ventana recien creada
 */
ui.popup.crearUrl = function(url,claseCss){
    var bloque = $("<div />");
    var cargando = $("<div />");
    cargando.addClass("cargando");
    var iframe = $("<iframe />");
    iframe.attr("frameBorder",0);
    bloque.append(cargando);
    bloque.append(iframe);
    iframe.load(
    	function(){
    		cargando.remove();
    	}
    );
    iframe.attr("src",url);
    return ui.popup.crear(bloque,claseCss);
};

/**
 * Muestra un popup con el cdigo HTML pasado
 * @param string htmlInterno HTML interior
 * @param string claseCss Clase CSS a aplicar al div exterior
 */
ui.popup.crearHtml = function(htmlInterno,claseCss){
    return ui.popup.crear($(htmlInterno),claseCss);
};

/**
 * Muestra un popup con el nodo pasado
 * @param jQuery jq Nodo DOM a incluir
 * @param string claseCss Clase CSS a aplicar al div exterior
 * @return string Id de la ventana recien creada
 */
ui.popup.crear = function(jq,claseCss,ocultarBody,param1,param2,titulo){
	if(ocultarBody){
		//cambiamos los estilos para ocultar el body
		$(".seccionPrincipal").css("display","none");
		$("body").css("overflow","auto");
		//cambiamos los estilos
	}
	var popup = $("<div />");
	popup.attr("id",nbf.generarIdAleatorio());
    popup.addClass("popup");
    popup.addClass(claseCss);
    popup.css("z-index",ui.zIndex++);
    
    var popupContent = $("<div />");
    popupContent.addClass("popupContent");
    
    var botones = ui.popup.crearBotones("btnsNav");
    var btnCerrar = $("<a />");
    btnCerrar.attr("href","#");
    btnCerrar.html("Close"); //evitamos acceder a BDD
    btnCerrar.addClass("btn btnCerrar");
	btnCerrar.click(
    	function(ev){
    		ev.preventDefault();
    		ui.popup.ocultar(popup);
    		ui.vibracionCorta();
    		if(ocultarBody){
				//mostramos de nuevo el contenido
				$(".seccionPrincipal").css("display","block");
				$("body").css("overflow","hidden");
			}
    			
    	}
    );
    botones.append(btnCerrar);
    if(titulo){
		var titulo = "<span class='titulo'>"+titulo+"</span>";
		botones.append(titulo);
	}
    
    if(param1 && param2){
    	 var popupParam1 = $("<div />");
    	 popupParam1.addClass(param1);
    	 var popupParam2 = $("<div />");
    	 popupParam2.addClass(param2);
    	 popupParam2.append(popupContent);
    	 popupParam1.append(popupParam2);
    	 popup.append(popupParam1);
    	 
    	 
    }
    else{
    	popup.append(popupContent);	
    }   
    popupContent.append(botones);
    popupContent.append(jq);
    
    var preferencias = st.obtenerLocalVar("preferencias");
    preferencias = nbf.parseJSON(preferencias);
     if(preferencias){
     	if(preferencias.header.subirAltoHeader){
     		popup.find(".popupContent").css("margin-top","20px");
     	}
     }
    ui.popup.mostrar(popup);
       return popup;
};

/**
 * Muestra por pantalla un contenido Jq
 * @param jQuery jq Nodo jQuery a incluir
 */
ui.popup.mostrar = function(jq){
	$("body").append(jq);
	jq.show();
	nbf.init(jq);
};

/**
 * Oculta/elimina un contenido Jq
 * @param jQuery jq Nodo jQuery a ocultar
 */
ui.popup.ocultar = function(jq){
	jq.remove();
};

/**
 * Obtiene el popup al que pertenece el elemento pasado
 * @param jQuery jq Elemento perteneciente a popup
 * @return jQuery Popup al que pertenece
 */
ui.popup.obtenerPopup = function(jq){
	if(jq.hasClass("popup"))
		return jq;
	else
		return jq.closest(".popup").eq(0);
};