nbf.txt = {};

nbf.txt.textos = [];

/**
 * Obtiene el valor de una variable
 * @param string variable Variable a obtener
 * @return string Valor de la variable
 */
nbf.txt.v = function(variable){
	if(!nbf.txt.textos[variable]){
		nbf.txt.textos[variable] = nbf.ejecutarSync(
			"\\appv1\\app::ajaxObtenerVariable",
			[variable]
		);
	} 
	return nbf.txt.textos[variable].var;
};

/**
 * Define una variable
 * @param string variable Variable a asignar
 * @param string variable Valor de la variable a asignar
 */
nbf.txt.vDef = function(variable,valor){
	nbf.txt.textos[variable] = valor;
};