//pedido = pedido || {};
//pedido.proceso = pedido.proceso || {};
//

carro = function() {
	function pintarCesta(respuestaAjax,cantidad){
		$(".bloqueIzquierdo").html(respuestaAjax.html);
		if(respuestaAjax.totalProductos>0){
			var tituloCesta =$(".bloqueIzquierdo .bloqueInformacion .tituloInformacion");
			tituloCesta.html(tituloCesta.html()+ " ("+ respuestaAjax.totalProductos+ " productos seleccionados)");
			$(".header .numElemCarro").show();
			$(".header .numElemCarro span").text(respuestaAjax.totalProductos);
			if(cantidad){
				if(cantidad>respuestaAjax.cantidad){
				//si la cantidad devuelta por el servidor es menor que la cantidad que pretendiamos almacenar, refrescamos los productos
					contenido.cargarPanelCentral(null,null);
				}
			}
		}
		else{
			$(".header .numElemCarro").hide();
			$(".header .numElemCarro span").text("");
		}
		nbf.initCesta();
	}
	
	// Incluye un producto en el proceso de compra
	function cambiarCantidadProductoAJAX(idProducto, cantidad, idOfertaFlash,
			desdeVentaCruzada, qContexto, funcionOk, funcionCantidadNoDisp,
			funcionError,noRepintar) {
		nbf.ejecutar("\\appv1\\app::ajaxCambiarCantidadProducto", [ idProducto,
				cantidad, false, idOfertaFlash, desdeVentaCruzada, qContexto ],
				function(respuesta) {
					if (respuesta.status == "ok") {
						if (funcionOk) {
							funcionOk(respuesta);
							//repintamos la cesta con el html devuelto por CambiarCantidadProducto
							if(noRepintar){
								//	alert("no pintamos");
							}
							else
								carro.pintarCesta(respuesta,cantidad);
							//contenido.cargarBloqueDerecho();
						} else {
							if (respuesta.cantidadNoDisp
									&& funcionCantidadNoDisp)
								funcionCantidadNoDisp(respuesta.cantidad);
							
						}
						usuario.procesarAccionesReglaGestion(respuesta);
					} else {
						if (funcionError) {
							funcionError(respuesta.mensajes);
						}
					}
				});
	}

	/**
	 * Control que aade una unidad al carro y luego llama a la funcion ajax de
	 * servidor, funcionFin es por si queremos hacer algo justo despues de
	 * aadir al carro. parametro unitaria si cada peticion se hace por separado
	 * o se agrupa en un lanzar en caso contrario
	 */
	function anadirUnidadCarro(jqProducto, funcionFin, unitaria) {
		var cantidadAnterior = (jqProducto.find(".uds").text()).split("Uds")[0];
		if (cantidadAnterior == "")
			cantidadAnterior = 0;
		var idProducto = nbf.extraerDatos(jqProducto);
		if(jqProducto.hasClass("on"))
			contenido.cambiarClass($(".contentPrincipal"),"buscar on-"+idProducto);
		var nuevaCantidad = parseInt(cantidadAnterior) + 1;
		jqProducto.find(".uds").html(
				nuevaCantidad + " <span class='ud'>Uds</span>");
		if (unitaria == true) {
			cambiarCantidadProductoAJAX(idProducto, nuevaCantidad, null, null,
					null, funcionFin);
		} else {
			nbf.lanzar2(500,
				function(ev) {
					cambiarCantidadProductoAJAX(idProducto, nuevaCantidad, null,
						null, null, function() {
//						ui.actualizarCarro();
						if(funcionFin)
							funcionFin();	
					}
					);
				},
				idProducto
			);
		}
	}

	function quitarUnidadCarro(jqProducto,quitarLinea,funcionFin) {

		if (jqProducto.hasClass("ofer"))
			esOfertaFlash = true;
		var cantidadAnterior = (jqProducto.find(".uds").text()).split("Uds")[0];
		var idProducto = nbf.extraerDatos(jqProducto);
		var nuevaCantidad = parseInt(cantidadAnterior) - 1;
//		if (nuevaCantidad < 0) {
//			if(quitarLinea)
//				jqProducto.remove();
//			eliminarProductoCarro(jqProducto,null,funcionFin);
//		} else {
		jqProducto.find(".uds").html(
			nuevaCantidad + " <span class='ud'>Uds</span>");
		nbf.lanzar2(
			500, 
			function(ev) {
				cambiarCantidadProductoAJAX(idProducto, nuevaCantidad, null,
					null, null,
					function(){
//						ui.actualizarCarro();
					if(funcionFin)
						funcionFin();
					}
				);
			},
			idProducto
		);
//		}
	}

	// Incluye los productos pasados (pares idProducto y cantidad)
	function incluirProductosAJAX(productos, funcionOk, funcionError) {
		nbf.ejecutar("\\appv1\\app::ajaxIncluirProductos", [ productos ],
			function(respuesta) {
				if (respuesta.status == "ok") {
					if (funcionOk)
						funcionOk(respuesta.mensaje);
				} else {
					if (funcionError)
						funcionError(respuesta.mensajes);
				}
			}
		);
	}

	// Bloque de control de eliminar el producto del carro que luego llama a la
	// funcion ajax de servidor
	function eliminarProductoCarro(jqProducto, borrarLinea,funcionFin) {
		var cantidadAnterior = (jqProducto.find(".uds").text()).split("Uds")[0];
		var idProducto = nbf.extraerDatos(jqProducto);
		var esOfertaFlash = false;
		if (jqProducto.find(".idOfer").size() > 0)
			esOfertaFlash = true;
		var importe = 0;
		if (esOfertaFlash == false)
			importe = jqProducto.find(".importeP").text().split("")[0];
		else
			importe = jqProducto.find(".pvp").text().split("")[0];

		importe = importe.replace(",", ".");
		var totalCesta = $(".totalCesta strong").text().split("")[0];
		totalCesta = totalCesta.replace(",", ".");

		var nuevoTotalTxt = "";
		var nuevoTotal = parseFloat(totalCesta) - parseFloat(importe);
		nuevoTotal = nuevoTotal.toFixed(2);
		if (nuevoTotal == 0)
			nuevoTotalTxt = "0,00";
		else
			nuevoTotalTxt = nuevoTotal.toString().replace(".", ",");

		$(".totalCesta strong").html(nuevoTotalTxt + " <em></em>");

		if (borrarLinea == true)
			jqProducto.remove();

		eliminarProductoAJAX(idProducto, esOfertaFlash, 
			function(){
				if(funcionFin)
					funcionFin();	
				contenido.cargarPanelCentral();
			}
		);
	}

	// Elimina el producto del carro de la compra
	function eliminarProductoAJAX(idProducto, esOfertaFlash, funcionOk) {
		nbf.ejecutar(
			"\\appv1\\app::ajaxEliminarProducto",
			[idProducto,esOfertaFlash ],
			function(respuesta) {
				if (respuesta) {
					if (funcionOk)
						funcionOk();
				}
			}
		);
	}
	
	// Vaca el carro de la compra actual
	function eliminarProductosAJAX(funcionOk) {
		nbf.ejecutar(
			"\\appv1\\app::ajaxVaciarCarro", 
			[],
			function(respuesta) {
				if (respuesta) {
					if (funcionOk)
						funcionOk();
				}
			}
		);
	}

	return {
		"quitarUnidadCarro" : quitarUnidadCarro,
		"anadirUnidadCarro" : anadirUnidadCarro,
		"eliminarProductoCarro" : eliminarProductoCarro,
		"eliminarProductosAJAX" : eliminarProductosAJAX,
		"cambiarCantidadProductoAJAX" : cambiarCantidadProductoAJAX,
		"pintarCesta" :pintarCesta
	};
}();