pedido ={};
pedido.proceso = pedido.proceso || {};
pedido.proceso.compra = {};

//Cancela la compra actual
pedido.proceso.compra.cancelarCompra = function(funcionOk){
	nbf.ejecutar(
		"\\appv1\\app::ajaxCancelarCompra",
		[],
		function(respuesta){
			if(respuesta.status=="ok"){
				if(funcionOk)
					funcionOk(respuesta.url);
			}
		}
	);
};

//Incluye / elimina un cupn descuento en el proceso de compra
pedido.proceso.compra.incluirCuponDescuento = function(idCuponDescuento,incluir,funcionOk,funcionError){
	nbf.ejecutar(
		"\\appv1\\app::ajaxIncluirCuponDescuento",
		[idCuponDescuento,incluir],
		function(respuesta){
			if(respuesta.status=="ok"){
				if(funcionOk)
					funcionOk();
			}else{
				if(funcionError)
					funcionError(respuesta.mensajes);
			}
		}
	);
};

//Selecciona la direccin de entrega pasada para el proceso de compra actual
pedido.proceso.compra.seleccionarDireccionEntrega = function(idDireccion,funcionOk){
	nbf.ejecutar(
		"\\appv1\\app::ajaxSeleccionarDireccionEntrega",
		[idDireccion],
		function(respuesta){
			if(respuesta.status=="ok"){
				if(funcionOk)
					funcionOk();
			}	
		}
	);
};

//Selecciona el telfono pasado para el proceso de compra actual
pedido.proceso.compra.seleccionarTelefono = function(idTelefono,funcionOk){
	nbf.ejecutar(
		"\\appv1\\app::ajaxSeleccionarTelefono",
		[idTelefono],
		function(respuesta){
			if(respuesta.status=="ok"){
				if(funcionOk)
					funcionOk();
			}	
		}
	);
};

//Selecciona la fecha de entrega para el proceso de compra actual
pedido.proceso.compra.seleccionarFechaEntrega = function(fecha,idHorarioEntrega,funcionOk){
	nbf.ejecutar(
		"\\appv1\\app::ajaxSeleccionarFechaEntrega",
		[fecha,idHorarioEntrega],
		function(respuesta){
			if(respuesta.status=="ok"){
				if(funcionOk)
					funcionOk();
			}
		}
	);
};

//Selecciona la forma de pago para el proceso de compra actual
pedido.proceso.compra.seleccionarFormaPago = function(idFormaPago,funcionOk){
	nbf.ejecutar(
		"\\appv1\\app::ajaxSeleccionarFormaPago",
		[idFormaPago],
		function(respuesta){
			if(respuesta.status=="ok"){
				if(funcionOk)
					funcionOk();
			}
		}
	);
};

//Confirma definitivamente el pago via paypal de un pedido
pedido.proceso.compra.confirmarPedidoPagoPaypal = function(idPedido,token,payerId,funcionOk,funcionError){
	nbf.ejecutar(
		"\\appv1\\app::ajaxConfirmarPedidoPagoPaypal",
		[idPedido,token,payerId],
		function(respuesta){
			if(respuesta.status=="ok"){
				if(funcionOk)
					funcionOk(respuesta.url);
			}else{
				if(funcionError)
					funcionError(respuesta.mensajes);
			}
		}
	);
};

//Cancela la modificacin de pedido actual
pedido.proceso.compra.modificarPedidoCancelar = function(funcionOk,funcionError){
	nbf.ejecutar(
		"\\appv1\\app::ajaxModificarPedidoCancelar",
		[],
		function(respuesta){
			if(respuesta.status=="ok"){
				if(funcionOk){
					funcionOk(respuesta.url);
				}
			}else{
				if(funcionError)
					funcionError(respuesta.mensajes);
			}
		}
	);
};

//Obtiene el contenido del paso siguiente
pedido.proceso.compra.obtenerContenidoPaso = function(nombrePaso,reservandoEntrega,funcionOk,funcionCambiarPaso){
	nbf.ejecutar(
		"\\appv1\\app::ajaxProcesoPagoPaso",
		[nombrePaso,reservandoEntrega],
		function(respuesta){
			if(respuesta.status=="ok"){
				cargarProgreso(nombrePaso);
				funcionOk(respuesta.html);
				//procesamos acciones de reglas de gestin por si hay algo pendiente
				usuario.procesarAccionesReglaGestion(respuesta);
			}else if(respuesta.paso)
				funcionCambiarPaso(respuesta.paso);
		}
	);
};
cargarProgreso =function(nombrePaso){
	var ancho ="";
	switch (nombrePaso){
		case "pasoCompraUpselling":
			ancho= 15;
		case "pasoCompraCompletarDatos":
			ancho =20;
		break;
		case "pasoCompraDireccionCrear":
			ancho=25;
		break;
		case "pasoCompraDireccionSeleccionar":
			ancho=25;
		break;
		case "pasoCompraTelefonoCrear":
			ancho=35;
		break;
		case "pasoCompraTelefonoSeleccionar":
			ancho=35;
		break;
		case "pasoCompraFechaEntrega":
			ancho=50;
		break;
		case "pasoCompraDisponibilidadProducto":
			ancho=55;
		break;
		case "pasoCompraCuponesDescuento":
			ancho=63;
		break;
		case "pasoCompraSeleccionarRegalos":
			ancho=66;
		break;
		case "pasoCompraFormaPago":
			ancho=70;
		break;
	
	}
	
	if($(".procesoCompra .progreso").size()>0){
		$(".procesoCompra .progreso").remove();
	}
	var anchoTxt = ancho +"%";
	var faltante = 100- ancho;
	var progreso = $("<div class='progreso'>Te falta "+faltante+"% para terminar<span><em></em></span></div>");
	
	$(".procesoCompra").prepend(progreso);
	$(".progreso span em").width(ancho+"%");
 				
}
//Obtiene el nombre del paso anterior
pedido.proceso.compra.pasoAnterior = function(nombrePasoActual,reservandoEntrega,funcionOk,funcionSinPaso){
	
	nbf.ejecutar(
		"\\appv1\\app::ajaxProcesoPagoPasoAnterior",
		[nombrePasoActual],
		function(respuesta){
			if(respuesta.status=="ok"){
				funcionOk(respuesta.paso);
			}
			else
				funcionSinPaso();
		}
	);
};

//Obtiene el nombre del paso anterior
pedido.proceso.compra.confirmarPaso = function(nombrePaso,reservandoEntrega,datos,funcionOk,funcionError,funcionCambiarPaso){
	nbf.ejecutar(
		"\\appv1\\app::ajaxProcesoPagoConfirmarPaso",
		[nombrePaso,datos,reservandoEntrega],
		function(respuesta){
			if(respuesta.status=="ok")
				funcionOk(respuesta.siguiente,respuesta);
			else{
				if(respuesta.paso)
					funcionCambiarPaso(respuesta.paso,respuesta.mensajes);
				else if(respuesta.mensajes)
					funcionError(respuesta.mensajes);
				else
					dbg(respuesta);
			}
		}
	);
};
