var breadCrumbs = function(){
zIndex = 9999;
//Hacemos el objeto myBreadCrumb global y accesible en el codigo
	//var myBreadCrumb=[];
	//tendremos un json con titulo y valor y tipo
	//si es busqueda 
	//titulo lo que queremos mostrar
	//valor el valor concreto 
	//tipo podra ser busqueda o pagina
	//busqueda - para ir cargando productos de la busqueda
	//pagina - para cargar directamente con un cargarContenido poniendo el class correspondiente a inicio.
	//{"pagina":[{"titulo":"Inicio","valor":""}]},{"pagina":[{"titulo":"Mi Cesta","valor":"miCesta"}]}
	
	/**
	 * Inicializamos la variable de breadCrumb
	 */
	initBreadCrumb = function(nombreBC){
		var myBreadCrumb =[];
		st.establecerLocalVar(nombreBC,nbf.toJSON(myBreadCrumb),'never');
		anadirElemento(nombreBC,"inicio","Inicio");
	}
	
	/**
	 * Aadimos un elemento al breadCrumb
	 * Si pertenece a busqueda entonces el contenido de valor es un JSON con varios valores
	 * nivel,textoBusqueda,idCategoria
	 */
	anadirElemento =function(nombreBC,titulo,valor,tituloLargo){
		var bArray =[];
		bJSON = st.obtenerLocalVar(nombreBC);
		bArray = nbf.parseJSON(bJSON);
		var elem = [];
		if(titulo=="buscar")
			elem = [titulo,valor,"JSON"];
		else
			elem = [titulo,valor,tituloLargo];
		
		bArray.push(elem);
		st.establecerLocalVar(nombreBC,nbf.toJSON(bArray));
	}
	/**
	 * Quitamos un elemento del breadCrumb
	 */
	quitarElemento = function(nombreBC){
		var bArray =[];
		bJSON = st.obtenerLocalVar(nombreBC);
		bArray = nbf.parseJSON(bJSON);
		bArray.pop();
		st.establecerLocalVar(nombreBC,nbf.toJSON(bArray));
	}
	
	
	//al parecer no se usa esta funcion BORRAR
	obtenerBreadCrumb = function (nombreBC){
		bJSON = st.ObtenerLocalVar(nombreBC);
		bArray = nbf.parseJSON(bJSON);
		return bArray;
	}
	
	/**
	 * Cuando se hace click en algun elemento del arbol tenemos que recomponer
	 * el arbol de breadCrumb
	 */
	renovarArbol = function(nombreBC,nombre){
		//tenemos que ir quitando elementos hasta llegar al que nos pasan por parametro
		var bArray =[];
		var cont =0;
		var salir=false;
		var elem =[];
		while (cont<=10 && salir==false){
			bJSON = st.obtenerLocalVar(nombreBC);
			bArray = nbf.parseJSON(bJSON);
			elem=bArray.pop();
			if(elem[0]==nombre){
				salir=true;
			}
			else{
				quitarElemento(nombreBC);
			}
			cont+=1;
		}
	}
	
	/**
	 * subir en el arbol
	 * el parametro el la clave que se almacena en el breadCrumb para subir hasta ese punto
	 * 
	 */
	subirArbol = function(nombreBC,clave){
		//tenemos que ir quitando elementos hasta llegar al que nos pasan por parametro
		var bArray =[];
		var cont =0;
		var salir=false;
		var elem =[];
		
		while (cont<=10 && salir==false){
			bJSON = st.obtenerLocalVar(nombreBC);
			bArray = nbf.parseJSON(bJSON);
			elem=bArray.pop();
			if(elem[0]==clave){
				salir=true;
			}
			else{
				quitarElemento(nombreBC);
			}
			cont+=1;
		}
		
	}
	/**
	 * Sube en el arbol hasta el elemento anterior al que se pasa como parametro
	 */
	//funcion que no se utiliza BORRAR
	subirArbolAnteriorA = function(nombreBC,clave){
		subirArbol(nombreBC,clave);
		quitarElemento(nombreBC);
	}
	
	retrocederBreadCrumb = function(nombreBC){
		quitarElemento(nombreBC);
		elem=pintarBreadCrumb(nombreBC);
		var arrElem = {};
		
		if(elem!=null && elem[2]=="JSON"){
			arrElem = nbf.parseJSON(elem[1]);
			classContent="contentPrincipal";
			classContent +=" "+nbf.codificarDatoClass(arrElem[0]);
			classContent +=" "+nbf.codificarDatoClass(arrElem[1]);
			classContent +=" "+nbf.codificarDatoClass(arrElem[2]);
			if(elem[3])
				classContent +=" "+nbf.codificarDatoClass(arrElem[3]);
			if(elem[4])
				classContent +=" "+nbf.codificarDatoClass(arrElem[4]);
			classContent +=" buscar";
			
			$("#content").attr("class",classContent);
		}
		else{
			if(elem==null)
				arrElem="inicio";
			else
				arrElem = elem[0];
			
			switch(nombreBC){
				case "breadCrumbPrincipal":
					if(arrElem=="inicio")
						$("#content").attr("class","contentPrincipal");
					else
						$("#content").attr("class","contentPrincipal "+arrElem);
				break;
				case "breadCrumbDerecho":
					if(arrElem=="inicio"){
						$(".bloqueDerecho").attr("class","bloqueDerecho");
					}
					else{
						$(".bloqueDerecho").attr("class","bloqueDerecho "+arrElem);
					}
				break;
			}
		}
		switch(nombreBC){
			case "breadCrumbPrincipal":
				contenido.cargarPanelCentral(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}
				);
			break;
			case "breadCrumbDerecho":
				contenido.cargarBloqueDerecho(
						function(){
							var comienzo = new Date().getTime();
							ui.popup.iniciarPopupEspera(comienzo);
						},
						function(){
							ui.popup.cerrarPopupEspera();
						}
					);
			break;
		}
	}
	/**
	 * Funcion que pinta el ultimo elemento en el breadCrumb con posibilidad de volver atras e INICIO
	 */
	pintarBreadCrumb = function(nombreBC){
		var bArray =[];
		bJSON = st.obtenerLocalVar(nombreBC);
		bArray = nbf.parseJSON(bJSON);
		var txtBread ="";
		var totalElementos = bArray.length-1;
		var cont=0;
		if(totalElementos <=0){
			switch(nombreBC){
			case "breadCrumbPrincipal":
				$(".breadCrumbs.bcPrincipal").addClass("noActivo");
				contenido.cambiarClass($("#content"),"");	
			break;
			
			case "breadCrumbDerecho":
				
				$(".breadCrumbs.btnNivel").addClass("noActivo");
				contenido.cambiarClass($(".bloqueDerecho"),"");
			break;
				
			}
			
		}
		else{
			switch(nombreBC){
			case "breadCrumbPrincipal":
				$(".breadCrumbs.bcPrincipal").removeClass("noActivo");
			break;
			
			case "breadCrumbDerecho":
				$(".breadCrumbs.btnNivel").removeClass("noActivo");
			break;
				
			}
		
			var elem = bArray.pop();
			var textoElem ="";
			if(elem[2]=="JSON"){
				//estructura del json es nivel,textoBusqueda,idCategoria,nombreCategoria,tipoFiltro,idFiltro
				var arrElem = nbf.parseJSON(elem[1]);
				if(arrElem[3])
					if ($(window).width()>400)
						textoElem = arrElem[3]; // metemos el nombre de la categoria clicada
					else
						textoElem = arrElem[3].substring(0,20)+"...";
						
				else{
					if ($(window).width()>400)
						textoElem = arrElem[1]; //si no hay categoria entonces es la principal ponemos el txtoBusqueda
					else
						textoElem = arrElem[1].substring(0,20)+"...";
				}
			}
			else{
				if ($(window).width()>400)
					textoElem=(elem[2]==null?elem[1]:elem[2]);
				else{
					textoElem=elem[1];
					textoElem = textoElem.substring(0,23);
				}
			}
			
			
		}
		switch(nombreBC){
		case "breadCrumbPrincipal":
			txtBread +="<div class='btns'>";
			txtBread +="<a class='inicio' href='#'>inicio</a>";
			txtBread +="<a class='volver'' href='#'>volver</a>";
			txtBread +="</div>";
			txtBread +="<h2 class='titulo'>"+textoElem+"</h2>";
			txtBread +="</div>";
			$(".breadCrumbs.bcPrincipal").html(txtBread);
		break;
		
		case "breadCrumbDerecho":
			txtBread +="<div class='zpTitulo'>"+textoElem+"</div><div class='zpAtras'>Atrs</div>";
			$(".breadCrumbs.btnNivel").html(txtBread);
		break;
			
		}
		
	
		
		$(".breadCrumbs.bcPrincipal .btns .inicio").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				subirArbol("breadCrumbPrincipal","inicio");
				pintarBreadCrumb("breadCrumbPrincipal");
				$("#content").attr("class","contentPrincipal");
				nbf.initContenido();
			}
		);
		$(".breadCrumbs.bcPrincipal .btns .volver").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();	
				ui.vibracionCorta();
				retrocederBreadCrumb("breadCrumbPrincipal");
			}
		);
		
		$(".breadCrumbs.bcPrincipal .bc").click(
			function(ev){
				ev.preventDefault();
				if($(this).hasClass("inicio"))
					contenido.cambiarClass($("#content"),"");
				else
					alert("has pinchado en una opcion");
				
				renovarArbol("breadCrumbPrincipal",$(this).attr("class").split(' ').pop());
				nbf.initContenido();
			}
		);
		$(".breadCrumbs.btnNivel .zpAtras").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();	
				ui.vibracionCorta();
				var bd=$(this).closest(".bloqueDerecho"); 
				if(bd.hasClass("miListaCompra") || bd.hasClass("sueloComprar") || bd.hasClass("recetasCategorias"))
					swiper.moverSwiper(1);
				retrocederBreadCrumb("breadCrumbDerecho");
			}
		);
		return elem;
	}
	return {"initBreadCrumb":initBreadCrumb,"anadirElemento":anadirElemento,"pintarBreadCrumb":pintarBreadCrumb,"obtenerBreadCrumb":obtenerBreadCrumb,"retrocederBreadCrumb":retrocederBreadCrumb};	
}();