
// cada "x" ajusta el alto
setInterval(
	function(){
		establecerTamanos();
	},
	500
);

/**
 * Funcion que calcula el alto de la pagina para scroll entre las pantallas
 */
establecerTamanos =function(){
	try{
		var altoPagina = $(window).height();
		var nuevoAlto = altoPagina;
		var panelActivo=1;
		$(".swiper-slide-active,.swiper-container,.swiper-wrapper").each(
			function(){
				if($(this).height()!=nuevoAlto)
					$(this).height(nuevoAlto);
			}
		);
		var body =$("body");
		body.height(nuevoAlto);
		body.css("overflow-x","hidden");
		body.css("scroll","no");
	
		$("swiper-container").height(nuevoAlto);
		$(".swiper-wrapper").height(nuevoAlto);
		if($(".breadCrumbs.bcPrincipal.noActivo").size()>0)
			$(".contenidoPagina").height(nuevoAlto-40);
		else
			$(".contenidoPagina").height(nuevoAlto-40-40);
		
		$(".bloqueIzquierdo").height(nuevoAlto-40);
		if($(".breadCrumbs.btnNivel.noActivo").size()>0)
			$(".bloqueDerecho .contenidoInformacion").height(nuevoAlto-40);
		else
			$(".bloqueDerecho .contenidoInformacion").height(nuevoAlto-40-40);
	}
	catch(e){
		console.log(e);
	}
}
// impide desaparecer el header en el bottom de la pagina
	setInterval(
		function(){
			if($("body").hasClass("obs")==false && $(".popupModal").size()==0){
				if($("body").scrollTop()>0){
					$("body").scrollTop(0);
				}
			}
		},
		500
	);

// ajusta el scroll cuando el teclado esta activo
$(window).resize(
	function () {  
		establecerTamanos();
		//refrescamos los breadcrumbs por si el ancho cambia
		breadCrumbs.pintarBreadCrumb("breadCrumbPrincipal");
		breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
	}
);

//libreras para funcionalidad del header
var cabecera= function(){
	//contador de profundidad
	zIndex = 1000;
	
	// lanzar la busqueda de productos en el input del header
	lanzarBusqueda = function(jq){
		if(st.obtenerLocalVar("modoTrabajo")=="online"){
			var textoBuscar = jq.find(".cuadroBuscar input[name=inputBusqueda]").val();
			if(textoBuscar =="")
				$(".contentPrincipal").attr("class","contentPrincipal categoriasLista"); 
			else{
				var classTextoBuscar = nbf.codificarDatoClass(textoBuscar);
				var classNivel = nbf.codificarDatoClass("0");
				var catId = nbf.codificarDatoClass("");
				var cad =classNivel +" " +classTextoBuscar +" "+catId+" buscando";
				$(".contentPrincipal").attr("class","contentPrincipal "+cad); 
				st.establecerSesionVar("textoBuscar",textoBuscar);
				
				var elemJSON = [0,textoBuscar,"","","",""];
				breadCrumbs.anadirElemento("breadCrumbPrincipal","buscar",nbf.toJSON(elemJSON));
			}
			contenido.cargarPanelCentral(
					function(){
						var comienzo = new Date().getTime();
						ui.popup.iniciarPopupEspera(comienzo);
					},
					function(){
						ui.popup.cerrarPopupEspera();
					}
				);
		}
		else{
			ui.mensajeSinConexion();
		}
	}

	/**
	 * Funcion que establece las cabeceras dependiendo de las tres pantallas principales (Izquierda,Central,Derecha)
	 */
	cargarCabecera = function(jq){
		
		jq.find(".cuadroBuscar input[name=inputBusqueda]").change(
			function(e){
				if($(this).val().length>0){
					jq.find(".cuadroBuscar .vaciarInput").addClass("on");
				}
				else
					jq.find(".cuadroBuscar .vaciarInput").removeClass("on");
				
			}
		);
		jq.find(".cuadroBuscar .vaciarInput").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				jq.find(".cuadroBuscar input[name=inputBusqueda]").val("");
				$(this).removeClass("on");
			}
		);
		jq.find(".cuadroBuscar input[name=inputBusqueda]").keyup(
			function(e){
				if($(this).val().length>0){
					jq.find(".cuadroBuscar .vaciarInput").addClass("on");
				}
				else
					jq.find(".cuadroBuscar .vaciarInput").removeClass("on");
				
				if(e.keyCode==13){
					lanzarBusqueda(jq);
				}
			}
		);
		jq.find(".btnBuscar").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				lanzarBusqueda(jq);
			}
		);
		jq.find(".btnVaciarCarrito").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				if(st.obtenerLocalVar("modoTrabajo")=="offline"){
					ui.mensajeSinConexion();
				}
				else{
					ui.popup.crearConfirmar(
						"Quieres vaciar el carrito de la compra?",
						function(){
							var sessId = st.obtenerLocalVar("sessId");
							var idUsuario = st.obtenerLocalVar("idUsuario");
							carro.eliminarProductosAJAX();
							swiper.moverSwiper(1);
							$(".bloqueIzquierdo").attr("class","bloqueIzquierdo");
							contenido.cargarBloqueIzquierdo();
							contenido.cargarPanelCentral();
						},
						null,
						false,
						"Vaciar Carrito"
					);
				}
			}
		);
		//evento del boton verCarrito
		jq.find(".btnCarrito,.numElemCarro").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();	
				ui.vibracionCorta();
				
				if(st.obtenerLocalVar("modoTrabajo")=="offline"){
					ui.mensajeSinConexion();
				}
				else{
					swiper.moverSwiper(0);
				}
			}
		);
		//boton Menu
		jq.find(".btnMenu").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				if(st.obtenerLocalVar("modoTrabajo")=="offline"){
					ui.mensajeSinConexion();
				}
				else
					swiper.moverSwiper(2);
			}
		);
		//boton Atras (tanto el de la pant izq como la dcha
		jq.find(".btnAtras").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				swiper.moverSwiper(1); 
			}
		);
		//boton Pagar
		jq.find(".btnPagar").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				if(st.obtenerLocalVar("modoTrabajo")=="offline"){
					ui.mensajeSinConexion();
				}
				else{
					if($(".bloqueInformacion .contenidoBloque .productos").size()==0 && $(".procesoCompra").size()==0){
						ui.popup.crearAlerta("No tienes ningn producto en la cesta.",null,"popup2",false,"Carrito vaco");
					}
					else{
						contenido.cambiarClass($(".bloqueIzquierdo"),"cargarProcesoPagos");
						contenido.cargarBloqueIzquierdo(
							function(){
								var comienzo = new Date().getTime();
								ui.popup.iniciarPopupEspera(comienzo);
							},
							function(){
								ui.popup.cerrarPopupEspera();
							}				
						);
						nbf.initCesta();
					}
				}
			}
		);
		//boton Finalizar
		jq.find(".btnFinalizar").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				ui.popup.crearAlerta("Para finalizar el pedido, dirjete a www.tudespensa.com o llama gratis al telfono <em style='white-space:nowrap'>900 103 282</em>. Muchas gracias.",null,"popup2",false,"Finaliza el pedido");
			}
		);
	}

return {"cargarCabecera":cargarCabecera,"lanzarBusqueda":lanzarBusqueda};
}();

