var localTips = function(){
zIndex = 9999;

	/**
	 * Inicializamos la variable de localTips
	 */
	initLocalTips= function(){
		var myLocalTips =[];
		if(st.estadoLocalVar("localTips")==0){
			st.establecerLocalVar("localTips",nbf.toJSON(myLocalTips));
		}
	}
	/**
	 * Aadimos un elemento al localTips
	 * Vamos a incluir el class de la pagina a cargar y vemos si tenemos un item que mostrar y el estado (si ya ha 
	 * sido clickeado
	 * el valor sera bool (true si clickeado y false si no clickeado
	 * en el json tendremos el texto de informacion a mostrar.
	 * parametros
	 * className nombre de la clase a aadir
	 * indide
	 * sesion si es "sesion" lo almacenamos en sesion para que cuando vuelva a ejecutar la aplicacion salte de nuevo el mensaje
	 * si no se define se hace de forma local(localStorage) y no volvera a mostrarse el mensaje
	 */
	anadirElementoLocalTips =function(className,indice,sesion){
		if(sesion=="sesion"){
			//lo metemos en sesion
			var sArray =new Array();
			sJSON = sessionStorage.getItem("slocalTips");
			
			if(sJSON==null){
				sArray=[];
			}
			else{
				sArray =nbf.parseJSON(sJSON);
			}
			var elem = className +" indice"+indice;
			sArray.push(elem);
			sessionStorage.setItem("slocalTips",nbf.toJSON(sArray));
		}
		else{
			var bArray =new Array();
			bJSON = st.obtenerLocalVar("localTips");
			if(bJSON==null){
				bArray=[];
			}
			else{ 
				bArray = nbf.parseJSON(bJSON);
			}
			var elem= className +" indice"+indice;
			bArray.push(elem);
			st.establecerLocalVar("localTips",nbf.toJSON(bArray));
		}
	}
	/**
	 * Quitamos un elemento del localTips por el momento no se utiliza
	 */
	quitarElementoLocalTips = function(){
		var bArray =[];
		bJSON = st.obtenerLocalVar("localTips");
		bArray = nbf.parseJSON(bJSON);
		bArray.pop();
		st.establecerLocalVar("localTips",nbf.toJSON(bArray));
	}
	/**
	 * Busca un localTip dentro del conjunto
	 */
	buscarLocalTips = function(className,indice,sesion){
		if(sesion=="sesion"){
			var sArray =[];
			sJSON = sessionStorage.getItem("slocalTips");
			if(sJSON!=null){
				sArray = nbf.parseJSON(sJSON);
				var elem= className +" indice"+indice;
				var result= jQuery.inArray(elem,sArray);
				if(result==-1)
					return false;
				else
					return true;
			}
			else{
				return false;
			}
		}else{
			var bArray =[];
			bJSON = st.obtenerLocalVar("localTips");
			bArray = nbf.parseJSON(bJSON);
			var elem= className +" indice"+indice;
			var result= jQuery.inArray(elem,bArray);
			if(result==-1)
				return false;
			else
				return true;	
		}
		
	}
	/**
	 * Borra todos los posibles localtips almacenados para que vuelvan a saltar los mensajes de informacin
	 * 
	 */
	eliminarLocalTips =function(){
		st.eliminarLocalVar("localTips");
		sessionStorage.removeItem("slocalTips");
	}
	obtenerLocalTips = function (){
		bJSON = st.obtenerLocalVar("localTips");
		bArray = nbf.parseJSON(bJSON);
		return bArray;
	}
	
	formularioLocalTips =function(mensaje,className,indice,tituloTxt){
		var bloque = $("<div />");
		var botones = ui.popup.crearBotones("btnsAccion");
		bloque.addClass("c");
		bloque.append("<p class='mensaje'>"+mensaje+"</p>");
		bloque.append(botones);
		var popup = ui.popup.crear(bloque,"popupLocalTips popup2",false,"popupI","popupII");
		var titulo = popup.find(".btnsNav");
		titulo.append("<span class='titulo'>"+tituloTxt+"</span>");
		//aadimos botones
		botones.append(
			ui.popup.crearBoton(
				"No volver a mostrar",
				"Ok",
				function(){		
					ui.vibracionCorta();
					localTips.anadirElementoLocalTips(className,indice);
					ui.popup.ocultar(popup);
				}
			)
		);
		botones.append(
			ui.popup.crearBoton(
				"Solo ocultar",
				"No",
				function(){
					ui.vibracionCorta();
					//almacenamos en sesion el localtip para que vuelva a saltar cuando se arranque de nuevo la app
					localTips.anadirElementoLocalTips(className,indice,"sesion");
					ui.popup.ocultar(popup);
				}
				
			)
		);
	}
	
	formularioLocalTipsMultiple =function(mensajes,className,tituloTxt){
		var bloque = $("<div />");
		var botones = ui.popup.crearBotones("btnsAccion");
		bloque.addClass("c");
		bloque.append("<p class='mensaje'>"+mensajes[0]+"</p>");
		bloque.append(botones);
		var popup = ui.popup.crear(bloque,"popupAlerta popupLocalTips popup2",false,"popupI","popupII");
		var titulo = popup.find(".btnsNav");
		titulo.append("<span class='titulo'>"+tituloTxt+"</span>");
		//aadimos botones
		botones.append(
			ui.popup.crearBoton(
				"No volver a mostrar",
				"Ok",
				function(){		
					ui.vibracionCorta();
					localTips.anadirElementoLocalTips(className,indice);
					ui.popup.ocultar(popup);
				}
			)
		);
		botones.append(
			ui.popup.crearBoton(
				"solo ocultar",
				"No",
				function(){
					ui.vibracionCorta();
					localTips.anadirElementoLocalTips(className,indice,"sesion");
					ui.popup.ocultar(popup);
				}
				
			)
		);
	}
	
	cargarLocalTips=function(className,indice,mensaje,titulo){
		if(localTips.buscarLocalTips(className,indice)==false && localTips.buscarLocalTips(className,indice,"sesion")==false){
			localTips.formularioLocalTips(mensaje,className,indice,titulo);
		}
	}
	
	return {"initLocalTips":initLocalTips,"anadirElementoLocalTips":anadirElementoLocalTips,"obtenerLocalTips":obtenerLocalTips,"buscarLocalTips":buscarLocalTips,"eliminarLocalTips":eliminarLocalTips,"formularioLocalTips":formularioLocalTips,"cargarLocalTips":cargarLocalTips};	
}();